from typing import List
import ghidra.app.plugin
import ghidra.app.services
import ghidra.framework.model
import ghidra.framework.options
import ghidra.framework.plugintool
import ghidra.framework.plugintool.util
import ghidra.program.model.block
import ghidra.program.model.listing
import ghidra.program.util
import java.lang


class BlockModelServicePlugin(ghidra.app.plugin.ProgramPlugin, ghidra.app.services.BlockModelService, ghidra.framework.options.OptionsChangeListener):




    def __init__(self, __a0: ghidra.framework.plugintool.PluginTool): ...



    def acceptData(self, __a0: List[ghidra.framework.model.DomainFile]) -> bool: ...

    def addListener(self, __a0: ghidra.app.services.BlockModelServiceListener) -> None: ...

    def dataStateRestoreCompleted(self) -> None: ...

    def dependsUpon(self, __a0: ghidra.framework.plugintool.Plugin) -> bool: ...

    def equals(self, __a0: object) -> bool: ...

    def eventSent(self, __a0: ghidra.framework.plugintool.PluginEvent) -> None: ...

    def firePluginEvent(self, __a0: ghidra.framework.plugintool.PluginEvent) -> None: ...

    @overload
    def getActiveBlockModel(self) -> ghidra.program.model.block.CodeBlockModel: ...

    @overload
    def getActiveBlockModel(self, __a0: bool) -> ghidra.program.model.block.CodeBlockModel: ...

    @overload
    def getActiveBlockModel(self, __a0: ghidra.program.model.listing.Program) -> ghidra.program.model.block.CodeBlockModel: ...

    @overload
    def getActiveBlockModel(self, __a0: ghidra.program.model.listing.Program, __a1: bool) -> ghidra.program.model.block.CodeBlockModel: ...

    def getActiveBlockModelName(self) -> unicode: ...

    @overload
    def getActiveSubroutineModel(self) -> ghidra.program.model.block.CodeBlockModel: ...

    @overload
    def getActiveSubroutineModel(self, __a0: bool) -> ghidra.program.model.block.CodeBlockModel: ...

    @overload
    def getActiveSubroutineModel(self, __a0: ghidra.program.model.listing.Program) -> ghidra.program.model.block.CodeBlockModel: ...

    @overload
    def getActiveSubroutineModel(self, __a0: ghidra.program.model.listing.Program, __a1: bool) -> ghidra.program.model.block.CodeBlockModel: ...

    def getActiveSubroutineModelName(self) -> unicode: ...

    def getAvailableModelNames(self, __a0: int) -> List[unicode]: ...

    def getClass(self) -> java.lang.Class: ...

    def getCurrentProgram(self) -> ghidra.program.model.listing.Program: ...

    def getData(self) -> List[ghidra.framework.model.DomainFile]: ...

    def getMissingRequiredServices(self) -> List[object]: ...

    def getName(self) -> unicode: ...

    @overload
    def getNewModelByName(self, __a0: unicode) -> ghidra.program.model.block.CodeBlockModel: ...

    @overload
    def getNewModelByName(self, __a0: unicode, __a1: bool) -> ghidra.program.model.block.CodeBlockModel: ...

    @overload
    def getNewModelByName(self, __a0: unicode, __a1: ghidra.program.model.listing.Program) -> ghidra.program.model.block.CodeBlockModel: ...

    @overload
    def getNewModelByName(self, __a0: unicode, __a1: ghidra.program.model.listing.Program, __a2: bool) -> ghidra.program.model.block.CodeBlockModel: ...

    def getPluginDescription(self) -> ghidra.framework.plugintool.util.PluginDescription: ...

    def getProgramHighlight(self) -> ghidra.program.util.ProgramSelection: ...

    def getProgramLocation(self) -> ghidra.program.util.ProgramLocation: ...

    def getProgramSelection(self) -> ghidra.program.util.ProgramSelection: ...

    def getSupportedDataTypes(self) -> List[java.lang.Class]: ...

    def getTool(self) -> ghidra.framework.plugintool.PluginTool: ...

    def getTransientState(self) -> object: ...

    def getUndoRedoState(self, __a0: ghidra.framework.model.DomainObject) -> object: ...

    def hasMissingRequiredService(self) -> bool: ...

    def hashCode(self) -> int: ...

    def isDisposed(self) -> bool: ...

    def notify(self) -> None: ...

    def notifyAll(self) -> None: ...

    def optionsChanged(self, __a0: ghidra.framework.options.ToolOptions, __a1: unicode, __a2: object, __a3: object) -> None: ...

    def processEvent(self, __a0: ghidra.framework.plugintool.PluginEvent) -> None: ...

    def readConfigState(self, __a0: ghidra.framework.options.SaveState) -> None: ...

    def readDataState(self, __a0: ghidra.framework.options.SaveState) -> None: ...

    def registerModel(self, __a0: java.lang.Class, __a1: unicode) -> None: ...

    def removeListener(self, __a0: ghidra.app.services.BlockModelServiceListener) -> None: ...

    def restoreTransientState(self, __a0: object) -> None: ...

    def restoreUndoRedoState(self, __a0: ghidra.framework.model.DomainObject, __a1: object) -> None: ...

    def serviceAdded(self, __a0: java.lang.Class, __a1: object) -> None: ...

    def serviceRemoved(self, __a0: java.lang.Class, __a1: object) -> None: ...

    def toString(self) -> unicode: ...

    def unregisterModel(self, __a0: java.lang.Class) -> None: ...

    @overload
    def wait(self) -> None: ...

    @overload
    def wait(self, __a0: long) -> None: ...

    @overload
    def wait(self, __a0: long, __a1: int) -> None: ...

    def writeConfigState(self, __a0: ghidra.framework.options.SaveState) -> None: ...

    def writeDataState(self, __a0: ghidra.framework.options.SaveState) -> None: ...

    @property
    def activeBlockModel(self) -> ghidra.program.model.block.CodeBlockModel: ...

    @property
    def activeBlockModelName(self) -> unicode: ...

    @property
    def activeSubroutineModel(self) -> ghidra.program.model.block.CodeBlockModel: ...

    @property
    def activeSubroutineModelName(self) -> unicode: ...