from typing import List
import docking
import docking.action
import ghidra.app.plugin.core.compositeeditor
import ghidra.app.services
import ghidra.framework.plugintool
import ghidra.program.model.data
import ghidra.util
import java.awt.event
import java.lang
import javax.swing


class CompositeEditorProvider(ghidra.framework.plugintool.ComponentProviderAdapter, ghidra.app.plugin.core.compositeeditor.EditorProvider, ghidra.app.plugin.core.compositeeditor.EditorActionListener):








    def actionsAdded(self, __a0: List[ghidra.app.plugin.core.compositeeditor.CompositeEditorTableAction]) -> None: ...

    def actionsRemoved(self, __a0: List[ghidra.app.plugin.core.compositeeditor.CompositeEditorTableAction]) -> None: ...

    def addEditorListener(self, __a0: ghidra.app.plugin.core.compositeeditor.EditorListener) -> None: ...

    def addLocalAction(self, __a0: docking.action.DockingActionIf) -> None: ...

    def addToTool(self) -> None: ...

    def canBeParent(self) -> bool: ...

    def checkForSave(self, __a0: bool) -> bool: ...

    def closeComponent(self) -> None: ...

    def componentActivated(self) -> None: ...

    def componentDeactived(self) -> None: ...

    def componentHidden(self) -> None: ...

    def componentShown(self) -> None: ...

    def contextChanged(self) -> None: ...

    def dispose(self) -> None: ...

    def domainObjectRestored(self, __a0: ghidra.program.model.data.DataTypeManagerDomainObject) -> None: ...

    def equals(self, __a0: object) -> bool: ...

    def getActionContext(self, __a0: java.awt.event.MouseEvent) -> docking.ActionContext: ...

    def getClass(self) -> java.lang.Class: ...

    def getComponent(self) -> javax.swing.JComponent: ...

    def getComponentProvider(self) -> docking.ComponentProvider: ...

    def getContextType(self) -> java.lang.Class: ...

    def getDataTypeManager(self) -> ghidra.program.model.data.DataTypeManager: ...

    def getDefaultWindowPosition(self) -> docking.WindowPosition: ...

    def getDtPath(self) -> ghidra.program.model.data.DataTypePath: ...

    def getDtmService(self) -> ghidra.app.services.DataTypeManagerService: ...

    def getHelpInfo(self) -> unicode: ...

    def getHelpLocation(self) -> ghidra.util.HelpLocation: ...

    def getHelpName(self) -> unicode: ...

    def getHelpObject(self) -> object: ...

    def getHelpTopic(self) -> unicode: ...

    def getIcon(self) -> javax.swing.Icon: ...

    def getInstanceID(self) -> long: ...

    def getIntraGroupPosition(self) -> docking.WindowPosition: ...

    @staticmethod
    def getMappedName(__a0: unicode, __a1: unicode) -> unicode: ...

    @staticmethod
    def getMappedOwner(__a0: unicode, __a1: unicode) -> unicode: ...

    def getName(self) -> unicode: ...

    def getOwner(self) -> unicode: ...

    def getSubTitle(self) -> unicode: ...

    def getTabText(self) -> unicode: ...

    def getTable(self) -> javax.swing.JTable: ...

    def getTitle(self) -> unicode: ...

    def getTool(self) -> docking.Tool: ...

    def getWindowGroup(self) -> unicode: ...

    def getWindowSubMenuName(self) -> unicode: ...

    def hashCode(self) -> int: ...

    def isActive(self) -> bool: ...

    def isEditing(self, __a0: ghidra.program.model.data.DataTypePath) -> bool: ...

    def isFocusedProvider(self) -> bool: ...

    def isInTool(self) -> bool: ...

    def isSnapshot(self) -> bool: ...

    def isTransient(self) -> bool: ...

    def isVisible(self) -> bool: ...

    def needsSave(self) -> bool: ...

    def notify(self) -> None: ...

    def notifyAll(self) -> None: ...

    @staticmethod
    def registerProviderNameOwnerChange(__a0: unicode, __a1: unicode, __a2: unicode, __a3: unicode) -> None: ...

    def removeFromTool(self) -> None: ...

    def requestFocus(self) -> None: ...

    def setHelpLocation(self, __a0: ghidra.util.HelpLocation) -> None: ...

    def setIntraGroupPosition(self, __a0: docking.WindowPosition) -> None: ...

    def setSubTitle(self, __a0: unicode) -> None: ...

    def setTabText(self, __a0: unicode) -> None: ...

    def setTitle(self, __a0: unicode) -> None: ...

    def setVisible(self, __a0: bool) -> None: ...

    def show(self) -> None: ...

    def toFront(self) -> None: ...

    def toString(self) -> unicode: ...

    @overload
    def wait(self) -> None: ...

    @overload
    def wait(self, __a0: long) -> None: ...

    @overload
    def wait(self, __a0: long, __a1: int) -> None: ...

    @property
    def component(self) -> javax.swing.JComponent: ...

    @property
    def componentProvider(self) -> docking.ComponentProvider: ...

    @property
    def dataTypeManager(self) -> ghidra.program.model.data.DataTypeManager: ...

    @property
    def dtPath(self) -> ghidra.program.model.data.DataTypePath: ...

    @property
    def dtmService(self) -> ghidra.app.services.DataTypeManagerService: ...

    @property
    def helpLocation(self) -> ghidra.util.HelpLocation: ...

    @helpLocation.setter
    def helpLocation(self, value: ghidra.util.HelpLocation) -> None: ...

    @property
    def helpName(self) -> unicode: ...

    @property
    def helpTopic(self) -> unicode: ...

    @property
    def table(self) -> javax.swing.JTable: ...

    @property
    def transient(self) -> bool: ...

    @property
    def windowSubMenuName(self) -> unicode: ...