import docking
import docking.action
import ghidra.app.services
import ghidra.framework.options
import ghidra.framework.plugintool
import ghidra.program.model.address
import ghidra.program.model.listing
import ghidra.util
import java.awt.event
import java.io
import java.lang
import javax.swing


class ConsoleComponentProvider(ghidra.framework.plugintool.ComponentProviderAdapter, ghidra.app.services.ConsoleService, ghidra.framework.options.OptionsChangeListener):




    def __init__(self, __a0: ghidra.framework.plugintool.PluginTool, __a1: unicode): ...



    def addErrorMessage(self, __a0: unicode, __a1: unicode) -> None: ...

    def addException(self, __a0: unicode, __a1: java.lang.Exception) -> None: ...

    def addLocalAction(self, __a0: docking.action.DockingActionIf) -> None: ...

    def addMessage(self, __a0: unicode, __a1: unicode) -> None: ...

    def addToTool(self) -> None: ...

    def canBeParent(self) -> bool: ...

    def clearMessages(self) -> None: ...

    def closeComponent(self) -> None: ...

    def componentActivated(self) -> None: ...

    def componentDeactived(self) -> None: ...

    def componentHidden(self) -> None: ...

    def componentShown(self) -> None: ...

    def contextChanged(self) -> None: ...

    def equals(self, __a0: object) -> bool: ...

    def getActionContext(self, __a0: java.awt.event.MouseEvent) -> docking.ActionContext: ...

    def getClass(self) -> java.lang.Class: ...

    def getComponent(self) -> javax.swing.JComponent: ...

    def getContextType(self) -> java.lang.Class: ...

    def getDefaultWindowPosition(self) -> docking.WindowPosition: ...

    def getHelpInfo(self) -> unicode: ...

    def getHelpLocation(self) -> ghidra.util.HelpLocation: ...

    def getHelpObject(self) -> object: ...

    def getIcon(self) -> javax.swing.Icon: ...

    def getInstanceID(self) -> long: ...

    def getIntraGroupPosition(self) -> docking.WindowPosition: ...

    @staticmethod
    def getMappedName(__a0: unicode, __a1: unicode) -> unicode: ...

    @staticmethod
    def getMappedOwner(__a0: unicode, __a1: unicode) -> unicode: ...

    def getName(self) -> unicode: ...

    def getOwner(self) -> unicode: ...

    def getStdErr(self) -> java.io.PrintWriter: ...

    def getStdOut(self) -> java.io.PrintWriter: ...

    def getSubTitle(self) -> unicode: ...

    def getTabText(self) -> unicode: ...

    def getText(self, __a0: int, __a1: int) -> unicode: ...

    def getTextLength(self) -> int: ...

    def getTitle(self) -> unicode: ...

    def getTool(self) -> docking.Tool: ...

    def getWindowGroup(self) -> unicode: ...

    def getWindowSubMenuName(self) -> unicode: ...

    def hashCode(self) -> int: ...

    def isActive(self) -> bool: ...

    def isFocusedProvider(self) -> bool: ...

    def isInTool(self) -> bool: ...

    def isSnapshot(self) -> bool: ...

    def isTransient(self) -> bool: ...

    def isVisible(self) -> bool: ...

    def notify(self) -> None: ...

    def notifyAll(self) -> None: ...

    def optionsChanged(self, __a0: ghidra.framework.options.ToolOptions, __a1: unicode, __a2: object, __a3: object) -> None: ...

    def print(self, __a0: unicode) -> None: ...

    def printError(self, __a0: unicode) -> None: ...

    def println(self, __a0: unicode) -> None: ...

    def printlnError(self, __a0: unicode) -> None: ...

    @staticmethod
    def registerProviderNameOwnerChange(__a0: unicode, __a1: unicode, __a2: unicode, __a3: unicode) -> None: ...

    def removeFromTool(self) -> None: ...

    def requestFocus(self) -> None: ...

    def setCurrentAddress(self, __a0: ghidra.program.model.address.Address) -> None: ...

    def setCurrentProgram(self, __a0: ghidra.program.model.listing.Program) -> None: ...

    def setHelpLocation(self, __a0: ghidra.util.HelpLocation) -> None: ...

    def setIntraGroupPosition(self, __a0: docking.WindowPosition) -> None: ...

    def setSubTitle(self, __a0: unicode) -> None: ...

    def setTabText(self, __a0: unicode) -> None: ...

    def setTitle(self, __a0: unicode) -> None: ...

    def setVisible(self, __a0: bool) -> None: ...

    def toFront(self) -> None: ...

    def toString(self) -> unicode: ...

    @overload
    def wait(self) -> None: ...

    @overload
    def wait(self, __a0: long) -> None: ...

    @overload
    def wait(self, __a0: long, __a1: int) -> None: ...

    @property
    def component(self) -> javax.swing.JComponent: ...

    @property
    def currentAddress(self) -> None: ...  # No getter available.

    @currentAddress.setter
    def currentAddress(self, value: ghidra.program.model.address.Address) -> None: ...

    @property
    def currentProgram(self) -> None: ...  # No getter available.

    @currentProgram.setter
    def currentProgram(self, value: ghidra.program.model.listing.Program) -> None: ...

    @property
    def stdErr(self) -> java.io.PrintWriter: ...

    @property
    def stdOut(self) -> java.io.PrintWriter: ...

    @property
    def textLength(self) -> int: ...