import docking
import docking.action
import docking.widgets.table
import ghidra.app.services
import ghidra.framework.plugintool
import ghidra.program.model.address
import ghidra.program.model.listing
import ghidra.program.model.mem
import ghidra.program.util
import ghidra.trace.model.memory
import ghidra.trace.model.modules
import ghidra.util
import ghidra.util.table
import ghidra.util.task
import java.awt
import java.awt.event
import java.lang
import java.util
import javax.swing


class DebuggerBlockChooserDialog(docking.DialogComponentProvider):





    class MemoryBlockRow(object):








        def equals(self, __a0: object) -> bool: ...

        def getBlock(self) -> ghidra.program.model.mem.MemoryBlock: ...

        def getBlockName(self) -> unicode: ...

        def getClass(self) -> java.lang.Class: ...

        def getLength(self) -> long: ...

        def getMaxAddress(self) -> ghidra.program.model.address.Address: ...

        def getMinAddress(self) -> ghidra.program.model.address.Address: ...

        def getProgram(self) -> ghidra.program.model.listing.Program: ...

        def getProgramLocation(self) -> ghidra.program.util.ProgramLocation: ...

        def getProgramName(self) -> unicode: ...

        def getScore(self) -> float: ...

        def hashCode(self) -> int: ...

        def notify(self) -> None: ...

        def notifyAll(self) -> None: ...

        @overload
        def score(self, __a0: ghidra.trace.model.memory.TraceMemoryRegion, __a1: ghidra.app.services.DebuggerStaticMappingService) -> float: ...

        @overload
        def score(self, __a0: ghidra.trace.model.modules.TraceSection, __a1: ghidra.app.services.DebuggerStaticMappingService) -> float: ...

        def toString(self) -> unicode: ...

        @overload
        def wait(self) -> None: ...

        @overload
        def wait(self, __a0: long) -> None: ...

        @overload
        def wait(self, __a0: long, __a1: int) -> None: ...

        @property
        def block(self) -> ghidra.program.model.mem.MemoryBlock: ...

        @property
        def blockName(self) -> unicode: ...

        @property
        def length(self) -> long: ...

        @property
        def maxAddress(self) -> ghidra.program.model.address.Address: ...

        @property
        def minAddress(self) -> ghidra.program.model.address.Address: ...

        @property
        def program(self) -> ghidra.program.model.listing.Program: ...

        @property
        def programLocation(self) -> ghidra.program.util.ProgramLocation: ...

        @property
        def programName(self) -> unicode: ...

    def __init__(self, __a0: ghidra.framework.plugintool.PluginTool): ...



    def addAction(self, __a0: docking.action.DockingActionIf) -> None: ...

    @overload
    def chooseBlock(self, __a0: ghidra.framework.plugintool.PluginTool, __a1: ghidra.trace.model.memory.TraceMemoryRegion, __a2: java.util.Collection) -> java.util.Map.Entry: ...

    @overload
    def chooseBlock(self, __a0: ghidra.framework.plugintool.PluginTool, __a1: ghidra.trace.model.modules.TraceSection, __a2: java.util.Collection) -> java.util.Map.Entry: ...

    def clearStatusText(self) -> None: ...

    def close(self) -> None: ...

    def dispose(self) -> None: ...

    def equals(self, __a0: object) -> bool: ...

    def getActionContext(self, __a0: java.awt.event.MouseEvent) -> docking.ActionContext: ...

    def getActions(self) -> java.util.Set: ...

    def getBackground(self) -> java.awt.Color: ...

    def getChosen(self) -> java.util.Map.Entry: ...

    def getClass(self) -> java.lang.Class: ...

    def getComponent(self) -> javax.swing.JComponent: ...

    def getDefaultButton(self) -> javax.swing.JButton: ...

    def getDefaultSize(self) -> java.awt.Dimension: ...

    def getFocusComponent(self) -> java.awt.Component: ...

    def getHelpLocation(self) -> ghidra.util.HelpLocation: ...

    def getId(self) -> int: ...

    def getInitialLocation(self) -> java.awt.Point: ...

    def getPreferredSize(self) -> java.awt.Dimension: ...

    def getRememberLocation(self) -> bool: ...

    def getRememberSize(self) -> bool: ...

    def getStatusText(self) -> unicode: ...

    def getTableFilterPanel(self) -> ghidra.util.table.GhidraTableFilterPanel: ...

    def getTableModel(self) -> docking.widgets.table.EnumeratedColumnTableModel: ...

    def getTitle(self) -> unicode: ...

    def getUseSharedLocation(self) -> bool: ...

    def hashCode(self) -> int: ...

    def hideTaskMonitorComponent(self) -> None: ...

    def isModal(self) -> bool: ...

    def isResizeable(self) -> bool: ...

    def isRunningTask(self) -> bool: ...

    def isShowing(self) -> bool: ...

    def isTransient(self) -> bool: ...

    def isVisible(self) -> bool: ...

    def notify(self) -> None: ...

    def notifyAll(self) -> None: ...

    def removeAction(self, __a0: docking.action.DockingActionIf) -> None: ...

    def setBackground(self, __a0: java.awt.Color) -> None: ...

    def setCursor(self, __a0: java.awt.Cursor) -> None: ...

    def setDefaultButton(self, __a0: javax.swing.JButton) -> None: ...

    def setDefaultSize(self, __a0: int, __a1: int) -> None: ...

    def setFocusComponent(self, __a0: java.awt.Component) -> None: ...

    def setHelpLocation(self, __a0: ghidra.util.HelpLocation) -> None: ...

    def setInitialLocation(self, __a0: int, __a1: int) -> None: ...

    @overload
    def setMinimumSize(self, __a0: java.awt.Dimension) -> None: ...

    @overload
    def setMinimumSize(self, __a0: int, __a1: int) -> None: ...

    def setPreferredSize(self, __a0: int, __a1: int) -> None: ...

    def setRememberLocation(self, __a0: bool) -> None: ...

    def setRememberSize(self, __a0: bool) -> None: ...

    def setResizable(self, __a0: bool) -> None: ...

    def setStatusJustification(self, __a0: int) -> None: ...

    @overload
    def setStatusText(self, __a0: unicode) -> None: ...

    @overload
    def setStatusText(self, __a0: unicode, __a1: ghidra.util.MessageType) -> None: ...

    @overload
    def setStatusText(self, __a0: unicode, __a1: ghidra.util.MessageType, __a2: bool) -> None: ...

    def setTitle(self, __a0: unicode) -> None: ...

    def setTransient(self, __a0: bool) -> None: ...

    def setUseSharedLocation(self, __a0: bool) -> None: ...

    def showTaskMonitorComponent(self, __a0: unicode, __a1: bool, __a2: bool) -> ghidra.util.task.TaskMonitor: ...

    def taskCancelled(self, __a0: ghidra.util.task.Task) -> None: ...

    def taskCompleted(self, __a0: ghidra.util.task.Task) -> None: ...

    def toFront(self) -> None: ...

    def toString(self) -> unicode: ...

    @overload
    def wait(self) -> None: ...

    @overload
    def wait(self, __a0: long) -> None: ...

    @overload
    def wait(self, __a0: long, __a1: int) -> None: ...

    def waitForCurrentTask(self) -> None: ...

    @property
    def chosen(self) -> java.util.Map.Entry: ...

    @property
    def tableFilterPanel(self) -> ghidra.util.table.GhidraTableFilterPanel: ...

    @property
    def tableModel(self) -> docking.widgets.table.EnumeratedColumnTableModel: ...