from typing import List
import ghidra.app.plugin.core.debug
import ghidra.app.plugin.core.debug.gui.action
import ghidra.framework.plugintool
import ghidra.trace.model
import ghidra.trace.model.stack
import ghidra.trace.util
import java.lang
import java.util
import java.util.concurrent
import javax.swing


class NoneLocationTrackingSpec(java.lang.Enum, ghidra.app.plugin.core.debug.gui.action.LocationTrackingSpec, ghidra.app.plugin.core.debug.gui.action.LocationTracker):
    CONFIG_NAME: unicode = u'TRACK_NONE'
    INSTANCE: ghidra.app.plugin.core.debug.gui.action.NoneLocationTrackingSpec = INSTANCE







    def affectedByBytesChange(self, __a0: ghidra.trace.util.TraceAddressSpace, __a1: ghidra.trace.model.TraceAddressSnapRange, __a2: ghidra.app.plugin.core.debug.DebuggerCoordinates) -> bool: ...

    def affectedByStackChange(self, __a0: ghidra.trace.model.stack.TraceStack, __a1: ghidra.app.plugin.core.debug.DebuggerCoordinates) -> bool: ...

    @staticmethod
    def changeIsCurrent(__a0: ghidra.trace.util.TraceAddressSpace, __a1: ghidra.trace.model.TraceAddressSnapRange, __a2: ghidra.app.plugin.core.debug.DebuggerCoordinates) -> bool: ...

    @overload
    def compareTo(self, __a0: java.lang.Enum) -> int: ...

    @overload
    def compareTo(self, __a0: object) -> int: ...

    def computeTitle(self, __a0: ghidra.app.plugin.core.debug.DebuggerCoordinates) -> unicode: ...

    def computeTraceAddress(self, __a0: ghidra.framework.plugintool.PluginTool, __a1: ghidra.app.plugin.core.debug.DebuggerCoordinates) -> java.util.concurrent.CompletableFuture: ...

    def describeConstable(self) -> java.util.Optional: ...

    def equals(self, __a0: object) -> bool: ...

    def getClass(self) -> java.lang.Class: ...

    def getConfigName(self) -> unicode: ...

    def getDeclaringClass(self) -> java.lang.Class: ...

    def getMenuIcon(self) -> javax.swing.Icon: ...

    def getMenuName(self) -> unicode: ...

    def getTracker(self) -> ghidra.app.plugin.core.debug.gui.action.LocationTracker: ...

    def hashCode(self) -> int: ...

    def name(self) -> unicode: ...

    def notify(self) -> None: ...

    def notifyAll(self) -> None: ...

    def ordinal(self) -> int: ...

    def toString(self) -> unicode: ...

    @overload
    @staticmethod
    def valueOf(__a0: unicode) -> ghidra.app.plugin.core.debug.gui.action.NoneLocationTrackingSpec: ...

    @overload
    @staticmethod
    def valueOf(__a0: java.lang.Class, __a1: unicode) -> java.lang.Enum: ...

    @staticmethod
    def values() -> List[ghidra.app.plugin.core.debug.gui.action.NoneLocationTrackingSpec]: ...

    @overload
    def wait(self) -> None: ...

    @overload
    def wait(self, __a0: long) -> None: ...

    @overload
    def wait(self, __a0: long, __a1: int) -> None: ...

    @property
    def configName(self) -> unicode: ...

    @property
    def menuIcon(self) -> javax.swing.Icon: ...

    @property
    def menuName(self) -> unicode: ...

    @property
    def tracker(self) -> ghidra.app.plugin.core.debug.gui.action.LocationTracker: ...