from typing import List
import ghidra.app.plugin.core.debug.mapping
import ghidra.app.plugin.core.debug.service.model
import ghidra.app.plugin.core.debug.service.model.interfaces
import ghidra.app.services
import ghidra.dbg.target
import ghidra.program.model.address
import ghidra.program.model.lang
import ghidra.trace.model
import ghidra.trace.model.breakpoint
import ghidra.trace.model.guest
import ghidra.trace.model.memory
import ghidra.trace.model.modules
import ghidra.trace.model.stack
import ghidra.trace.model.thread
import ghidra.trace.model.time
import ghidra.util.datastruct
import ghidra.util.task
import java.lang
import java.util
import java.util.concurrent


class DefaultTraceRecorder(object, ghidra.app.services.TraceRecorder):




    def __init__(self, __a0: ghidra.app.plugin.core.debug.service.model.DebuggerModelServicePlugin, __a1: ghidra.trace.model.Trace, __a2: ghidra.dbg.target.TargetObject, __a3: ghidra.app.plugin.core.debug.mapping.DefaultDebuggerTargetTraceMapper): ...



    def addListener(self, __a0: ghidra.app.services.TraceRecorderListener) -> None: ...

    @overload
    def captureDataTypes(self, __a0: ghidra.dbg.target.TargetDataTypeNamespace, __a1: ghidra.util.task.TaskMonitor) -> java.util.concurrent.CompletableFuture: ...

    @overload
    def captureDataTypes(self, __a0: ghidra.trace.model.modules.TraceModule, __a1: ghidra.util.task.TaskMonitor) -> java.util.concurrent.CompletableFuture: ...

    @overload
    def captureSymbols(self, __a0: ghidra.dbg.target.TargetSymbolNamespace, __a1: ghidra.util.task.TaskMonitor) -> java.util.concurrent.CompletableFuture: ...

    @overload
    def captureSymbols(self, __a0: ghidra.trace.model.modules.TraceModule, __a1: ghidra.util.task.TaskMonitor) -> java.util.concurrent.CompletableFuture: ...

    def captureThreadRegisters(self, __a0: ghidra.trace.model.guest.TracePlatform, __a1: ghidra.trace.model.thread.TraceThread, __a2: int, __a3: java.util.Set) -> java.util.concurrent.CompletableFuture: ...

    def collectBreakpointContainers(self, __a0: ghidra.dbg.target.TargetThread) -> List[object]: ...

    def collectBreakpoints(self, __a0: ghidra.dbg.target.TargetThread) -> List[object]: ...

    def computeIfAbsent(self, __a0: ghidra.dbg.target.TargetThread) -> ghidra.app.plugin.core.debug.service.model.interfaces.ManagedThreadRecorder: ...

    def createSnapshot(self, __a0: unicode, __a1: ghidra.trace.model.thread.TraceThread, __a2: ghidra.app.plugin.core.debug.service.model.RecorderPermanentTransaction) -> None: ...

    def createTraceThread(self, __a0: ghidra.dbg.target.TargetThread) -> ghidra.trace.model.thread.TraceThread: ...

    def equals(self, __a0: object) -> bool: ...

    def flushTransactions(self) -> java.util.concurrent.CompletableFuture: ...

    def forceSnapshot(self) -> ghidra.trace.model.time.TraceSnapshot: ...

    def getAccessibleMemory(self) -> ghidra.program.model.address.AddressSetView: ...

    def getClass(self) -> java.lang.Class: ...

    def getFocus(self) -> ghidra.dbg.target.TargetObject: ...

    def getListeners(self) -> ghidra.util.datastruct.ListenerSet: ...

    def getLiveTargetThreads(self) -> java.util.Set: ...

    def getMemoryMapper(self) -> ghidra.app.plugin.core.debug.mapping.DebuggerMemoryMapper: ...

    def getProcessMemory(self) -> ghidra.app.plugin.core.debug.service.model.interfaces.AbstractRecorderMemory: ...

    def getRegisterMapper(self, __a0: ghidra.trace.model.thread.TraceThread) -> ghidra.app.plugin.core.debug.mapping.DebuggerRegisterMapper: ...

    def getSnap(self) -> long: ...

    def getSnapshot(self) -> ghidra.trace.model.time.TraceSnapshot: ...

    def getSupportedBreakpointKinds(self) -> java.util.Set: ...

    def getTarget(self) -> ghidra.dbg.target.TargetObject: ...

    def getTargetBreakpoint(self, __a0: ghidra.trace.model.breakpoint.TraceBreakpoint) -> ghidra.dbg.target.TargetBreakpointLocation: ...

    def getTargetMemoryRegion(self, __a0: ghidra.trace.model.memory.TraceMemoryRegion) -> ghidra.dbg.target.TargetMemoryRegion: ...

    def getTargetModule(self, __a0: ghidra.trace.model.modules.TraceModule) -> ghidra.dbg.target.TargetModule: ...

    def getTargetRegisterBank(self, __a0: ghidra.trace.model.thread.TraceThread, __a1: int) -> ghidra.dbg.target.TargetRegisterBank: ...

    def getTargetSection(self, __a0: ghidra.trace.model.modules.TraceSection) -> ghidra.dbg.target.TargetSection: ...

    def getTargetStackFrame(self, __a0: ghidra.trace.model.thread.TraceThread, __a1: int) -> ghidra.dbg.target.TargetStackFrame: ...

    def getTargetThread(self, __a0: ghidra.trace.model.thread.TraceThread) -> ghidra.dbg.target.TargetThread: ...

    @overload
    def getTargetThreadState(self, __a0: ghidra.dbg.target.TargetThread) -> ghidra.dbg.target.TargetExecutionStateful.TargetExecutionState: ...

    @overload
    def getTargetThreadState(self, __a0: ghidra.trace.model.thread.TraceThread) -> ghidra.dbg.target.TargetExecutionStateful.TargetExecutionState: ...

    def getThreadMap(self) -> ghidra.app.plugin.core.debug.service.model.RecorderThreadMap: ...

    @overload
    def getThreadRecorder(self, __a0: ghidra.dbg.target.TargetThread) -> ghidra.app.plugin.core.debug.service.model.interfaces.ManagedThreadRecorder: ...

    @overload
    def getThreadRecorder(self, __a0: ghidra.trace.model.thread.TraceThread) -> ghidra.app.plugin.core.debug.service.model.DefaultThreadRecorder: ...

    def getThreadRecorderForSuccessor(self, __a0: ghidra.dbg.target.TargetObject) -> ghidra.app.plugin.core.debug.service.model.interfaces.ManagedThreadRecorder: ...

    def getThreadsView(self) -> java.util.Set: ...

    def getTrace(self) -> ghidra.trace.model.Trace: ...

    def getTraceBreakpoint(self, __a0: ghidra.dbg.target.TargetBreakpointLocation) -> ghidra.trace.model.breakpoint.TraceBreakpoint: ...

    def getTraceMemoryRegion(self, __a0: ghidra.dbg.target.TargetMemoryRegion) -> ghidra.trace.model.memory.TraceMemoryRegion: ...

    def getTraceModule(self, __a0: ghidra.dbg.target.TargetModule) -> ghidra.trace.model.modules.TraceModule: ...

    def getTraceSection(self, __a0: ghidra.dbg.target.TargetSection) -> ghidra.trace.model.modules.TraceSection: ...

    def getTraceStackFrame(self, __a0: ghidra.dbg.target.TargetStackFrame) -> ghidra.trace.model.stack.TraceStackFrame: ...

    def getTraceStackFrameForSuccessor(self, __a0: ghidra.dbg.target.TargetObject) -> ghidra.trace.model.stack.TraceStackFrame: ...

    def getTraceThread(self, __a0: ghidra.dbg.target.TargetThread) -> ghidra.trace.model.thread.TraceThread: ...

    def getTraceThreadForSuccessor(self, __a0: ghidra.dbg.target.TargetObject) -> ghidra.trace.model.thread.TraceThread: ...

    def hashCode(self) -> int: ...

    def init(self) -> java.util.concurrent.CompletableFuture: ...

    def isMemoryOnTarget(self, __a0: ghidra.program.model.address.Address) -> bool: ...

    def isRecording(self) -> bool: ...

    @overload
    def isRegisterBankAccessible(self, __a0: ghidra.dbg.target.TargetRegisterBank) -> bool: ...

    @overload
    def isRegisterBankAccessible(self, __a0: ghidra.trace.model.thread.TraceThread, __a1: int) -> bool: ...

    def isRegisterOnTarget(self, __a0: ghidra.trace.model.thread.TraceThread, __a1: ghidra.program.model.lang.Register) -> bool: ...

    def isSupportsFocus(self) -> bool: ...

    def isVariableOnTarget(self, __a0: ghidra.trace.model.thread.TraceThread, __a1: ghidra.program.model.address.Address, __a2: int) -> bool: ...

    def notify(self) -> None: ...

    def notifyAll(self) -> None: ...

    def readMemory(self, __a0: ghidra.program.model.address.Address, __a1: int) -> java.util.concurrent.CompletableFuture: ...

    def readMemoryBlocks(self, __a0: ghidra.program.model.address.AddressSetView, __a1: ghidra.util.task.TaskMonitor) -> java.util.concurrent.CompletableFuture: ...

    def removeListener(self, __a0: ghidra.app.services.TraceRecorderListener) -> None: ...

    def requestFocus(self, __a0: ghidra.dbg.target.TargetObject) -> java.util.concurrent.CompletableFuture: ...

    def setCurrentFocus(self, __a0: ghidra.dbg.target.TargetObject) -> None: ...

    def stopRecording(self) -> None: ...

    @staticmethod
    def targetToTraceBreakpointKind(__a0: ghidra.dbg.target.TargetBreakpointSpec.TargetBreakpointKind) -> ghidra.trace.model.breakpoint.TraceBreakpointKind: ...

    @staticmethod
    def targetToTraceBreakpointKinds(__a0: java.util.Collection) -> java.util.Set: ...

    def toString(self) -> unicode: ...

    @staticmethod
    def traceToTargetBreakpointKind(__a0: ghidra.trace.model.breakpoint.TraceBreakpointKind) -> ghidra.dbg.target.TargetBreakpointSpec.TargetBreakpointKind: ...

    @staticmethod
    def traceToTargetBreakpointKinds(__a0: java.util.Collection) -> java.util.Set: ...

    @overload
    def wait(self) -> None: ...

    @overload
    def wait(self, __a0: long) -> None: ...

    @overload
    def wait(self, __a0: long, __a1: int) -> None: ...

    def writeMemory(self, __a0: ghidra.program.model.address.Address, __a1: List[int]) -> java.util.concurrent.CompletableFuture: ...

    def writeRegister(self, __a0: ghidra.trace.model.guest.TracePlatform, __a1: ghidra.trace.model.thread.TraceThread, __a2: int, __a3: ghidra.program.model.address.Address, __a4: List[int]) -> java.util.concurrent.CompletableFuture: ...

    def writeThreadRegisters(self, __a0: ghidra.trace.model.guest.TracePlatform, __a1: ghidra.trace.model.thread.TraceThread, __a2: int, __a3: java.util.Map) -> java.util.concurrent.CompletableFuture: ...

    def writeVariable(self, __a0: ghidra.trace.model.guest.TracePlatform, __a1: ghidra.trace.model.thread.TraceThread, __a2: int, __a3: ghidra.program.model.address.Address, __a4: List[int]) -> java.util.concurrent.CompletableFuture: ...

    @property
    def accessibleMemory(self) -> ghidra.program.model.address.AddressSetView: ...

    @property
    def currentFocus(self) -> None: ...  # No getter available.

    @currentFocus.setter
    def currentFocus(self, value: ghidra.dbg.target.TargetObject) -> None: ...

    @property
    def focus(self) -> ghidra.dbg.target.TargetObject: ...

    @property
    def listeners(self) -> ghidra.util.datastruct.ListenerSet: ...

    @property
    def liveTargetThreads(self) -> java.util.Set: ...

    @property
    def memoryMapper(self) -> ghidra.app.plugin.core.debug.mapping.DebuggerMemoryMapper: ...

    @property
    def processMemory(self) -> ghidra.app.plugin.core.debug.service.model.interfaces.AbstractRecorderMemory: ...

    @property
    def recording(self) -> bool: ...

    @property
    def snap(self) -> long: ...

    @property
    def snapshot(self) -> ghidra.trace.model.time.TraceSnapshot: ...

    @property
    def supportedBreakpointKinds(self) -> java.util.Set: ...

    @property
    def supportsFocus(self) -> bool: ...

    @property
    def target(self) -> ghidra.dbg.target.TargetObject: ...

    @property
    def threadMap(self) -> ghidra.app.plugin.core.debug.service.model.RecorderThreadMap: ...

    @property
    def threadsView(self) -> java.util.Set: ...

    @property
    def trace(self) -> ghidra.trace.model.Trace: ...