import docking
import docking.action
import ghidra.app.decompiler
import ghidra.app.plugin.core.decompile.actions
import ghidra.app.util.datatype
import ghidra.program.model.data
import ghidra.program.model.pcode
import ghidra.util
import ghidra.util.task
import java.awt
import java.awt.event
import java.beans
import java.lang
import java.util
import java.util.function
import javax.swing


class CreatePointerRelative(ghidra.app.plugin.core.decompile.actions.RetypeLocalAction):





    class RelativePointerDialog(ghidra.app.util.datatype.DataTypeSelectionDialog):




        def __init__(self, __a0: ghidra.app.plugin.core.decompile.actions.CreatePointerRelative, __a1: ghidra.framework.plugintool.PluginTool, __a2: ghidra.program.model.listing.Program): ...



        def addAction(self, __a0: docking.action.DockingActionIf) -> None: ...

        def clearStatusText(self) -> None: ...

        def clearUserChosenDataType(self) -> None: ...

        def close(self) -> None: ...

        def dispose(self) -> None: ...

        def equals(self, __a0: object) -> bool: ...

        def getActionContext(self, __a0: java.awt.event.MouseEvent) -> docking.ActionContext: ...

        def getActions(self) -> java.util.Set: ...

        def getBackground(self) -> java.awt.Color: ...

        def getClass(self) -> java.lang.Class: ...

        def getComponent(self) -> javax.swing.JComponent: ...

        def getDefaultButton(self) -> javax.swing.JButton: ...

        def getDefaultSize(self) -> java.awt.Dimension: ...

        def getEditor(self) -> ghidra.app.util.datatype.DataTypeSelectionEditor: ...

        def getFocusComponent(self) -> java.awt.Component: ...

        def getHelpLocation(self) -> ghidra.util.HelpLocation: ...

        def getId(self) -> int: ...

        def getInitialLocation(self) -> java.awt.Point: ...

        def getPreferredSize(self) -> java.awt.Dimension: ...

        def getRememberLocation(self) -> bool: ...

        def getRememberSize(self) -> bool: ...

        def getStatusText(self) -> unicode: ...

        def getTitle(self) -> unicode: ...

        def getUseSharedLocation(self) -> bool: ...

        def getUserChosenDataType(self) -> ghidra.program.model.data.DataType: ...

        def hashCode(self) -> int: ...

        def hideTaskMonitorComponent(self) -> None: ...

        def isModal(self) -> bool: ...

        def isResizeable(self) -> bool: ...

        def isRunningTask(self) -> bool: ...

        def isShowing(self) -> bool: ...

        def isTransient(self) -> bool: ...

        def isVisible(self) -> bool: ...

        def notify(self) -> None: ...

        def notifyAll(self) -> None: ...

        def removeAction(self, __a0: docking.action.DockingActionIf) -> None: ...

        def setBackground(self, __a0: java.awt.Color) -> None: ...

        def setCursor(self, __a0: java.awt.Cursor) -> None: ...

        def setDefaultButton(self, __a0: javax.swing.JButton) -> None: ...

        def setDefaultSize(self, __a0: int, __a1: int) -> None: ...

        def setFocusComponent(self, __a0: java.awt.Component) -> None: ...

        def setHelpLocation(self, __a0: ghidra.util.HelpLocation) -> None: ...

        def setInitialDataType(self, __a0: ghidra.program.model.data.DataType) -> None: ...

        def setInitialLocation(self, __a0: int, __a1: int) -> None: ...

        def setInitialName(self, __a0: unicode) -> None: ...

        def setInitialOffset(self, __a0: int) -> None: ...

        @overload
        def setMinimumSize(self, __a0: java.awt.Dimension) -> None: ...

        @overload
        def setMinimumSize(self, __a0: int, __a1: int) -> None: ...

        def setPreferredSize(self, __a0: int, __a1: int) -> None: ...

        def setRememberLocation(self, __a0: bool) -> None: ...

        def setRememberSize(self, __a0: bool) -> None: ...

        def setResizable(self, __a0: bool) -> None: ...

        def setStatusJustification(self, __a0: int) -> None: ...

        @overload
        def setStatusText(self, __a0: unicode) -> None: ...

        @overload
        def setStatusText(self, __a0: unicode, __a1: ghidra.util.MessageType) -> None: ...

        @overload
        def setStatusText(self, __a0: unicode, __a1: ghidra.util.MessageType, __a2: bool) -> None: ...

        def setTabCommitsEdit(self, __a0: bool) -> None: ...

        def setTitle(self, __a0: unicode) -> None: ...

        def setTransient(self, __a0: bool) -> None: ...

        def setUseSharedLocation(self, __a0: bool) -> None: ...

        def showTaskMonitorComponent(self, __a0: unicode, __a1: bool, __a2: bool) -> ghidra.util.task.TaskMonitor: ...

        def taskCancelled(self, __a0: ghidra.util.task.Task) -> None: ...

        def taskCompleted(self, __a0: ghidra.util.task.Task) -> None: ...

        def toFront(self) -> None: ...

        def toString(self) -> unicode: ...

        @overload
        def wait(self) -> None: ...

        @overload
        def wait(self, __a0: long) -> None: ...

        @overload
        def wait(self, __a0: long, __a1: int) -> None: ...

        def waitForCurrentTask(self) -> None: ...

        @property
        def initialName(self) -> None: ...  # No getter available.

        @initialName.setter
        def initialName(self, value: unicode) -> None: ...

        @property
        def initialOffset(self) -> None: ...  # No getter available.

        @initialOffset.setter
        def initialOffset(self, value: int) -> None: ...

    def __init__(self): ...



    def actionPerformed(self, __a0: docking.ActionContext) -> None: ...

    def addPropertyChangeListener(self, __a0: java.beans.PropertyChangeListener) -> None: ...

    def addToWindowWhen(self, __a0: java.lang.Class) -> None: ...

    @staticmethod
    def buildDefaultName(__a0: ghidra.program.model.data.DataType, __a1: int) -> unicode: ...

    def createButton(self) -> javax.swing.JButton: ...

    def createMenuItem(self, __a0: bool) -> javax.swing.JMenuItem: ...

    def dispose(self) -> None: ...

    def enabledWhen(self, __a0: java.util.function.Predicate) -> None: ...

    def equals(self, __a0: object) -> bool: ...

    @staticmethod
    def findHighSymbolFromToken(__a0: ghidra.app.decompiler.ClangToken, __a1: ghidra.program.model.pcode.HighFunction) -> ghidra.program.model.pcode.HighSymbol: ...

    def firePropertyChanged(self, __a0: unicode, __a1: object, __a2: object) -> None: ...

    def getClass(self) -> java.lang.Class: ...

    @staticmethod
    def getCompositeDataType(__a0: ghidra.app.decompiler.ClangToken) -> ghidra.program.model.data.Composite: ...

    def getDefaultKeyBindingData(self) -> docking.action.KeyBindingData: ...

    def getDescription(self) -> unicode: ...

    def getFullName(self) -> unicode: ...

    def getHelpInfo(self) -> unicode: ...

    def getHelpLocation(self) -> ghidra.util.HelpLocation: ...

    def getHelpObject(self) -> object: ...

    def getInceptionInformation(self) -> unicode: ...

    def getKeyBinding(self) -> javax.swing.KeyStroke: ...

    def getKeyBindingData(self) -> docking.action.KeyBindingData: ...

    def getKeyBindingType(self) -> docking.action.KeyBindingType: ...

    def getMenuBarData(self) -> docking.action.MenuData: ...

    def getName(self) -> unicode: ...

    def getOwner(self) -> unicode: ...

    def getOwnerDescription(self) -> unicode: ...

    def getPopupMenuData(self) -> docking.action.MenuData: ...

    def getToolBarData(self) -> docking.action.ToolBarData: ...

    def hashCode(self) -> int: ...

    def isAddToPopup(self, __a0: docking.ActionContext) -> bool: ...

    def isEnabled(self) -> bool: ...

    def isEnabledForContext(self, __a0: docking.ActionContext) -> bool: ...

    def isValidContext(self, __a0: docking.ActionContext) -> bool: ...

    def markHelpUnnecessary(self) -> None: ...

    def notify(self) -> None: ...

    def notifyAll(self) -> None: ...

    def popupWhen(self, __a0: java.util.function.Predicate) -> None: ...

    def removePropertyChangeListener(self, __a0: java.beans.PropertyChangeListener) -> None: ...

    def setAddToAllWindows(self, __a0: bool) -> None: ...

    def setDescription(self, __a0: unicode) -> None: ...

    def setEnabled(self, __a0: bool) -> None: ...

    def setHelpLocation(self, __a0: ghidra.util.HelpLocation) -> None: ...

    def setKeyBindingData(self, __a0: docking.action.KeyBindingData) -> None: ...

    def setMenuBarData(self, __a0: docking.action.MenuData) -> None: ...

    def setPopupMenuData(self, __a0: docking.action.MenuData) -> None: ...

    def setSupportsDefaultToolContext(self, __a0: bool) -> None: ...

    def setToolBarData(self, __a0: docking.action.ToolBarData) -> None: ...

    def setUnvalidatedKeyBindingData(self, __a0: docking.action.KeyBindingData) -> None: ...

    def shouldAddToWindow(self, __a0: bool, __a1: java.util.Set) -> bool: ...

    def supportsDefaultToolContext(self) -> bool: ...

    def toString(self) -> unicode: ...

    def validContextWhen(self, __a0: java.util.function.Predicate) -> None: ...

    @overload
    def wait(self) -> None: ...

    @overload
    def wait(self, __a0: long) -> None: ...

    @overload
    def wait(self, __a0: long, __a1: int) -> None: ...

