from typing import List
import ghidra.app.services
import ghidra.framework.model
import ghidra.program.model.address
import ghidra.program.model.listing
import java.awt
import java.lang
import java.net


class DiffProgramManager(object, ghidra.app.services.ProgramManager):
    OPEN_CURRENT: int = 1
    OPEN_HIDDEN: int = 0
    OPEN_VISIBLE: int = 2



    def __init__(self, __a0: ghidra.app.plugin.core.diff.ProgramDiffPlugin): ...



    def closeAllPrograms(self, __a0: bool) -> bool: ...

    def closeOtherPrograms(self, __a0: bool) -> bool: ...

    @overload
    def closeProgram(self) -> bool: ...

    @overload
    def closeProgram(self, __a0: ghidra.program.model.listing.Program, __a1: bool) -> bool: ...

    def equals(self, __a0: object) -> bool: ...

    def getAllOpenPrograms(self) -> List[ghidra.program.model.listing.Program]: ...

    def getClass(self) -> java.lang.Class: ...

    def getCurrentProgram(self) -> ghidra.program.model.listing.Program: ...

    def getProgram(self, __a0: ghidra.program.model.address.Address) -> ghidra.program.model.listing.Program: ...

    def hashCode(self) -> int: ...

    def isLocked(self) -> bool: ...

    def isVisible(self, __a0: ghidra.program.model.listing.Program) -> bool: ...

    def lockDown(self, __a0: bool) -> None: ...

    def notify(self) -> None: ...

    def notifyAll(self) -> None: ...

    @overload
    def openProgram(self, __a0: ghidra.framework.model.DomainFile) -> ghidra.program.model.listing.Program: ...

    @overload
    def openProgram(self, __a0: ghidra.program.model.listing.Program) -> None: ...

    @overload
    def openProgram(self, __a0: ghidra.framework.model.DomainFile, __a1: int) -> ghidra.program.model.listing.Program: ...

    @overload
    def openProgram(self, __a0: ghidra.program.model.listing.Program, __a1: int) -> None: ...

    @overload
    def openProgram(self, __a0: java.net.URL, __a1: int) -> ghidra.program.model.listing.Program: ...

    @overload
    def openProgram(self, __a0: ghidra.program.model.listing.Program, __a1: bool) -> None: ...

    @overload
    def openProgram(self, __a0: ghidra.framework.model.DomainFile, __a1: java.awt.Component) -> ghidra.program.model.listing.Program: ...

    @overload
    def openProgram(self, __a0: ghidra.framework.model.DomainFile, __a1: int, __a2: int) -> ghidra.program.model.listing.Program: ...

    def releaseProgram(self, __a0: ghidra.program.model.listing.Program, __a1: object) -> None: ...

    @overload
    def saveProgram(self) -> None: ...

    @overload
    def saveProgram(self, __a0: ghidra.program.model.listing.Program) -> None: ...

    @overload
    def saveProgramAs(self) -> None: ...

    @overload
    def saveProgramAs(self, __a0: ghidra.program.model.listing.Program) -> None: ...

    def setCurrentProgram(self, __a0: ghidra.program.model.listing.Program) -> None: ...

    def setPersistentOwner(self, __a0: ghidra.program.model.listing.Program, __a1: object) -> bool: ...

    def toString(self) -> unicode: ...

    @overload
    def wait(self) -> None: ...

    @overload
    def wait(self, __a0: long) -> None: ...

    @overload
    def wait(self, __a0: long, __a1: int) -> None: ...

    @property
    def allOpenPrograms(self) -> List[ghidra.program.model.listing.Program]: ...

    @property
    def currentProgram(self) -> ghidra.program.model.listing.Program: ...

    @currentProgram.setter
    def currentProgram(self, value: ghidra.program.model.listing.Program) -> None: ...

    @property
    def locked(self) -> bool: ...