from typing import List
import ghidra.app.plugin
import ghidra.app.plugin.core.functiongraph
import ghidra.app.plugin.core.functiongraph.mvc
import ghidra.app.util.viewer.format
import ghidra.framework.model
import ghidra.framework.options
import ghidra.framework.plugintool
import ghidra.framework.plugintool.util
import ghidra.program.model.listing
import ghidra.program.util
import java.lang


class FunctionGraphPlugin(ghidra.app.plugin.ProgramPlugin, ghidra.framework.options.OptionsChangeListener):
    GROUP_ADD_ICON: javax.swing.ImageIcon = images/shape_square_add.png
    GROUP_ICON: javax.swing.ImageIcon = images/shape_handles.png
    UNGROUP_ICON: javax.swing.ImageIcon = images/shape_ungroup.png



    def __init__(self, __a0: ghidra.framework.plugintool.PluginTool): ...



    def acceptData(self, __a0: List[ghidra.framework.model.DomainFile]) -> bool: ...

    def dataStateRestoreCompleted(self) -> None: ...

    def dependsUpon(self, __a0: ghidra.framework.plugintool.Plugin) -> bool: ...

    def equals(self, __a0: object) -> bool: ...

    def eventSent(self, __a0: ghidra.framework.plugintool.PluginEvent) -> None: ...

    def firePluginEvent(self, __a0: ghidra.framework.plugintool.PluginEvent) -> None: ...

    def getClass(self) -> java.lang.Class: ...

    def getColorProvider(self) -> ghidra.app.plugin.core.functiongraph.FGColorProvider: ...

    def getCurrentProgram(self) -> ghidra.program.model.listing.Program: ...

    def getData(self) -> List[ghidra.framework.model.DomainFile]: ...

    def getFunctionGraphOptions(self) -> ghidra.app.plugin.core.functiongraph.mvc.FunctionGraphOptions: ...

    def getLayoutProviders(self) -> List[object]: ...

    def getMissingRequiredServices(self) -> List[object]: ...

    def getName(self) -> unicode: ...

    def getPluginDescription(self) -> ghidra.framework.plugintool.util.PluginDescription: ...

    def getProgramHighlight(self) -> ghidra.program.util.ProgramSelection: ...

    def getProgramLocation(self) -> ghidra.program.util.ProgramLocation: ...

    def getProgramSelection(self) -> ghidra.program.util.ProgramSelection: ...

    def getSupportedDataTypes(self) -> List[java.lang.Class]: ...

    def getTool(self) -> ghidra.framework.plugintool.PluginTool: ...

    def getTransientState(self) -> object: ...

    def getUndoRedoState(self, __a0: ghidra.framework.model.DomainObject) -> object: ...

    def getUserDefinedFormat(self) -> ghidra.app.util.viewer.format.FormatManager: ...

    def handleProviderHighlightChanged(self, __a0: ghidra.app.plugin.core.functiongraph.FGProvider, __a1: ghidra.program.util.ProgramSelection) -> None: ...

    def handleProviderLocationChanged(self, __a0: ghidra.app.plugin.core.functiongraph.FGProvider, __a1: ghidra.program.util.ProgramLocation) -> None: ...

    def handleProviderSelectionChanged(self, __a0: ghidra.app.plugin.core.functiongraph.FGProvider, __a1: ghidra.program.util.ProgramSelection) -> None: ...

    def hasMissingRequiredService(self) -> bool: ...

    def hashCode(self) -> int: ...

    def isDisposed(self) -> bool: ...

    def notify(self) -> None: ...

    def notifyAll(self) -> None: ...

    def optionsChanged(self, __a0: ghidra.framework.options.ToolOptions, __a1: unicode, __a2: object, __a3: object) -> None: ...

    def processEvent(self, __a0: ghidra.framework.plugintool.PluginEvent) -> None: ...

    def readConfigState(self, __a0: ghidra.framework.options.SaveState) -> None: ...

    def readDataState(self, __a0: ghidra.framework.options.SaveState) -> None: ...

    def restoreTransientState(self, __a0: object) -> None: ...

    def restoreUndoRedoState(self, __a0: ghidra.framework.model.DomainObject, __a1: object) -> None: ...

    def serviceAdded(self, __a0: java.lang.Class, __a1: object) -> None: ...

    def serviceRemoved(self, __a0: java.lang.Class, __a1: object) -> None: ...

    def setUserDefinedFormat(self, __a0: ghidra.app.util.viewer.format.FormatManager) -> None: ...

    def toString(self) -> unicode: ...

    @overload
    def wait(self) -> None: ...

    @overload
    def wait(self, __a0: long) -> None: ...

    @overload
    def wait(self, __a0: long, __a1: int) -> None: ...

    def writeConfigState(self, __a0: ghidra.framework.options.SaveState) -> None: ...

    def writeDataState(self, __a0: ghidra.framework.options.SaveState) -> None: ...

    @property
    def colorProvider(self) -> ghidra.app.plugin.core.functiongraph.FGColorProvider: ...

    @property
    def functionGraphOptions(self) -> ghidra.app.plugin.core.functiongraph.mvc.FunctionGraphOptions: ...

    @property
    def layoutProviders(self) -> List[object]: ...

    @property
    def userDefinedFormat(self) -> ghidra.app.util.viewer.format.FormatManager: ...

    @userDefinedFormat.setter
    def userDefinedFormat(self, value: ghidra.app.util.viewer.format.FormatManager) -> None: ...