import ghidra.app.plugin.core.functiongraph.graph
import ghidra.app.plugin.core.functiongraph.graph.vertex
import ghidra.app.plugin.core.functiongraph.mvc
import ghidra.app.util.viewer.listingpanel
import ghidra.graph.viewer
import ghidra.program.model.address
import ghidra.program.model.listing
import ghidra.program.model.symbol
import ghidra.program.util
import java.awt
import java.awt.event
import java.awt.geom
import java.lang
import javax.swing


class FGVertex(ghidra.graph.viewer.VisualVertex, object):
    TOOLTIP_BACKGROUND_COLOR: java.awt.Color = java.awt.Color[r=255,g=255,b=230]







    def clearColor(self) -> None: ...

    def cloneVertex(self, __a0: ghidra.app.plugin.core.functiongraph.mvc.FGController) -> ghidra.app.plugin.core.functiongraph.graph.vertex.FGVertex: ...

    def containsAddress(self, __a0: ghidra.program.model.address.Address) -> bool: ...

    def containsProgramLocation(self, __a0: ghidra.program.util.ProgramLocation) -> bool: ...

    def dispose(self) -> None: ...

    def editLabel(self, __a0: javax.swing.JComponent) -> None: ...

    def equals(self, __a0: object) -> bool: ...

    def getAddresses(self) -> ghidra.program.model.address.AddressSetView: ...

    def getAlpha(self) -> float: ...

    def getBackgroundColor(self) -> java.awt.Color: ...

    def getBounds(self) -> java.awt.Rectangle: ...

    def getClass(self) -> java.lang.Class: ...

    def getComponent(self) -> javax.swing.JComponent: ...

    def getCursorBounds(self) -> java.awt.Rectangle: ...

    def getDefaultBackgroundColor(self) -> java.awt.Color: ...

    def getEmphasis(self) -> float: ...

    def getFlowType(self) -> ghidra.program.model.symbol.FlowType: ...

    def getGroupInfo(self) -> ghidra.app.plugin.core.functiongraph.graph.vertex.GroupHistoryInfo: ...

    def getListingModel(self, __a0: ghidra.program.model.address.Address) -> ghidra.app.util.viewer.listingpanel.ListingModel: ...

    def getLocation(self) -> java.awt.geom.Point2D: ...

    def getMaximizedViewComponent(self) -> java.awt.Component: ...

    def getProgram(self) -> ghidra.program.model.listing.Program: ...

    def getProgramLocation(self) -> ghidra.program.util.ProgramLocation: ...

    def getProgramSelection(self) -> ghidra.program.util.ProgramSelection: ...

    def getSelectionColor(self) -> java.awt.Color: ...

    def getTextSelection(self) -> unicode: ...

    def getTitle(self) -> unicode: ...

    def getToolTipComponentForEdge(self, __a0: ghidra.app.plugin.core.functiongraph.graph.FGEdge) -> javax.swing.JComponent: ...

    def getToolTipComponentForVertex(self) -> javax.swing.JComponent: ...

    def getToolTipText(self, __a0: java.awt.event.MouseEvent) -> unicode: ...

    def getUserDefinedColor(self) -> java.awt.Color: ...

    def getVertexAddress(self) -> ghidra.program.model.address.Address: ...

    def getVertexType(self) -> ghidra.app.plugin.core.functiongraph.graph.FGVertexType: ...

    def hashCode(self) -> int: ...

    def isDefaultBackgroundColor(self) -> bool: ...

    def isEntry(self) -> bool: ...

    def isFocused(self) -> bool: ...

    def isFullScreenMode(self) -> bool: ...

    def isGrabbable(self, __a0: java.awt.Component) -> bool: ...

    def isHeaderClick(self, __a0: java.awt.Component) -> bool: ...

    def isHovered(self) -> bool: ...

    def isSelected(self) -> bool: ...

    def isUncollapsedGroupMember(self) -> bool: ...

    def notify(self) -> None: ...

    def notifyAll(self) -> None: ...

    def readSettings(self, __a0: ghidra.app.plugin.core.functiongraph.mvc.FunctionGraphVertexAttributes) -> None: ...

    def refreshDisplay(self) -> None: ...

    def refreshDisplayForAddress(self, __a0: ghidra.program.model.address.Address) -> None: ...

    def refreshModel(self) -> None: ...

    def restoreColor(self, __a0: java.awt.Color) -> None: ...

    def setAlpha(self, __a0: float) -> None: ...

    def setBackgroundColor(self, __a0: java.awt.Color) -> None: ...

    def setEmphasis(self, __a0: float) -> None: ...

    def setFocused(self, __a0: bool) -> None: ...

    def setFullScreenMode(self, __a0: bool) -> None: ...

    def setHovered(self, __a0: bool) -> None: ...

    def setLocation(self, __a0: java.awt.geom.Point2D) -> None: ...

    def setProgramHighlight(self, __a0: ghidra.program.util.ProgramSelection) -> None: ...

    def setProgramLocation(self, __a0: ghidra.program.util.ProgramLocation) -> None: ...

    def setProgramSelection(self, __a0: ghidra.program.util.ProgramSelection) -> None: ...

    def setSelected(self, __a0: bool) -> None: ...

    def setShowing(self, __a0: bool) -> None: ...

    def setVertexType(self, __a0: ghidra.app.plugin.core.functiongraph.graph.FGVertexType) -> None: ...

    def toString(self) -> unicode: ...

    def updateGroupAssociationStatus(self, __a0: ghidra.app.plugin.core.functiongraph.graph.vertex.GroupHistoryInfo) -> None: ...

    @overload
    def wait(self) -> None: ...

    @overload
    def wait(self, __a0: long) -> None: ...

    @overload
    def wait(self, __a0: long, __a1: int) -> None: ...

    def writeSettings(self, __a0: ghidra.app.plugin.core.functiongraph.mvc.FunctionGraphVertexAttributes) -> None: ...

    @property
    def addresses(self) -> ghidra.program.model.address.AddressSetView: ...

    @property
    def alpha(self) -> float: ...

    @alpha.setter
    def alpha(self, value: float) -> None: ...

    @property
    def backgroundColor(self) -> java.awt.Color: ...

    @backgroundColor.setter
    def backgroundColor(self, value: java.awt.Color) -> None: ...

    @property
    def bounds(self) -> java.awt.Rectangle: ...

    @property
    def component(self) -> javax.swing.JComponent: ...

    @property
    def cursorBounds(self) -> java.awt.Rectangle: ...

    @property
    def defaultBackgroundColor(self) -> bool: ...

    @property
    def emphasis(self) -> float: ...

    @emphasis.setter
    def emphasis(self, value: float) -> None: ...

    @property
    def entry(self) -> bool: ...

    @property
    def flowType(self) -> ghidra.program.model.symbol.FlowType: ...

    @property
    def focused(self) -> bool: ...

    @focused.setter
    def focused(self, value: bool) -> None: ...

    @property
    def fullScreenMode(self) -> bool: ...

    @fullScreenMode.setter
    def fullScreenMode(self, value: bool) -> None: ...

    @property
    def groupInfo(self) -> ghidra.app.plugin.core.functiongraph.graph.vertex.GroupHistoryInfo: ...

    @property
    def hovered(self) -> bool: ...

    @hovered.setter
    def hovered(self, value: bool) -> None: ...

    @property
    def location(self) -> java.awt.geom.Point2D: ...

    @location.setter
    def location(self, value: java.awt.geom.Point2D) -> None: ...

    @property
    def maximizedViewComponent(self) -> java.awt.Component: ...

    @property
    def program(self) -> ghidra.program.model.listing.Program: ...

    @property
    def programHighlight(self) -> None: ...  # No getter available.

    @programHighlight.setter
    def programHighlight(self, value: ghidra.program.util.ProgramSelection) -> None: ...

    @property
    def programLocation(self) -> ghidra.program.util.ProgramLocation: ...

    @programLocation.setter
    def programLocation(self, value: ghidra.program.util.ProgramLocation) -> None: ...

    @property
    def programSelection(self) -> ghidra.program.util.ProgramSelection: ...

    @programSelection.setter
    def programSelection(self, value: ghidra.program.util.ProgramSelection) -> None: ...

    @property
    def selected(self) -> bool: ...

    @selected.setter
    def selected(self, value: bool) -> None: ...

    @property
    def selectionColor(self) -> java.awt.Color: ...

    @property
    def showing(self) -> None: ...  # No getter available.

    @showing.setter
    def showing(self, value: bool) -> None: ...

    @property
    def textSelection(self) -> unicode: ...

    @property
    def title(self) -> unicode: ...

    @property
    def toolTipComponentForVertex(self) -> javax.swing.JComponent: ...

    @property
    def uncollapsedGroupMember(self) -> bool: ...

    @property
    def userDefinedColor(self) -> java.awt.Color: ...

    @property
    def vertexAddress(self) -> ghidra.program.model.address.Address: ...

    @property
    def vertexType(self) -> ghidra.app.plugin.core.functiongraph.graph.FGVertexType: ...

    @vertexType.setter
    def vertexType(self, value: ghidra.app.plugin.core.functiongraph.graph.FGVertexType) -> None: ...