from typing import List
import ghidra.app.plugin.core.graph
import ghidra.app.services
import ghidra.framework.model
import ghidra.framework.options
import ghidra.framework.plugintool
import ghidra.framework.plugintool.util
import ghidra.service.graph
import ghidra.util.task
import java.lang


class GraphDisplayBrokerPlugin(ghidra.framework.plugintool.Plugin, ghidra.app.services.GraphDisplayBroker, ghidra.framework.options.OptionsChangeListener):




    def __init__(self, __a0: ghidra.framework.plugintool.PluginTool): ...



    def acceptData(self, __a0: List[ghidra.framework.model.DomainFile]) -> bool: ...

    def addGraphDisplayBrokerListener(self, __a0: ghidra.app.plugin.core.graph.GraphDisplayBrokerListener) -> None: ...

    def dataStateRestoreCompleted(self) -> None: ...

    def dependsUpon(self, __a0: ghidra.framework.plugintool.Plugin) -> bool: ...

    def dispose(self) -> None: ...

    def equals(self, __a0: object) -> bool: ...

    def eventSent(self, __a0: ghidra.framework.plugintool.PluginEvent) -> None: ...

    def firePluginEvent(self, __a0: ghidra.framework.plugintool.PluginEvent) -> None: ...

    def getClass(self) -> java.lang.Class: ...

    def getData(self) -> List[ghidra.framework.model.DomainFile]: ...

    def getDefaultGraphDisplay(self, __a0: bool, __a1: ghidra.util.task.TaskMonitor) -> ghidra.service.graph.GraphDisplay: ...

    def getDefaultGraphDisplayProvider(self) -> ghidra.service.graph.GraphDisplayProvider: ...

    def getGraphDisplayProvider(self, __a0: unicode) -> ghidra.service.graph.GraphDisplayProvider: ...

    @overload
    def getGraphExporters(self) -> List[object]: ...

    @overload
    def getGraphExporters(self, __a0: unicode) -> ghidra.service.graph.AttributedGraphExporter: ...

    def getMissingRequiredServices(self) -> List[object]: ...

    def getName(self) -> unicode: ...

    def getPluginDescription(self) -> ghidra.framework.plugintool.util.PluginDescription: ...

    def getSupportedDataTypes(self) -> List[java.lang.Class]: ...

    def getTool(self) -> ghidra.framework.plugintool.PluginTool: ...

    def getTransientState(self) -> object: ...

    def getUndoRedoState(self, __a0: ghidra.framework.model.DomainObject) -> object: ...

    def hasDefaultGraphDisplayProvider(self) -> bool: ...

    def hasMissingRequiredService(self) -> bool: ...

    def hashCode(self) -> int: ...

    def isDisposed(self) -> bool: ...

    def notify(self) -> None: ...

    def notifyAll(self) -> None: ...

    def optionsChanged(self, __a0: ghidra.framework.options.ToolOptions, __a1: unicode, __a2: object, __a3: object) -> None: ...

    def processEvent(self, __a0: ghidra.framework.plugintool.PluginEvent) -> None: ...

    def readConfigState(self, __a0: ghidra.framework.options.SaveState) -> None: ...

    def readDataState(self, __a0: ghidra.framework.options.SaveState) -> None: ...

    def removeGraphDisplayBrokerLisetener(self, __a0: ghidra.app.plugin.core.graph.GraphDisplayBrokerListener) -> None: ...

    def restoreTransientState(self, __a0: object) -> None: ...

    def restoreUndoRedoState(self, __a0: ghidra.framework.model.DomainObject, __a1: object) -> None: ...

    def serviceAdded(self, __a0: java.lang.Class, __a1: object) -> None: ...

    def serviceRemoved(self, __a0: java.lang.Class, __a1: object) -> None: ...

    def setDefaultGraphDisplayProvider(self, __a0: ghidra.service.graph.GraphDisplayProvider) -> None: ...

    def toString(self) -> unicode: ...

    @overload
    def wait(self) -> None: ...

    @overload
    def wait(self, __a0: long) -> None: ...

    @overload
    def wait(self, __a0: long, __a1: int) -> None: ...

    def writeConfigState(self, __a0: ghidra.framework.options.SaveState) -> None: ...

    def writeDataState(self, __a0: ghidra.framework.options.SaveState) -> None: ...

    @property
    def defaultGraphDisplayProvider(self) -> ghidra.service.graph.GraphDisplayProvider: ...

    @defaultGraphDisplayProvider.setter
    def defaultGraphDisplayProvider(self, value: ghidra.service.graph.GraphDisplayProvider) -> None: ...

    @property
    def graphExporters(self) -> List[object]: ...