import ghidra.app.plugin.core.debug
import ghidra.app.services
import ghidra.framework.model
import ghidra.trace.model
import ghidra.trace.model.guest
import ghidra.trace.model.program
import ghidra.trace.model.target
import ghidra.trace.model.thread
import ghidra.trace.model.time.schedule
import ghidra.util
import java.lang
import java.util
import java.util.concurrent


class DebuggerTraceManagerService(object):





    class BooleanChangeAdapter(ghidra.util.TriConsumer, object):








        @overload
        def accept(self, __a0: bool, __a1: bool, __a2: java.lang.Void) -> None: ...

        @overload
        def accept(self, __a0: object, __a1: object, __a2: object) -> None: ...

        def changed(self, __a0: bool) -> None: ...

        def equals(self, __a0: object) -> bool: ...

        def getClass(self) -> java.lang.Class: ...

        def hashCode(self) -> int: ...

        def notify(self) -> None: ...

        def notifyAll(self) -> None: ...

        def toString(self) -> unicode: ...

        @overload
        def wait(self) -> None: ...

        @overload
        def wait(self, __a0: long) -> None: ...

        @overload
        def wait(self, __a0: long, __a1: int) -> None: ...







    def activate(self, __a0: ghidra.app.plugin.core.debug.DebuggerCoordinates) -> None: ...

    def activateAndNotify(self, __a0: ghidra.app.plugin.core.debug.DebuggerCoordinates, __a1: bool) -> java.util.concurrent.CompletableFuture: ...

    def activateFrame(self, __a0: int) -> None: ...

    def activateObject(self, __a0: ghidra.trace.model.target.TraceObject) -> None: ...

    def activatePlatform(self, __a0: ghidra.trace.model.guest.TracePlatform) -> None: ...

    def activateSnap(self, __a0: long) -> None: ...

    def activateThread(self, __a0: ghidra.trace.model.thread.TraceThread) -> None: ...

    def activateTime(self, __a0: ghidra.trace.model.time.schedule.TraceSchedule) -> None: ...

    def activateTrace(self, __a0: ghidra.trace.model.Trace) -> None: ...

    def addAutoActivatePresentChangeListener(self, __a0: ghidra.app.services.DebuggerTraceManagerService.BooleanChangeAdapter) -> None: ...

    def addAutoCloseOnTerminateChangeListener(self, __a0: ghidra.app.services.DebuggerTraceManagerService.BooleanChangeAdapter) -> None: ...

    def addSaveTracesByDefaultChangeListener(self, __a0: ghidra.app.services.DebuggerTraceManagerService.BooleanChangeAdapter) -> None: ...

    def addSynchronizeFocusChangeListener(self, __a0: ghidra.app.services.DebuggerTraceManagerService.BooleanChangeAdapter) -> None: ...

    def closeAllTraces(self) -> None: ...

    def closeDeadTraces(self) -> None: ...

    def closeOtherTraces(self, __a0: ghidra.trace.model.Trace) -> None: ...

    def closeTrace(self, __a0: ghidra.trace.model.Trace) -> None: ...

    def equals(self, __a0: object) -> bool: ...

    def findSnapshot(self, __a0: ghidra.app.plugin.core.debug.DebuggerCoordinates) -> long: ...

    def getClass(self) -> java.lang.Class: ...

    def getCurrent(self) -> ghidra.app.plugin.core.debug.DebuggerCoordinates: ...

    def getCurrentFor(self, __a0: ghidra.trace.model.Trace) -> ghidra.app.plugin.core.debug.DebuggerCoordinates: ...

    def getCurrentFrame(self) -> int: ...

    def getCurrentObject(self) -> ghidra.trace.model.target.TraceObject: ...

    def getCurrentPlatform(self) -> ghidra.trace.model.guest.TracePlatform: ...

    def getCurrentSnap(self) -> long: ...

    def getCurrentThread(self) -> ghidra.trace.model.thread.TraceThread: ...

    def getCurrentTrace(self) -> ghidra.trace.model.Trace: ...

    def getCurrentView(self) -> ghidra.trace.model.program.TraceProgramView: ...

    def getOpenTraces(self) -> java.util.Collection: ...

    def hashCode(self) -> int: ...

    def isAutoActivatePresent(self) -> bool: ...

    def isAutoCloseOnTerminate(self) -> bool: ...

    def isSaveTracesByDefault(self) -> bool: ...

    def isSynchronizeFocus(self) -> bool: ...

    def materialize(self, __a0: ghidra.app.plugin.core.debug.DebuggerCoordinates) -> java.util.concurrent.CompletableFuture: ...

    def notify(self) -> None: ...

    def notifyAll(self) -> None: ...

    @overload
    def openTrace(self, __a0: ghidra.trace.model.Trace) -> None: ...

    @overload
    def openTrace(self, __a0: ghidra.framework.model.DomainFile, __a1: int) -> ghidra.trace.model.Trace: ...

    def openTraces(self, __a0: java.util.Collection) -> java.util.Collection: ...

    def removeAutoActivatePresentChangeListener(self, __a0: ghidra.app.services.DebuggerTraceManagerService.BooleanChangeAdapter) -> None: ...

    def removeAutoCloseOnTerminateChangeListener(self, __a0: ghidra.app.services.DebuggerTraceManagerService.BooleanChangeAdapter) -> None: ...

    def removeSaveTracesByDefaultChangeListener(self, __a0: ghidra.app.services.DebuggerTraceManagerService.BooleanChangeAdapter) -> None: ...

    def removeSynchronizeFocusChangeListener(self, __a0: ghidra.app.services.DebuggerTraceManagerService.BooleanChangeAdapter) -> None: ...

    def resolveFrame(self, __a0: int) -> ghidra.app.plugin.core.debug.DebuggerCoordinates: ...

    def resolveObject(self, __a0: ghidra.trace.model.target.TraceObject) -> ghidra.app.plugin.core.debug.DebuggerCoordinates: ...

    def resolvePlatform(self, __a0: ghidra.trace.model.guest.TracePlatform) -> ghidra.app.plugin.core.debug.DebuggerCoordinates: ...

    def resolveSnap(self, __a0: long) -> ghidra.app.plugin.core.debug.DebuggerCoordinates: ...

    def resolveThread(self, __a0: ghidra.trace.model.thread.TraceThread) -> ghidra.app.plugin.core.debug.DebuggerCoordinates: ...

    def resolveTime(self, __a0: ghidra.trace.model.time.schedule.TraceSchedule) -> ghidra.app.plugin.core.debug.DebuggerCoordinates: ...

    def resolveTrace(self, __a0: ghidra.trace.model.Trace) -> ghidra.app.plugin.core.debug.DebuggerCoordinates: ...

    def resolveView(self, __a0: ghidra.trace.model.program.TraceProgramView) -> ghidra.app.plugin.core.debug.DebuggerCoordinates: ...

    def saveTrace(self, __a0: ghidra.trace.model.Trace) -> java.util.concurrent.CompletableFuture: ...

    def setAutoActivatePresent(self, __a0: bool) -> None: ...

    def setAutoCloseOnTerminate(self, __a0: bool) -> None: ...

    def setSaveTracesByDefault(self, __a0: bool) -> None: ...

    def setSynchronizeFocus(self, __a0: bool) -> None: ...

    def toString(self) -> unicode: ...

    @overload
    def wait(self) -> None: ...

    @overload
    def wait(self, __a0: long) -> None: ...

    @overload
    def wait(self, __a0: long, __a1: int) -> None: ...

    @property
    def autoActivatePresent(self) -> bool: ...

    @autoActivatePresent.setter
    def autoActivatePresent(self, value: bool) -> None: ...

    @property
    def autoCloseOnTerminate(self) -> bool: ...

    @autoCloseOnTerminate.setter
    def autoCloseOnTerminate(self, value: bool) -> None: ...

    @property
    def current(self) -> ghidra.app.plugin.core.debug.DebuggerCoordinates: ...

    @property
    def currentFrame(self) -> int: ...

    @property
    def currentObject(self) -> ghidra.trace.model.target.TraceObject: ...

    @property
    def currentPlatform(self) -> ghidra.trace.model.guest.TracePlatform: ...

    @property
    def currentSnap(self) -> long: ...

    @property
    def currentThread(self) -> ghidra.trace.model.thread.TraceThread: ...

    @property
    def currentTrace(self) -> ghidra.trace.model.Trace: ...

    @property
    def currentView(self) -> ghidra.trace.model.program.TraceProgramView: ...

    @property
    def saveTracesByDefault(self) -> bool: ...

    @saveTracesByDefault.setter
    def saveTracesByDefault(self, value: bool) -> None: ...

    @property
    def synchronizeFocus(self) -> bool: ...

    @synchronizeFocus.setter
    def synchronizeFocus(self, value: bool) -> None: ...