from typing import List
import ghidra.app.services
import ghidra.framework.model
import ghidra.program.model.address
import ghidra.program.model.listing
import ghidra.program.util
import ghidra.trace.model
import ghidra.trace.model.breakpoint
import java.lang
import java.util
import java.util.concurrent


class LogicalBreakpoint(object):
    BREAKPOINT_DISABLED_BOOKMARK_TYPE: unicode = u'BreakpointDisabled'
    BREAKPOINT_ENABLED_BOOKMARK_TYPE: unicode = u'BreakpointEnabled'




    class ProgramMode(java.lang.Enum):
        DISABLED: ghidra.app.services.LogicalBreakpoint.ProgramMode = DISABLED
        ENABLED: ghidra.app.services.LogicalBreakpoint.ProgramMode = ENABLED
        MISSING: ghidra.app.services.LogicalBreakpoint.ProgramMode = MISSING
        NONE: ghidra.app.services.LogicalBreakpoint.ProgramMode = NONE







        def combineTrace(self, __a0: ghidra.app.services.LogicalBreakpoint.TraceMode, __a1: ghidra.app.services.LogicalBreakpoint.Perspective) -> ghidra.app.services.LogicalBreakpoint.State: ...

        @overload
        def compareTo(self, __a0: java.lang.Enum) -> int: ...

        @overload
        def compareTo(self, __a0: object) -> int: ...

        def describeConstable(self) -> java.util.Optional: ...

        def equals(self, __a0: object) -> bool: ...

        def getClass(self) -> java.lang.Class: ...

        def getDeclaringClass(self) -> java.lang.Class: ...

        def hashCode(self) -> int: ...

        def name(self) -> unicode: ...

        def notify(self) -> None: ...

        def notifyAll(self) -> None: ...

        def ordinal(self) -> int: ...

        def toString(self) -> unicode: ...

        @overload
        @staticmethod
        def valueOf(__a0: unicode) -> ghidra.app.services.LogicalBreakpoint.ProgramMode: ...

        @overload
        @staticmethod
        def valueOf(__a0: java.lang.Class, __a1: unicode) -> java.lang.Enum: ...

        @staticmethod
        def values() -> List[ghidra.app.services.LogicalBreakpoint.ProgramMode]: ...

        @overload
        def wait(self) -> None: ...

        @overload
        def wait(self, __a0: long) -> None: ...

        @overload
        def wait(self, __a0: long, __a1: int) -> None: ...






    class Consistency(java.lang.Enum):
        INCONSISTENT: ghidra.app.services.LogicalBreakpoint.Consistency = INCONSISTENT
        INEFFECTIVE: ghidra.app.services.LogicalBreakpoint.Consistency = INEFFECTIVE
        NORMAL: ghidra.app.services.LogicalBreakpoint.Consistency = NORMAL







        @overload
        def compareTo(self, __a0: java.lang.Enum) -> int: ...

        @overload
        def compareTo(self, __a0: object) -> int: ...

        def describeConstable(self) -> java.util.Optional: ...

        def equals(self, __a0: object) -> bool: ...

        def getClass(self) -> java.lang.Class: ...

        def getDeclaringClass(self) -> java.lang.Class: ...

        def hashCode(self) -> int: ...

        def name(self) -> unicode: ...

        def notify(self) -> None: ...

        def notifyAll(self) -> None: ...

        def ordinal(self) -> int: ...

        def sameAddress(self, __a0: ghidra.app.services.LogicalBreakpoint.Consistency) -> ghidra.app.services.LogicalBreakpoint.Consistency: ...

        def toString(self) -> unicode: ...

        @overload
        @staticmethod
        def valueOf(__a0: unicode) -> ghidra.app.services.LogicalBreakpoint.Consistency: ...

        @overload
        @staticmethod
        def valueOf(__a0: java.lang.Class, __a1: unicode) -> java.lang.Enum: ...

        @staticmethod
        def values() -> List[ghidra.app.services.LogicalBreakpoint.Consistency]: ...

        @overload
        def wait(self) -> None: ...

        @overload
        def wait(self, __a0: long) -> None: ...

        @overload
        def wait(self, __a0: long, __a1: int) -> None: ...






    class State(java.lang.Enum):
        DISABLED: ghidra.app.services.LogicalBreakpoint.State = DISABLED
        ENABLED: ghidra.app.services.LogicalBreakpoint.State = ENABLED
        INCONSISTENT_DISABLED: ghidra.app.services.LogicalBreakpoint.State = INCONSISTENT_DISABLED
        INCONSISTENT_ENABLED: ghidra.app.services.LogicalBreakpoint.State = INCONSISTENT_ENABLED
        INCONSISTENT_MIXED: ghidra.app.services.LogicalBreakpoint.State = INCONSISTENT_MIXED
        INEFFECTIVE_DISABLED: ghidra.app.services.LogicalBreakpoint.State = INEFFECTIVE_DISABLED
        INEFFECTIVE_ENABLED: ghidra.app.services.LogicalBreakpoint.State = INEFFECTIVE_ENABLED
        INEFFECTIVE_MIXED: ghidra.app.services.LogicalBreakpoint.State = INEFFECTIVE_MIXED
        MIXED: ghidra.app.services.LogicalBreakpoint.State = MIXED
        NONE: ghidra.app.services.LogicalBreakpoint.State = NONE
        consistency: ghidra.app.services.LogicalBreakpoint.Consistency
        display: unicode
        icon: javax.swing.Icon
        mode: ghidra.app.services.LogicalBreakpoint.Mode







        @overload
        def compareTo(self, __a0: java.lang.Enum) -> int: ...

        @overload
        def compareTo(self, __a0: object) -> int: ...

        def describeConstable(self) -> java.util.Optional: ...

        def equals(self, __a0: object) -> bool: ...

        @staticmethod
        def fromFields(__a0: ghidra.app.services.LogicalBreakpoint.Mode, __a1: ghidra.app.services.LogicalBreakpoint.Consistency) -> ghidra.app.services.LogicalBreakpoint.State: ...

        def getClass(self) -> java.lang.Class: ...

        def getDeclaringClass(self) -> java.lang.Class: ...

        def getToggled(self, __a0: bool) -> ghidra.app.services.LogicalBreakpoint.State: ...

        def hashCode(self) -> int: ...

        def isEffective(self) -> bool: ...

        def isEnabled(self) -> bool: ...

        def isIneffective(self) -> bool: ...

        def isNormal(self) -> bool: ...

        def name(self) -> unicode: ...

        def notify(self) -> None: ...

        def notifyAll(self) -> None: ...

        def ordinal(self) -> int: ...

        def sameAdddress(self, __a0: ghidra.app.services.LogicalBreakpoint.State) -> ghidra.app.services.LogicalBreakpoint.State: ...

        @staticmethod
        def sameAddress(__a0: java.util.Collection) -> ghidra.app.services.LogicalBreakpoint.State: ...

        def toString(self) -> unicode: ...

        @overload
        @staticmethod
        def valueOf(__a0: unicode) -> ghidra.app.services.LogicalBreakpoint.State: ...

        @overload
        @staticmethod
        def valueOf(__a0: java.lang.Class, __a1: unicode) -> java.lang.Enum: ...

        @staticmethod
        def values() -> List[ghidra.app.services.LogicalBreakpoint.State]: ...

        @overload
        def wait(self) -> None: ...

        @overload
        def wait(self, __a0: long) -> None: ...

        @overload
        def wait(self, __a0: long, __a1: int) -> None: ...

        @property
        def effective(self) -> bool: ...

        @property
        def enabled(self) -> bool: ...

        @property
        def ineffective(self) -> bool: ...

        @property
        def normal(self) -> bool: ...




    class Perspective(java.lang.Enum):
        LOGICAL: ghidra.app.services.LogicalBreakpoint.Perspective = LOGICAL
        TRACE: ghidra.app.services.LogicalBreakpoint.Perspective = TRACE







        @overload
        def compareTo(self, __a0: java.lang.Enum) -> int: ...

        @overload
        def compareTo(self, __a0: object) -> int: ...

        def describeConstable(self) -> java.util.Optional: ...

        def equals(self, __a0: object) -> bool: ...

        def getClass(self) -> java.lang.Class: ...

        def getDeclaringClass(self) -> java.lang.Class: ...

        def hashCode(self) -> int: ...

        def name(self) -> unicode: ...

        def notify(self) -> None: ...

        def notifyAll(self) -> None: ...

        def ordinal(self) -> int: ...

        def toString(self) -> unicode: ...

        @overload
        @staticmethod
        def valueOf(__a0: unicode) -> ghidra.app.services.LogicalBreakpoint.Perspective: ...

        @overload
        @staticmethod
        def valueOf(__a0: java.lang.Class, __a1: unicode) -> java.lang.Enum: ...

        @staticmethod
        def values() -> List[ghidra.app.services.LogicalBreakpoint.Perspective]: ...

        @overload
        def wait(self) -> None: ...

        @overload
        def wait(self, __a0: long) -> None: ...

        @overload
        def wait(self, __a0: long, __a1: int) -> None: ...






    class Mode(java.lang.Enum):
        DISABLED: ghidra.app.services.LogicalBreakpoint.Mode = DISABLED
        ENABLED: ghidra.app.services.LogicalBreakpoint.Mode = ENABLED
        MIXED: ghidra.app.services.LogicalBreakpoint.Mode = MIXED







        @overload
        def compareTo(self, __a0: java.lang.Enum) -> int: ...

        @overload
        def compareTo(self, __a0: object) -> int: ...

        def describeConstable(self) -> java.util.Optional: ...

        def equals(self, __a0: object) -> bool: ...

        def getClass(self) -> java.lang.Class: ...

        def getDeclaringClass(self) -> java.lang.Class: ...

        def hashCode(self) -> int: ...

        def name(self) -> unicode: ...

        def notify(self) -> None: ...

        def notifyAll(self) -> None: ...

        def ordinal(self) -> int: ...

        def sameAddress(self, __a0: ghidra.app.services.LogicalBreakpoint.Mode) -> ghidra.app.services.LogicalBreakpoint.Mode: ...

        def toString(self) -> unicode: ...

        @overload
        @staticmethod
        def valueOf(__a0: unicode) -> ghidra.app.services.LogicalBreakpoint.Mode: ...

        @overload
        @staticmethod
        def valueOf(__a0: java.lang.Class, __a1: unicode) -> java.lang.Enum: ...

        @staticmethod
        def values() -> List[ghidra.app.services.LogicalBreakpoint.Mode]: ...

        @overload
        def wait(self) -> None: ...

        @overload
        def wait(self, __a0: long) -> None: ...

        @overload
        def wait(self, __a0: long, __a1: int) -> None: ...






    class TraceMode(java.lang.Enum):
        DISABLED: ghidra.app.services.LogicalBreakpoint.TraceMode = DISABLED
        ENABLED: ghidra.app.services.LogicalBreakpoint.TraceMode = ENABLED
        MISSING: ghidra.app.services.LogicalBreakpoint.TraceMode = MISSING
        MIXED: ghidra.app.services.LogicalBreakpoint.TraceMode = MIXED
        NONE: ghidra.app.services.LogicalBreakpoint.TraceMode = NONE







        def combine(self, __a0: ghidra.app.services.LogicalBreakpoint.TraceMode) -> ghidra.app.services.LogicalBreakpoint.TraceMode: ...

        @overload
        def compareTo(self, __a0: java.lang.Enum) -> int: ...

        @overload
        def compareTo(self, __a0: object) -> int: ...

        def describeConstable(self) -> java.util.Optional: ...

        def equals(self, __a0: object) -> bool: ...

        @staticmethod
        def fromBool(__a0: bool) -> ghidra.app.services.LogicalBreakpoint.TraceMode: ...

        def getClass(self) -> java.lang.Class: ...

        def getDeclaringClass(self) -> java.lang.Class: ...

        def hashCode(self) -> int: ...

        def name(self) -> unicode: ...

        def notify(self) -> None: ...

        def notifyAll(self) -> None: ...

        def ordinal(self) -> int: ...

        def toString(self) -> unicode: ...

        @overload
        @staticmethod
        def valueOf(__a0: unicode) -> ghidra.app.services.LogicalBreakpoint.TraceMode: ...

        @overload
        @staticmethod
        def valueOf(__a0: java.lang.Class, __a1: unicode) -> java.lang.Enum: ...

        @staticmethod
        def values() -> List[ghidra.app.services.LogicalBreakpoint.TraceMode]: ...

        @overload
        def wait(self) -> None: ...

        @overload
        def wait(self, __a0: long) -> None: ...

        @overload
        def wait(self, __a0: long, __a1: int) -> None: ...







    def computeState(self) -> ghidra.app.services.LogicalBreakpoint.State: ...

    def computeStateForLocation(self, __a0: ghidra.trace.model.breakpoint.TraceBreakpoint) -> ghidra.app.services.LogicalBreakpoint.State: ...

    def computeStateForProgram(self, __a0: ghidra.program.model.listing.Program) -> ghidra.app.services.LogicalBreakpoint.State: ...

    def computeStateForTrace(self, __a0: ghidra.trace.model.Trace) -> ghidra.app.services.LogicalBreakpoint.State: ...

    def delete(self) -> java.util.concurrent.CompletableFuture: ...

    def deleteForProgram(self) -> None: ...

    def deleteForTrace(self, __a0: ghidra.trace.model.Trace) -> java.util.concurrent.CompletableFuture: ...

    def disable(self) -> java.util.concurrent.CompletableFuture: ...

    def disableForProgram(self) -> None: ...

    def disableForTrace(self, __a0: ghidra.trace.model.Trace) -> java.util.concurrent.CompletableFuture: ...

    def enable(self) -> java.util.concurrent.CompletableFuture: ...

    def enableForProgram(self) -> None: ...

    def enableForTrace(self, __a0: ghidra.trace.model.Trace) -> java.util.concurrent.CompletableFuture: ...

    def equals(self, __a0: object) -> bool: ...

    def generateStatusEnable(self, __a0: ghidra.trace.model.Trace) -> unicode: ...

    def getAddress(self) -> ghidra.program.model.address.Address: ...

    def getClass(self) -> java.lang.Class: ...

    def getDomainObject(self) -> ghidra.framework.model.DomainObject: ...

    def getKinds(self) -> java.util.Set: ...

    def getLength(self) -> long: ...

    def getMappedTraces(self) -> java.util.Set: ...

    def getName(self) -> unicode: ...

    def getParticipatingTraces(self) -> java.util.Set: ...

    def getProgram(self) -> ghidra.program.model.listing.Program: ...

    def getProgramBookmark(self) -> ghidra.program.model.listing.Bookmark: ...

    def getProgramLocation(self) -> ghidra.program.util.ProgramLocation: ...

    def getTraceAddress(self, __a0: ghidra.trace.model.Trace) -> ghidra.program.model.address.Address: ...

    @overload
    def getTraceBreakpoints(self) -> java.util.Set: ...

    @overload
    def getTraceBreakpoints(self, __a0: ghidra.trace.model.Trace) -> java.util.Set: ...

    def hashCode(self) -> int: ...

    def isEmpty(self) -> bool: ...

    def notify(self) -> None: ...

    def notifyAll(self) -> None: ...

    def setName(self, __a0: unicode) -> None: ...

    def toString(self) -> unicode: ...

    @overload
    def wait(self) -> None: ...

    @overload
    def wait(self, __a0: long) -> None: ...

    @overload
    def wait(self, __a0: long, __a1: int) -> None: ...

    @property
    def address(self) -> ghidra.program.model.address.Address: ...

    @property
    def domainObject(self) -> ghidra.framework.model.DomainObject: ...

    @property
    def empty(self) -> bool: ...

    @property
    def kinds(self) -> java.util.Set: ...

    @property
    def length(self) -> long: ...

    @property
    def mappedTraces(self) -> java.util.Set: ...

    @property
    def name(self) -> unicode: ...

    @name.setter
    def name(self, value: unicode) -> None: ...

    @property
    def participatingTraces(self) -> java.util.Set: ...

    @property
    def program(self) -> ghidra.program.model.listing.Program: ...

    @property
    def programBookmark(self) -> ghidra.program.model.listing.Bookmark: ...

    @property
    def programLocation(self) -> ghidra.program.util.ProgramLocation: ...

    @property
    def traceBreakpoints(self) -> java.util.Set: ...