import ghidra.app.util.bin
import ghidra.app.util.bin.format.macho.commands
import ghidra.program.model.data
import java.lang


class DyldChainedFixupHeader(object, ghidra.app.util.bin.StructConverter):
    """
    Represents a dyld_chained_fixups_header structure.
    """

    ASCII: ghidra.program.model.data.DataType = char
    BYTE: ghidra.program.model.data.DataType = byte
    DWORD: ghidra.program.model.data.DataType = dword
    IBO32: ghidra.program.model.data.DataType = IBO32DataType: typedef ImageBaseOffset32 pointer32
    IBO64: ghidra.program.model.data.DataType = IBO64DataType: typedef ImageBaseOffset64 pointer64
    POINTER: ghidra.program.model.data.DataType = pointer
    QWORD: ghidra.program.model.data.DataType = qword
    STRING: ghidra.program.model.data.DataType = string
    UTF16: ghidra.program.model.data.DataType = unicode
    UTF8: ghidra.program.model.data.DataType = string-utf8
    VOID: ghidra.program.model.data.DataType = void
    WORD: ghidra.program.model.data.DataType = word







    def equals(self, __a0: object) -> bool: ...

    def getChainedImports(self) -> ghidra.app.util.bin.format.macho.commands.DyldChainedImports: ...

    def getChainedStartsInImage(self) -> ghidra.app.util.bin.format.macho.commands.DyldChainedStartsInImage: ...

    def getClass(self) -> java.lang.Class: ...

    def getFixups_version(self) -> int: ...

    def getImports_count(self) -> int: ...

    def getImports_format(self) -> int: ...

    def getImports_offset(self) -> int: ...

    def getStarts_offset(self) -> int: ...

    def getSymbols_format(self) -> int: ...

    def getSymbols_offset(self) -> int: ...

    def hashCode(self) -> int: ...

    def isCompress(self) -> bool: ...

    def notify(self) -> None: ...

    def notifyAll(self) -> None: ...

    def toDataType(self) -> ghidra.program.model.data.DataType: ...

    def toString(self) -> unicode: ...

    @overload
    def wait(self) -> None: ...

    @overload
    def wait(self, __a0: long) -> None: ...

    @overload
    def wait(self, __a0: long, __a1: int) -> None: ...

    @property
    def chainedImports(self) -> ghidra.app.util.bin.format.macho.commands.DyldChainedImports: ...

    @property
    def chainedStartsInImage(self) -> ghidra.app.util.bin.format.macho.commands.DyldChainedStartsInImage: ...

    @property
    def compress(self) -> bool: ...

    @property
    def fixups_version(self) -> int: ...

    @property
    def imports_count(self) -> int: ...

    @property
    def imports_format(self) -> int: ...

    @property
    def imports_offset(self) -> int: ...

    @property
    def starts_offset(self) -> int: ...

    @property
    def symbols_format(self) -> int: ...

    @property
    def symbols_offset(self) -> int: ...