import ghidra.app.util.bin
import ghidra.program.model.data
import java.lang


class DyldChainedImport(object, ghidra.app.util.bin.StructConverter):
    """
    Represents a dyld_chained_import structure.
    """

    ASCII: ghidra.program.model.data.DataType = char
    BYTE: ghidra.program.model.data.DataType = byte
    DWORD: ghidra.program.model.data.DataType = dword
    IBO32: ghidra.program.model.data.DataType = IBO32DataType: typedef ImageBaseOffset32 pointer32
    IBO64: ghidra.program.model.data.DataType = IBO64DataType: typedef ImageBaseOffset64 pointer64
    POINTER: ghidra.program.model.data.DataType = pointer
    QWORD: ghidra.program.model.data.DataType = qword
    STRING: ghidra.program.model.data.DataType = string
    UTF16: ghidra.program.model.data.DataType = unicode
    UTF8: ghidra.program.model.data.DataType = string-utf8
    VOID: ghidra.program.model.data.DataType = void
    WORD: ghidra.program.model.data.DataType = word







    def equals(self, __a0: object) -> bool: ...

    def getAddend(self) -> long: ...

    def getClass(self) -> java.lang.Class: ...

    def getLibOrdinal(self) -> int: ...

    def getName(self) -> unicode: ...

    def getNameOffset(self) -> long: ...

    def hashCode(self) -> int: ...

    def initString(self, reader: ghidra.app.util.bin.BinaryReader) -> None: ...

    def isWeakImport(self) -> bool: ...

    def notify(self) -> None: ...

    def notifyAll(self) -> None: ...

    def toDataType(self) -> ghidra.program.model.data.DataType: ...

    def toString(self) -> unicode: ...

    @overload
    def wait(self) -> None: ...

    @overload
    def wait(self, __a0: long) -> None: ...

    @overload
    def wait(self, __a0: long, __a1: int) -> None: ...

    @property
    def addend(self) -> long: ...

    @property
    def libOrdinal(self) -> int: ...

    @property
    def name(self) -> unicode: ...

    @property
    def nameOffset(self) -> long: ...

    @property
    def weakImport(self) -> bool: ...