import ghidra.dbg
import ghidra.framework.options
import java.lang
import java.util
import java.util.concurrent


class AbstractGadpLocalDebuggerModelFactory(object, ghidra.dbg.DebuggerModelFactory):
    LOG_AGENT_STDOUT: bool = True
    agentAddressOption: ghidra.dbg.util.ConfigurableFactory.Property
    agentPortOption: ghidra.dbg.util.ConfigurableFactory.Property
    jdwpPortOption: ghidra.dbg.util.ConfigurableFactory.Property
    jdwpSuspendOption: ghidra.dbg.util.ConfigurableFactory.Property



    def __init__(self): ...



    def build(self) -> java.util.concurrent.CompletableFuture: ...

    def equals(self, __a0: object) -> bool: ...

    def getAgentAddress(self) -> unicode: ...

    def getAgentPort(self) -> int: ...

    def getBrief(self) -> unicode: ...

    def getClass(self) -> java.lang.Class: ...

    def getHtmlDetails(self) -> unicode: ...

    def getJdwpPort(self) -> int: ...

    def getOptions(self) -> java.util.Map: ...

    def hashCode(self) -> int: ...

    def isCompatible(self) -> bool: ...

    def isJdwpSuspend(self) -> bool: ...

    def notify(self) -> None: ...

    def notifyAll(self) -> None: ...

    def readConfigState(self, __a0: ghidra.framework.options.SaveState) -> None: ...

    def setAgentAddress(self, __a0: unicode) -> None: ...

    def setAgentPort(self, __a0: int) -> None: ...

    def setJdwpPort(self, __a0: int) -> None: ...

    def setJdwpSuspend(self, __a0: bool) -> None: ...

    def toString(self) -> unicode: ...

    @overload
    def wait(self) -> None: ...

    @overload
    def wait(self, __a0: long) -> None: ...

    @overload
    def wait(self, __a0: long, __a1: int) -> None: ...

    def writeConfigState(self, __a0: ghidra.framework.options.SaveState) -> None: ...

    @property
    def agentAddress(self) -> unicode: ...

    @agentAddress.setter
    def agentAddress(self, value: unicode) -> None: ...

    @property
    def agentPort(self) -> int: ...

    @agentPort.setter
    def agentPort(self, value: int) -> None: ...

    @property
    def brief(self) -> unicode: ...

    @property
    def compatible(self) -> bool: ...

    @property
    def htmlDetails(self) -> unicode: ...

    @property
    def jdwpPort(self) -> int: ...

    @jdwpPort.setter
    def jdwpPort(self, value: int) -> None: ...

    @property
    def jdwpSuspend(self) -> bool: ...

    @jdwpSuspend.setter
    def jdwpSuspend(self, value: bool) -> None: ...

    @property
    def options(self) -> java.util.Map: ...