from typing import List
import ghidra.comm.service
import ghidra.dbg
import ghidra.dbg.error
import ghidra.dbg.target
import ghidra.program.model.address
import java.lang
import java.net
import java.util
import java.util.concurrent


class AbstractGadpServer(ghidra.comm.service.AbstractAsyncServer, ghidra.dbg.DebuggerModelListener):
    LISTENING_ON: unicode = u'GADP Server listening on '



    def __init__(self, __a0: ghidra.dbg.DebuggerObjectModel, __a1: java.net.SocketAddress): ...



    def attributesChanged(self, __a0: ghidra.dbg.target.TargetObject, __a1: java.util.Collection, __a2: java.util.Map) -> None: ...

    def breakpointHit(self, __a0: ghidra.dbg.target.TargetObject, __a1: ghidra.dbg.target.TargetObject, __a2: ghidra.dbg.target.TargetStackFrame, __a3: ghidra.dbg.target.TargetBreakpointSpec, __a4: ghidra.dbg.target.TargetBreakpointLocation) -> None: ...

    def catastrophic(self, __a0: java.lang.Throwable) -> None: ...

    @overload
    def consoleOutput(self, __a0: ghidra.dbg.target.TargetObject, __a1: ghidra.dbg.target.TargetConsole.Channel, __a2: unicode) -> None: ...

    @overload
    def consoleOutput(self, __a0: ghidra.dbg.target.TargetObject, __a1: ghidra.dbg.target.TargetConsole.Channel, __a2: List[int]) -> None: ...

    def created(self, __a0: ghidra.dbg.target.TargetObject) -> None: ...

    def elementsChanged(self, __a0: ghidra.dbg.target.TargetObject, __a1: java.util.Collection, __a2: java.util.Map) -> None: ...

    def equals(self, __a0: object) -> bool: ...

    def event(self, __a0: ghidra.dbg.target.TargetObject, __a1: ghidra.dbg.target.TargetThread, __a2: ghidra.dbg.target.TargetEventScope.TargetEventType, __a3: unicode, __a4: List[object]) -> None: ...

    def getClass(self) -> java.lang.Class: ...

    def getLocalAddress(self) -> java.net.SocketAddress: ...

    def getModel(self) -> ghidra.dbg.DebuggerObjectModel: ...

    def hashCode(self) -> int: ...

    def invalidateCacheRequested(self, __a0: ghidra.dbg.target.TargetObject) -> None: ...

    def invalidated(self, __a0: ghidra.dbg.target.TargetObject, __a1: ghidra.dbg.target.TargetObject, __a2: unicode) -> None: ...

    def launchAsyncService(self) -> java.util.concurrent.CompletableFuture: ...

    def memoryReadError(self, __a0: ghidra.dbg.target.TargetObject, __a1: ghidra.program.model.address.AddressRange, __a2: ghidra.dbg.error.DebuggerMemoryAccessException) -> None: ...

    def memoryUpdated(self, __a0: ghidra.dbg.target.TargetObject, __a1: ghidra.program.model.address.Address, __a2: List[int]) -> None: ...

    def modelClosed(self, __a0: ghidra.dbg.DebuggerModelClosedReason) -> None: ...

    def modelOpened(self) -> None: ...

    def modelStateChanged(self) -> None: ...

    def notify(self) -> None: ...

    def notifyAll(self) -> None: ...

    def registersUpdated(self, __a0: ghidra.dbg.target.TargetObject, __a1: java.util.Map) -> None: ...

    def rootAdded(self, __a0: ghidra.dbg.target.TargetObject) -> None: ...

    def setExitOnClosed(self, __a0: bool) -> None: ...

    def terminate(self) -> None: ...

    def toString(self) -> unicode: ...

    @overload
    def wait(self) -> None: ...

    @overload
    def wait(self, __a0: long) -> None: ...

    @overload
    def wait(self, __a0: long, __a1: int) -> None: ...

    @property
    def exitOnClosed(self) -> None: ...  # No getter available.

    @exitOnClosed.setter
    def exitOnClosed(self, value: bool) -> None: ...

    @property
    def model(self) -> ghidra.dbg.DebuggerObjectModel: ...