from typing import List
import com.sun.jdi
import com.sun.jdi.connect
import com.sun.jdi.event
import ghidra.dbg
import ghidra.dbg.agent
import ghidra.dbg.jdi.manager
import ghidra.dbg.jdi.manager.breakpoint
import ghidra.dbg.jdi.model
import ghidra.dbg.jdi.model.iface1
import ghidra.dbg.jdi.model.iface2
import ghidra.dbg.target
import ghidra.dbg.target.schema
import ghidra.dbg.util
import ghidra.util.datastruct
import java.lang
import java.util
import java.util.concurrent


class JdiModelTargetVM(ghidra.dbg.jdi.model.JdiModelTargetObjectImpl, ghidra.dbg.target.TargetProcess, ghidra.dbg.target.TargetAggregate, ghidra.dbg.jdi.model.iface1.JdiModelTargetEnvironment, ghidra.dbg.jdi.model.iface1.JdiModelTargetAccessConditioned, ghidra.dbg.jdi.model.iface1.JdiModelTargetExecutionStateful, ghidra.dbg.jdi.model.iface1.JdiModelTargetLauncher, ghidra.dbg.jdi.model.iface1.JdiModelTargetDeletable, ghidra.dbg.jdi.model.iface1.JdiModelTargetKillable, ghidra.dbg.jdi.model.iface1.JdiModelTargetResumable, ghidra.dbg.jdi.model.iface1.JdiModelTargetInterruptible, ghidra.dbg.jdi.manager.JdiEventsListenerAdapter, ghidra.dbg.jdi.model.iface1.JdiModelSelectableObject):
    EXIT_CODE_ATTRIBUTE_NAME: unicode = u'_exit_code'
    ID_ATTRIBUTE_NAME: unicode = u'_id'



    def __init__(self, __a0: ghidra.dbg.jdi.model.JdiModelTargetVMContainer, __a1: com.sun.jdi.VirtualMachine, __a2: bool): ...



    def acceptsElement(self, __a0: unicode) -> bool: ...

    def accessWatchpointHit(self, __a0: com.sun.jdi.event.AccessWatchpointEvent, __a1: ghidra.dbg.jdi.manager.JdiCause) -> None: ...

    def addListener(self, __a0: ghidra.dbg.DebuggerModelListener) -> None: ...

    def as(self, __a0: java.lang.Class) -> ghidra.dbg.target.TargetObject: ...

    def breakpointCreated(self, __a0: ghidra.dbg.jdi.manager.breakpoint.JdiBreakpointInfo, __a1: ghidra.dbg.jdi.manager.JdiCause) -> None: ...

    def breakpointDeleted(self, __a0: ghidra.dbg.jdi.manager.breakpoint.JdiBreakpointInfo, __a1: ghidra.dbg.jdi.manager.JdiCause) -> None: ...

    def breakpointHit(self, __a0: com.sun.jdi.event.BreakpointEvent, __a1: ghidra.dbg.jdi.manager.JdiCause) -> None: ...

    def breakpointModified(self, __a0: ghidra.dbg.jdi.manager.breakpoint.JdiBreakpointInfo, __a1: ghidra.dbg.jdi.manager.breakpoint.JdiBreakpointInfo, __a2: ghidra.dbg.jdi.manager.JdiCause) -> None: ...

    @overload
    def changeAttributes(self, __a0: List[object], __a1: java.util.Map, __a2: unicode) -> ghidra.dbg.util.CollectionUtils.Delta: ...

    @overload
    def changeAttributes(self, __a0: List[object], __a1: java.util.Collection, __a2: java.util.Map, __a3: unicode) -> ghidra.dbg.util.CollectionUtils.Delta: ...

    @overload
    def changeElements(self, __a0: java.util.Collection, __a1: java.util.Collection, __a2: unicode) -> ghidra.dbg.util.CollectionUtils.Delta: ...

    @overload
    def changeElements(self, __a0: java.util.Collection, __a1: java.util.Map, __a2: unicode) -> ghidra.dbg.util.CollectionUtils.Delta: ...

    @overload
    def changeElements(self, __a0: java.util.Collection, __a1: java.util.Collection, __a2: java.util.Map, __a3: unicode) -> ghidra.dbg.util.CollectionUtils.Delta: ...

    def classPrepare(self, __a0: com.sun.jdi.event.ClassPrepareEvent, __a1: ghidra.dbg.jdi.manager.JdiCause) -> None: ...

    def classUnload(self, __a0: com.sun.jdi.event.ClassUnloadEvent, __a1: ghidra.dbg.jdi.manager.JdiCause) -> None: ...

    @overload
    def compareTo(self, __a0: ghidra.dbg.target.TargetObject) -> int: ...

    @overload
    def compareTo(self, __a0: object) -> int: ...

    def computeHashCode(self) -> int: ...

    @staticmethod
    def createBooleanParameter(__a0: com.sun.jdi.connect.Connector.BooleanArgument) -> ghidra.dbg.target.TargetMethod.ParameterDescription: ...

    @staticmethod
    def createGenericParameter(__a0: com.sun.jdi.connect.Connector.Argument) -> ghidra.dbg.target.TargetMethod.ParameterDescription: ...

    @staticmethod
    def createIntegerParameter(__a0: com.sun.jdi.connect.Connector.IntegerArgument) -> ghidra.dbg.target.TargetMethod.ParameterDescription: ...

    @staticmethod
    def createParameter(__a0: com.sun.jdi.connect.Connector.Argument) -> ghidra.dbg.target.TargetMethod.ParameterDescription: ...

    @staticmethod
    def createSelectedParameter(__a0: com.sun.jdi.connect.Connector.SelectedArgument) -> ghidra.dbg.target.TargetMethod.ParameterDescription: ...

    @staticmethod
    def createStringParameter(__a0: com.sun.jdi.connect.Connector.StringArgument) -> ghidra.dbg.target.TargetMethod.ParameterDescription: ...

    def delete(self) -> java.util.concurrent.CompletableFuture: ...

    def doEquals(self, __a0: object) -> bool: ...

    def doInvalidateSubtree(self, __a0: ghidra.dbg.target.TargetObject, __a1: unicode) -> None: ...

    def enforcesStrictSchema(self) -> bool: ...

    def equals(self, __a0: object) -> bool: ...

    def exceptionHit(self, __a0: com.sun.jdi.event.ExceptionEvent, __a1: ghidra.dbg.jdi.manager.JdiCause) -> None: ...

    def fetchAttribute(self, __a0: unicode) -> java.util.concurrent.CompletableFuture: ...

    @overload
    def fetchAttributes(self) -> java.util.concurrent.CompletableFuture: ...

    @overload
    def fetchAttributes(self, __a0: bool) -> java.util.concurrent.CompletableFuture: ...

    def fetchChild(self, __a0: unicode) -> java.util.concurrent.CompletableFuture: ...

    @overload
    def fetchChildren(self) -> java.util.concurrent.CompletableFuture: ...

    @overload
    def fetchChildren(self, __a0: bool) -> java.util.concurrent.CompletableFuture: ...

    def fetchChildrenSupporting(self, __a0: java.lang.Class) -> java.util.concurrent.CompletableFuture: ...

    def fetchElement(self, __a0: unicode) -> java.util.concurrent.CompletableFuture: ...

    @overload
    def fetchElements(self) -> java.util.concurrent.CompletableFuture: ...

    @overload
    def fetchElements(self, __a0: bool) -> java.util.concurrent.CompletableFuture: ...

    @overload
    def fetchSubAttribute(self, __a0: List[unicode]) -> java.util.concurrent.CompletableFuture: ...

    @overload
    def fetchSubAttribute(self, __a0: List[object]) -> java.util.concurrent.CompletableFuture: ...

    @overload
    def fetchSubAttributes(self, __a0: List[unicode]) -> java.util.concurrent.CompletableFuture: ...

    @overload
    def fetchSubAttributes(self, __a0: List[object]) -> java.util.concurrent.CompletableFuture: ...

    @overload
    def fetchSubElements(self, __a0: List[unicode]) -> java.util.concurrent.CompletableFuture: ...

    @overload
    def fetchSubElements(self, __a0: List[object]) -> java.util.concurrent.CompletableFuture: ...

    @overload
    def fetchSuccessor(self, __a0: List[unicode]) -> java.util.concurrent.CompletableFuture: ...

    @overload
    def fetchSuccessor(self, __a0: List[object]) -> java.util.concurrent.CompletableFuture: ...

    @overload
    def fetchValue(self, __a0: List[unicode]) -> java.util.concurrent.CompletableFuture: ...

    @overload
    def fetchValue(self, __a0: List[object]) -> java.util.concurrent.CompletableFuture: ...

    def filterValid(self, __a0: unicode, __a1: java.util.Map) -> java.util.Map: ...

    def getArchitecture(self) -> unicode: ...

    @staticmethod
    def getArguments(__a0: java.util.Map, __a1: java.util.Map, __a2: java.util.Map) -> java.util.Map: ...

    def getCachedAttribute(self, __a0: unicode) -> object: ...

    def getCachedAttributes(self) -> java.util.Map: ...

    def getCachedElements(self) -> java.util.Map: ...

    def getCallbackAttributes(self) -> java.util.Map: ...

    def getCallbackElements(self) -> java.util.Map: ...

    def getClass(self) -> java.lang.Class: ...

    def getClasses(self) -> ghidra.dbg.jdi.model.JdiModelTargetClassContainer: ...

    def getDebugger(self) -> unicode: ...

    def getDelegate(self) -> ghidra.dbg.agent.SpiTargetObject: ...

    def getDisplay(self) -> unicode: ...

    def getEndian(self) -> unicode: ...

    def getExecutionState(self) -> ghidra.dbg.target.TargetExecutionStateful.TargetExecutionState: ...

    def getIndex(self) -> unicode: ...

    def getInstance(self, __a0: com.sun.jdi.Mirror) -> ghidra.dbg.jdi.model.iface2.JdiModelTargetObject: ...

    def getInterfaceNames(self) -> java.util.Collection: ...

    def getInterfaces(self) -> java.util.Collection: ...

    @staticmethod
    def getInterfacesByName(__a0: java.util.Collection) -> List[object]: ...

    def getJoinedPath(self, __a0: unicode) -> unicode: ...

    def getKind(self) -> unicode: ...

    def getListeners(self) -> ghidra.util.datastruct.ListenerSet: ...

    def getManager(self) -> ghidra.dbg.jdi.manager.JdiManager: ...

    def getModel(self) -> ghidra.dbg.DebuggerObjectModel: ...

    def getModelImpl(self) -> ghidra.dbg.jdi.model.JdiModelImpl: ...

    def getName(self) -> unicode: ...

    def getObject(self) -> object: ...

    def getOperatingSystem(self) -> unicode: ...

    def getOrder(self) -> int: ...

    def getParameters(self) -> ghidra.dbg.target.TargetMethod.TargetParameterMap: ...

    def getParent(self) -> ghidra.dbg.target.TargetObject: ...

    def getPath(self) -> List[object]: ...

    def getPid(self) -> long: ...

    def getProtocolID(self) -> object: ...

    def getProxy(self) -> ghidra.dbg.agent.SpiTargetObject: ...

    def getSchema(self) -> ghidra.dbg.target.schema.TargetObjectSchema: ...

    def getShortDisplay(self) -> unicode: ...

    @overload
    def getSuccessor(self, __a0: List[unicode]) -> ghidra.dbg.target.TargetObject: ...

    @overload
    def getSuccessor(self, __a0: List[object]) -> ghidra.dbg.target.TargetObject: ...

    @overload
    def getTargetObject(self, __a0: unicode) -> ghidra.dbg.jdi.model.iface2.JdiModelTargetObject: ...

    @overload
    def getTargetObject(self, __a0: object) -> ghidra.dbg.jdi.model.iface2.JdiModelTargetObject: ...

    def getType(self) -> unicode: ...

    def getTypeHint(self) -> unicode: ...

    def getTypedAttributeNowByName(self, __a0: unicode, __a1: java.lang.Class, __a2: object) -> object: ...

    def getValue(self) -> object: ...

    def hashCode(self) -> int: ...

    @overload
    def init(self) -> java.util.concurrent.CompletableFuture: ...

    @overload
    def init(self, __a0: java.util.Map) -> java.util.concurrent.CompletableFuture: ...

    @staticmethod
    def initInterfacesByName() -> java.util.Map: ...

    def interrupt(self) -> java.util.concurrent.CompletableFuture: ...

    def invalidateCaches(self) -> java.util.concurrent.CompletableFuture: ...

    def invalidateSubtree(self, __a0: ghidra.dbg.target.TargetObject, __a1: unicode) -> None: ...

    def isAccessible(self) -> bool: ...

    def isModified(self) -> bool: ...

    def isRoot(self) -> bool: ...

    def isValid(self) -> bool: ...

    @staticmethod
    def keyObject(__a0: unicode) -> unicode: ...

    def kill(self) -> java.util.concurrent.CompletableFuture: ...

    def launch(self, __a0: java.util.Map) -> java.util.concurrent.CompletableFuture: ...

    def libraryLoaded(self, __a0: com.sun.jdi.VirtualMachine, __a1: unicode, __a2: ghidra.dbg.jdi.manager.JdiCause) -> None: ...

    def libraryUnloaded(self, __a0: com.sun.jdi.VirtualMachine, __a1: unicode, __a2: ghidra.dbg.jdi.manager.JdiCause) -> None: ...

    def memoryChanged(self, __a0: com.sun.jdi.VirtualMachine, __a1: long, __a2: int, __a3: ghidra.dbg.jdi.manager.JdiCause) -> None: ...

    def methodEntry(self, __a0: com.sun.jdi.event.MethodEntryEvent, __a1: ghidra.dbg.jdi.manager.JdiCause) -> None: ...

    def methodExit(self, __a0: com.sun.jdi.event.MethodExitEvent, __a1: ghidra.dbg.jdi.manager.JdiCause) -> None: ...

    def monitorContendedEnter(self, __a0: com.sun.jdi.event.MonitorContendedEnterEvent, __a1: ghidra.dbg.jdi.manager.JdiCause) -> None: ...

    def monitorContendedEntered(self, __a0: com.sun.jdi.event.MonitorContendedEnteredEvent, __a1: ghidra.dbg.jdi.manager.JdiCause) -> None: ...

    def monitorWait(self, __a0: com.sun.jdi.event.MonitorWaitEvent, __a1: ghidra.dbg.jdi.manager.JdiCause) -> None: ...

    def monitorWaited(self, __a0: com.sun.jdi.event.MonitorWaitedEvent, __a1: ghidra.dbg.jdi.manager.JdiCause) -> None: ...

    def notify(self) -> None: ...

    def notifyAll(self) -> None: ...

    def processShutdown(self, __a0: com.sun.jdi.event.Event, __a1: ghidra.dbg.jdi.manager.JdiCause) -> None: ...

    def processStop(self, __a0: com.sun.jdi.event.EventSet, __a1: ghidra.dbg.jdi.manager.JdiCause) -> None: ...

    def refreshInternal(self) -> None: ...

    def removeListener(self, __a0: ghidra.dbg.DebuggerModelListener) -> None: ...

    def requestAttributes(self, __a0: bool) -> java.util.concurrent.CompletableFuture: ...

    def resetModified(self) -> None: ...

    def resume(self) -> java.util.concurrent.CompletableFuture: ...

    @overload
    def resync(self) -> java.util.concurrent.CompletableFuture: ...

    @overload
    def resync(self, __a0: bool, __a1: bool) -> java.util.concurrent.CompletableFuture: ...

    def searchForSuitable(self, __a0: java.lang.Class) -> ghidra.dbg.target.TargetObject: ...

    def setActive(self) -> java.util.concurrent.CompletableFuture: ...

    @overload
    def setAttributes(self, __a0: java.util.Map, __a1: unicode) -> ghidra.dbg.util.CollectionUtils.Delta: ...

    @overload
    def setAttributes(self, __a0: java.util.Collection, __a1: java.util.Map, __a2: unicode) -> ghidra.dbg.util.CollectionUtils.Delta: ...

    @overload
    def setElements(self, __a0: java.util.Collection, __a1: unicode) -> ghidra.dbg.util.CollectionUtils.Delta: ...

    @overload
    def setElements(self, __a0: java.util.Collection, __a1: java.util.Map, __a2: unicode) -> ghidra.dbg.util.CollectionUtils.Delta: ...

    def setExecutionState(self, __a0: ghidra.dbg.target.TargetExecutionStateful.TargetExecutionState, __a1: unicode) -> None: ...

    def setModified(self, __a0: bool) -> None: ...

    def setTargetObject(self, __a0: unicode, __a1: object, __a2: ghidra.dbg.jdi.model.iface2.JdiModelTargetObject) -> None: ...

    def started(self, __a0: unicode) -> java.util.concurrent.CompletableFuture: ...

    def stepComplete(self, __a0: com.sun.jdi.event.StepEvent, __a1: ghidra.dbg.jdi.manager.JdiCause) -> None: ...

    def threadExited(self, __a0: com.sun.jdi.event.ThreadDeathEvent, __a1: ghidra.dbg.jdi.manager.JdiCause) -> None: ...

    def threadSelected(self, __a0: com.sun.jdi.ThreadReference, __a1: com.sun.jdi.StackFrame, __a2: ghidra.dbg.jdi.manager.JdiCause) -> None: ...

    def threadStarted(self, __a0: com.sun.jdi.event.ThreadStartEvent, __a1: ghidra.dbg.jdi.manager.JdiCause) -> None: ...

    def threadStateChanged(self, __a0: com.sun.jdi.ThreadReference, __a1: int, __a2: ghidra.dbg.jdi.manager.JdiCause, __a3: ghidra.dbg.jdi.manager.JdiReason) -> None: ...

    def toString(self) -> unicode: ...

    def vmDied(self, __a0: com.sun.jdi.event.VMDeathEvent, __a1: ghidra.dbg.jdi.manager.JdiCause) -> None: ...

    def vmDisconnected(self, __a0: com.sun.jdi.event.VMDisconnectEvent, __a1: ghidra.dbg.jdi.manager.JdiCause) -> None: ...

    def vmInterrupted(self) -> None: ...

    def vmSelected(self, __a0: com.sun.jdi.VirtualMachine, __a1: ghidra.dbg.jdi.manager.JdiCause) -> None: ...

    def vmStarted(self, __a0: com.sun.jdi.event.VMStartEvent, __a1: ghidra.dbg.jdi.manager.JdiCause) -> None: ...

    def vmStateChanged(self, __a0: ghidra.dbg.target.TargetExecutionStateful.TargetExecutionState, __a1: ghidra.dbg.jdi.manager.JdiReason) -> None: ...

    @overload
    def wait(self) -> None: ...

    @overload
    def wait(self, __a0: long) -> None: ...

    @overload
    def wait(self, __a0: long, __a1: int) -> None: ...

    def watchpointHit(self, __a0: com.sun.jdi.event.WatchpointEvent, __a1: ghidra.dbg.jdi.manager.JdiCause) -> None: ...

    def watchpointModified(self, __a0: com.sun.jdi.event.ModificationWatchpointEvent, __a1: ghidra.dbg.jdi.manager.JdiCause) -> None: ...

    @property
    def accessible(self) -> bool: ...

    @property
    def classes(self) -> ghidra.dbg.jdi.model.JdiModelTargetClassContainer: ...

    @property
    def display(self) -> unicode: ...

    @property
    def parameters(self) -> ghidra.dbg.target.TargetMethod.TargetParameterMap: ...