from typing import List
import ghidra.dbg.target
import ghidra.dbg.target.schema
import ghidra.dbg.util
import java.lang
import java.util
import java.util.concurrent


class TargetObjectSchema(object):
    DEFAULT_ATTRIBUTE_RESYNC: ghidra.dbg.target.schema.TargetObjectSchema.ResyncMode = NEVER
    DEFAULT_ELEMENT_RESYNC: ghidra.dbg.target.schema.TargetObjectSchema.ResyncMode = NEVER




    class Private(object):




        def __init__(self): ...



        def equals(self, __a0: object) -> bool: ...

        def getClass(self) -> java.lang.Class: ...

        def hashCode(self) -> int: ...

        def notify(self) -> None: ...

        def notifyAll(self) -> None: ...

        def toString(self) -> unicode: ...

        @overload
        def wait(self) -> None: ...

        @overload
        def wait(self, __a0: long) -> None: ...

        @overload
        def wait(self, __a0: long, __a1: int) -> None: ...






    class AttributeSchema(object):
        DEFAULT_ANY: ghidra.dbg.target.schema.TargetObjectSchema.AttributeSchema = <attr name= schema=ANY required=false fixed=false hidden=true>
        DEFAULT_OBJECT: ghidra.dbg.target.schema.TargetObjectSchema.AttributeSchema = <attr name= schema=OBJECT required=false fixed=false hidden=true>
        DEFAULT_VOID: ghidra.dbg.target.schema.TargetObjectSchema.AttributeSchema = <attr name= schema=VOID required=false fixed=true hidden=true>







        def equals(self, __a0: object) -> bool: ...

        def getClass(self) -> java.lang.Class: ...

        def getName(self) -> unicode: ...

        def getSchema(self) -> ghidra.dbg.target.schema.TargetObjectSchema.SchemaName: ...

        def hashCode(self) -> int: ...

        def isFixed(self) -> bool: ...

        def isHidden(self) -> bool: ...

        def isRequired(self) -> bool: ...

        def notify(self) -> None: ...

        def notifyAll(self) -> None: ...

        def toString(self) -> unicode: ...

        @overload
        def wait(self) -> None: ...

        @overload
        def wait(self, __a0: long) -> None: ...

        @overload
        def wait(self, __a0: long, __a1: int) -> None: ...

        @property
        def fixed(self) -> bool: ...

        @property
        def hidden(self) -> bool: ...

        @property
        def name(self) -> unicode: ...

        @property
        def required(self) -> bool: ...

        @property
        def schema(self) -> ghidra.dbg.target.schema.TargetObjectSchema.SchemaName: ...




    class ResyncMode(java.lang.Enum):
        ALWAYS: ghidra.dbg.target.schema.TargetObjectSchema.ResyncMode = ALWAYS
        NEVER: ghidra.dbg.target.schema.TargetObjectSchema.ResyncMode = NEVER
        ONCE: ghidra.dbg.target.schema.TargetObjectSchema.ResyncMode = ONCE







        @overload
        def compareTo(self, __a0: java.lang.Enum) -> int: ...

        @overload
        def compareTo(self, __a0: object) -> int: ...

        def describeConstable(self) -> java.util.Optional: ...

        def equals(self, __a0: object) -> bool: ...

        def getClass(self) -> java.lang.Class: ...

        def getDeclaringClass(self) -> java.lang.Class: ...

        def hashCode(self) -> int: ...

        def name(self) -> unicode: ...

        def notify(self) -> None: ...

        def notifyAll(self) -> None: ...

        def ordinal(self) -> int: ...

        def shouldResync(self, __a0: java.util.concurrent.CompletableFuture) -> bool: ...

        def toString(self) -> unicode: ...

        @overload
        @staticmethod
        def valueOf(__a0: unicode) -> ghidra.dbg.target.schema.TargetObjectSchema.ResyncMode: ...

        @overload
        @staticmethod
        def valueOf(__a0: java.lang.Class, __a1: unicode) -> java.lang.Enum: ...

        @staticmethod
        def values() -> List[ghidra.dbg.target.schema.TargetObjectSchema.ResyncMode]: ...

        @overload
        def wait(self) -> None: ...

        @overload
        def wait(self, __a0: long) -> None: ...

        @overload
        def wait(self, __a0: long, __a1: int) -> None: ...






    class SchemaName(object, java.lang.Comparable):




        def __init__(self, __a0: unicode): ...



        @overload
        def compareTo(self, __a0: ghidra.dbg.target.schema.TargetObjectSchema.SchemaName) -> int: ...

        @overload
        def compareTo(self, __a0: object) -> int: ...

        def equals(self, __a0: object) -> bool: ...

        def getClass(self) -> java.lang.Class: ...

        def hashCode(self) -> int: ...

        def notify(self) -> None: ...

        def notifyAll(self) -> None: ...

        def toString(self) -> unicode: ...

        @overload
        def wait(self) -> None: ...

        @overload
        def wait(self, __a0: long) -> None: ...

        @overload
        def wait(self, __a0: long, __a1: int) -> None: ...







    def computeFrameLevel(self, __a0: List[object]) -> int: ...

    def equals(self, __a0: object) -> bool: ...

    def getAttributeResyncMode(self) -> ghidra.dbg.target.schema.TargetObjectSchema.ResyncMode: ...

    def getAttributeSchema(self, __a0: unicode) -> ghidra.dbg.target.schema.TargetObjectSchema.AttributeSchema: ...

    def getAttributeSchemas(self) -> java.util.Map: ...

    def getChildSchema(self, __a0: unicode) -> ghidra.dbg.target.schema.TargetObjectSchema: ...

    def getChildSchemaName(self, __a0: unicode) -> ghidra.dbg.target.schema.TargetObjectSchema.SchemaName: ...

    def getClass(self) -> java.lang.Class: ...

    def getContext(self) -> ghidra.dbg.target.schema.SchemaContext: ...

    def getDefaultAttributeSchema(self) -> ghidra.dbg.target.schema.TargetObjectSchema.AttributeSchema: ...

    def getDefaultElementSchema(self) -> ghidra.dbg.target.schema.TargetObjectSchema.SchemaName: ...

    def getElementResyncMode(self) -> ghidra.dbg.target.schema.TargetObjectSchema.ResyncMode: ...

    def getElementSchema(self, __a0: unicode) -> ghidra.dbg.target.schema.TargetObjectSchema.SchemaName: ...

    def getElementSchemas(self) -> java.util.Map: ...

    def getInterfaces(self) -> java.util.Set: ...

    def getName(self) -> ghidra.dbg.target.schema.TargetObjectSchema.SchemaName: ...

    def getSuccessorSchema(self, __a0: List[object]) -> ghidra.dbg.target.schema.TargetObjectSchema: ...

    def getType(self) -> java.lang.Class: ...

    def hashCode(self) -> int: ...

    def isCanonicalContainer(self) -> bool: ...

    def isHidden(self, __a0: unicode) -> bool: ...

    def notify(self) -> None: ...

    def notifyAll(self) -> None: ...

    @overload
    def searchFor(self, __a0: java.lang.Class, __a1: bool) -> ghidra.dbg.util.PathMatcher: ...

    @overload
    def searchFor(self, __a0: java.lang.Class, __a1: List[object], __a2: bool) -> ghidra.dbg.util.PathMatcher: ...

    def searchForAncestor(self, __a0: java.lang.Class, __a1: List[object]) -> List[object]: ...

    def searchForCanonicalContainer(self, __a0: java.lang.Class) -> List[object]: ...

    def searchForRegisterContainer(self, __a0: int, __a1: List[object]) -> ghidra.dbg.util.PathPredicates: ...

    def searchForSuitable(self, __a0: java.lang.Class, __a1: List[object]) -> List[object]: ...

    def toString(self) -> unicode: ...

    def validateAttributeDelta(self, __a0: List[object], __a1: ghidra.dbg.util.CollectionUtils.Delta, __a2: bool) -> None: ...

    def validateElementDelta(self, __a0: List[object], __a1: ghidra.dbg.util.CollectionUtils.Delta, __a2: bool) -> None: ...

    def validateRequiredAttributes(self, __a0: ghidra.dbg.target.TargetObject, __a1: bool) -> None: ...

    def validateTypeAndInterfaces(self, __a0: object, __a1: List[object], __a2: unicode, __a3: bool) -> None: ...

    @overload
    def wait(self) -> None: ...

    @overload
    def wait(self, __a0: long) -> None: ...

    @overload
    def wait(self, __a0: long, __a1: int) -> None: ...

    @property
    def attributeResyncMode(self) -> ghidra.dbg.target.schema.TargetObjectSchema.ResyncMode: ...

    @property
    def attributeSchemas(self) -> java.util.Map: ...

    @property
    def canonicalContainer(self) -> bool: ...

    @property
    def context(self) -> ghidra.dbg.target.schema.SchemaContext: ...

    @property
    def defaultAttributeSchema(self) -> ghidra.dbg.target.schema.TargetObjectSchema.AttributeSchema: ...

    @property
    def defaultElementSchema(self) -> ghidra.dbg.target.schema.TargetObjectSchema.SchemaName: ...

    @property
    def elementResyncMode(self) -> ghidra.dbg.target.schema.TargetObjectSchema.ResyncMode: ...

    @property
    def elementSchemas(self) -> java.util.Map: ...

    @property
    def interfaces(self) -> java.util.Set: ...

    @property
    def name(self) -> ghidra.dbg.target.schema.TargetObjectSchema.SchemaName: ...

    @property
    def type(self) -> java.lang.Class: ...