from typing import List
import ghidra.app.plugin.core.debug
import ghidra.app.plugin.core.debug.service.model.launch
import ghidra.app.script
import ghidra.app.services
import ghidra.dbg
import ghidra.dbg.target
import ghidra.debug.flatapi
import ghidra.program.model.address
import ghidra.program.model.lang
import ghidra.program.model.listing
import ghidra.program.util
import ghidra.trace.model
import ghidra.trace.model.breakpoint
import ghidra.trace.model.guest
import ghidra.trace.model.program
import ghidra.trace.model.thread
import ghidra.trace.model.time.schedule
import ghidra.util.task
import java.lang
import java.nio
import java.util
import java.util.concurrent


class FlatDebuggerAPI(object):





    class ExpectingBreakpointChanges(object, java.lang.AutoCloseable):




        def __init__(self, __a0: ghidra.debug.flatapi.FlatDebuggerAPI, __a1: ghidra.app.services.DebuggerLogicalBreakpointService): ...



        def close(self) -> None: ...

        def equals(self, __a0: object) -> bool: ...

        def getClass(self) -> java.lang.Class: ...

        def hashCode(self) -> int: ...

        def notify(self) -> None: ...

        def notifyAll(self) -> None: ...

        def toString(self) -> unicode: ...

        @overload
        def wait(self) -> None: ...

        @overload
        def wait(self, __a0: long) -> None: ...

        @overload
        def wait(self, __a0: long, __a1: int) -> None: ...







    def activateFrame(self, __a0: int) -> None: ...

    def activateSnap(self, __a0: long) -> None: ...

    def activateThread(self, __a0: ghidra.trace.model.thread.TraceThread) -> None: ...

    def activateTrace(self, __a0: ghidra.trace.model.Trace) -> None: ...

    def breakpointSet(self, __a0: ghidra.program.util.ProgramLocation, __a1: long, __a2: ghidra.trace.model.breakpoint.TraceBreakpointKind.TraceBreakpointKindSet, __a3: unicode) -> java.util.Set: ...

    def breakpointSetAccess(self, __a0: ghidra.program.util.ProgramLocation, __a1: int, __a2: unicode) -> java.util.Set: ...

    def breakpointSetHardwareExecute(self, __a0: ghidra.program.util.ProgramLocation, __a1: unicode) -> java.util.Set: ...

    def breakpointSetRead(self, __a0: ghidra.program.util.ProgramLocation, __a1: int, __a2: unicode) -> java.util.Set: ...

    def breakpointSetSoftwareExecute(self, __a0: ghidra.program.util.ProgramLocation, __a1: unicode) -> java.util.Set: ...

    def breakpointSetWrite(self, __a0: ghidra.program.util.ProgramLocation, __a1: int, __a2: unicode) -> java.util.Set: ...

    def breakpointsClear(self, __a0: ghidra.program.util.ProgramLocation) -> bool: ...

    def breakpointsDisable(self, __a0: ghidra.program.util.ProgramLocation) -> java.util.Set: ...

    def breakpointsEnable(self, __a0: ghidra.program.util.ProgramLocation) -> java.util.Set: ...

    def breakpointsToggle(self, __a0: ghidra.program.util.ProgramLocation) -> java.util.Set: ...

    def closeTrace(self, __a0: ghidra.trace.model.Trace) -> None: ...

    @overload
    def createStateEditor(self) -> ghidra.app.services.DebuggerStateEditingService.StateEditor: ...

    @overload
    def createStateEditor(self, __a0: ghidra.app.plugin.core.debug.DebuggerCoordinates) -> ghidra.app.services.DebuggerStateEditingService.StateEditor: ...

    @overload
    def createStateEditor(self, __a0: ghidra.trace.model.Trace, __a1: long) -> ghidra.app.services.DebuggerStateEditingService.StateEditor: ...

    @overload
    def createStateEditor(self, __a0: ghidra.trace.model.thread.TraceThread, __a1: int, __a2: long) -> ghidra.app.services.DebuggerStateEditingService.StateEditor: ...

    @overload
    def dynamicLocation(self, __a0: unicode) -> ghidra.program.util.ProgramLocation: ...

    @overload
    def dynamicLocation(self, __a0: ghidra.program.model.address.Address) -> ghidra.program.util.ProgramLocation: ...

    @overload
    def dynamicLocation(self, __a0: ghidra.trace.model.Trace, __a1: unicode) -> ghidra.program.util.ProgramLocation: ...

    @overload
    def dynamicLocation(self, __a0: ghidra.trace.model.program.TraceProgramView, __a1: unicode) -> ghidra.program.util.ProgramLocation: ...

    @overload
    def dynamicLocation(self, __a0: ghidra.trace.model.Trace, __a1: ghidra.program.model.address.Address) -> ghidra.program.util.ProgramLocation: ...

    @overload
    def dynamicLocation(self, __a0: ghidra.trace.model.program.TraceProgramView, __a1: ghidra.program.model.address.Address) -> ghidra.program.util.ProgramLocation: ...

    @overload
    def dynamicLocation(self, __a0: ghidra.trace.model.Trace, __a1: long, __a2: unicode) -> ghidra.program.util.ProgramLocation: ...

    @overload
    def dynamicLocation(self, __a0: ghidra.trace.model.Trace, __a1: long, __a2: ghidra.program.model.address.Address) -> ghidra.program.util.ProgramLocation: ...

    @overload
    def emulate(self, __a0: ghidra.trace.model.time.schedule.TraceSchedule, __a1: ghidra.util.task.TaskMonitor) -> bool: ...

    @overload
    def emulate(self, __a0: ghidra.trace.model.Trace, __a1: ghidra.trace.model.time.schedule.TraceSchedule, __a2: ghidra.util.task.TaskMonitor) -> bool: ...

    @overload
    def emulate(self, __a0: ghidra.trace.model.guest.TracePlatform, __a1: ghidra.trace.model.time.schedule.TraceSchedule, __a2: ghidra.util.task.TaskMonitor) -> bool: ...

    @overload
    def emulateLaunch(self, __a0: ghidra.program.model.address.Address) -> ghidra.trace.model.Trace: ...

    @overload
    def emulateLaunch(self, __a0: ghidra.program.model.listing.Program, __a1: ghidra.program.model.address.Address) -> ghidra.trace.model.Trace: ...

    def equals(self, __a0: object) -> bool: ...

    @overload
    def execute(self, __a0: unicode) -> bool: ...

    @overload
    def execute(self, __a0: ghidra.dbg.target.TargetInterpreter, __a1: unicode) -> bool: ...

    @overload
    def execute(self, __a0: ghidra.trace.model.Trace, __a1: unicode) -> bool: ...

    @overload
    def executeCapture(self, __a0: unicode) -> unicode: ...

    @overload
    def executeCapture(self, __a0: ghidra.dbg.target.TargetInterpreter, __a1: unicode) -> unicode: ...

    @overload
    def executeCapture(self, __a0: ghidra.trace.model.Trace, __a1: unicode) -> unicode: ...

    def expectBreakpointChanges(self) -> ghidra.debug.flatapi.FlatDebuggerAPI.ExpectingBreakpointChanges: ...

    @overload
    def findInterface(self, __a0: java.lang.Class) -> ghidra.dbg.target.TargetObject: ...

    @overload
    def findInterface(self, __a0: ghidra.dbg.target.TargetObject, __a1: java.lang.Class) -> ghidra.dbg.target.TargetObject: ...

    @overload
    def findInterface(self, __a0: ghidra.trace.model.Trace, __a1: java.lang.Class) -> ghidra.dbg.target.TargetObject: ...

    @overload
    def findInterface(self, __a0: ghidra.trace.model.thread.TraceThread, __a1: java.lang.Class) -> ghidra.dbg.target.TargetObject: ...

    def flushAsyncPipelines(self, __a0: ghidra.trace.model.Trace) -> bool: ...

    def getAllBreakpoints(self) -> java.util.Set: ...

    def getBreakpointService(self) -> ghidra.app.services.DebuggerLogicalBreakpointService: ...

    @overload
    def getBreakpoints(self, __a0: ghidra.program.model.listing.Program) -> java.util.NavigableMap: ...

    @overload
    def getBreakpoints(self, __a0: ghidra.trace.model.Trace) -> java.util.NavigableMap: ...

    def getBreakpointsAt(self, __a0: ghidra.program.util.ProgramLocation) -> java.util.Set: ...

    def getBreakpointsNamed(self, __a0: unicode) -> java.util.Set: ...

    def getClass(self) -> java.lang.Class: ...

    def getCurrentDebuggerAddress(self) -> ghidra.program.model.address.Address: ...

    def getCurrentDebuggerCoordinates(self) -> ghidra.app.plugin.core.debug.DebuggerCoordinates: ...

    def getCurrentDebuggerProgramLocation(self) -> ghidra.program.util.ProgramLocation: ...

    def getCurrentEmulationSchedule(self) -> ghidra.trace.model.time.schedule.TraceSchedule: ...

    def getCurrentFrame(self) -> int: ...

    def getCurrentPlatform(self) -> ghidra.trace.model.guest.TracePlatform: ...

    def getCurrentProgram(self) -> ghidra.program.model.listing.Program: ...

    def getCurrentRecorder(self) -> ghidra.app.services.TraceRecorder: ...

    def getCurrentSnap(self) -> long: ...

    def getCurrentThread(self) -> ghidra.trace.model.thread.TraceThread: ...

    def getCurrentTrace(self) -> ghidra.trace.model.Trace: ...

    def getCurrentView(self) -> ghidra.trace.model.program.TraceProgramView: ...

    def getDebuggerListing(self) -> ghidra.app.services.DebuggerListingService: ...

    def getEditingService(self) -> ghidra.app.services.DebuggerStateEditingService: ...

    def getEmulationService(self) -> ghidra.app.services.DebuggerEmulationService: ...

    @overload
    def getExecutionState(self, __a0: ghidra.dbg.target.TargetObject) -> ghidra.dbg.target.TargetExecutionStateful.TargetExecutionState: ...

    @overload
    def getExecutionState(self, __a0: ghidra.trace.model.Trace) -> ghidra.dbg.target.TargetExecutionStateful.TargetExecutionState: ...

    @overload
    def getExecutionState(self, __a0: ghidra.trace.model.thread.TraceThread) -> ghidra.dbg.target.TargetExecutionStateful.TargetExecutionState: ...

    @overload
    def getLaunchOffers(self) -> List[object]: ...

    @overload
    def getLaunchOffers(self, __a0: ghidra.program.model.listing.Program) -> List[object]: ...

    def getMappingService(self) -> ghidra.app.services.DebuggerStaticMappingService: ...

    def getModelService(self) -> ghidra.app.services.DebuggerModelService: ...

    @overload
    def getModelValue(self, __a0: unicode) -> object: ...

    @overload
    def getModelValue(self, __a0: ghidra.dbg.DebuggerObjectModel, __a1: unicode) -> object: ...

    @overload
    def getProgramCounter(self) -> ghidra.program.model.address.Address: ...

    @overload
    def getProgramCounter(self, __a0: ghidra.app.plugin.core.debug.DebuggerCoordinates) -> ghidra.program.model.address.Address: ...

    @overload
    def getStackPointer(self) -> ghidra.program.model.address.Address: ...

    @overload
    def getStackPointer(self, __a0: ghidra.app.plugin.core.debug.DebuggerCoordinates) -> ghidra.program.model.address.Address: ...

    def getState(self) -> ghidra.app.script.GhidraState: ...

    def getTarget(self, __a0: ghidra.trace.model.Trace) -> ghidra.dbg.target.TargetObject: ...

    def getTargetFocus(self, __a0: ghidra.trace.model.Trace) -> ghidra.dbg.target.TargetObject: ...

    def getTargetThread(self, __a0: ghidra.trace.model.thread.TraceThread) -> ghidra.dbg.target.TargetThread: ...

    def getTrace(self, __a0: ghidra.program.util.ProgramLocation) -> ghidra.trace.model.Trace: ...

    def getTraceManager(self) -> ghidra.app.services.DebuggerTraceManagerService: ...

    @overload
    def goToDynamic(self, __a0: unicode) -> bool: ...

    @overload
    def goToDynamic(self, __a0: ghidra.program.model.address.Address) -> bool: ...

    @overload
    def goToDynamic(self, __a0: ghidra.program.util.ProgramLocation) -> bool: ...

    def hashCode(self) -> int: ...

    @overload
    def interrupt(self) -> bool: ...

    @overload
    def interrupt(self, __a0: ghidra.dbg.target.TargetInterruptible) -> bool: ...

    @overload
    def interrupt(self, __a0: ghidra.trace.model.Trace) -> bool: ...

    @overload
    def interrupt(self, __a0: ghidra.trace.model.thread.TraceThread) -> bool: ...

    @overload
    def isTargetAlive(self) -> bool: ...

    @overload
    def isTargetAlive(self, __a0: ghidra.trace.model.Trace) -> bool: ...

    @overload
    def isThreadAlive(self) -> bool: ...

    @overload
    def isThreadAlive(self, __a0: ghidra.trace.model.thread.TraceThread) -> bool: ...

    @overload
    def kill(self) -> bool: ...

    @overload
    def kill(self, __a0: ghidra.dbg.target.TargetKillable) -> bool: ...

    @overload
    def kill(self, __a0: ghidra.trace.model.Trace) -> bool: ...

    @overload
    def kill(self, __a0: ghidra.trace.model.thread.TraceThread) -> bool: ...

    @overload
    def launch(self, __a0: ghidra.util.task.TaskMonitor) -> ghidra.app.plugin.core.debug.service.model.launch.DebuggerProgramLaunchOffer.LaunchResult: ...

    @overload
    def launch(self, __a0: unicode, __a1: ghidra.util.task.TaskMonitor) -> ghidra.app.plugin.core.debug.service.model.launch.DebuggerProgramLaunchOffer.LaunchResult: ...

    @overload
    def launch(self, __a0: ghidra.app.plugin.core.debug.service.model.launch.DebuggerProgramLaunchOffer, __a1: ghidra.util.task.TaskMonitor) -> ghidra.app.plugin.core.debug.service.model.launch.DebuggerProgramLaunchOffer.LaunchResult: ...

    @overload
    def launch(self, __a0: ghidra.program.model.listing.Program, __a1: ghidra.util.task.TaskMonitor) -> ghidra.app.plugin.core.debug.service.model.launch.DebuggerProgramLaunchOffer.LaunchResult: ...

    @overload
    def launch(self, __a0: ghidra.app.plugin.core.debug.service.model.launch.DebuggerProgramLaunchOffer, __a1: unicode, __a2: ghidra.util.task.TaskMonitor) -> ghidra.app.plugin.core.debug.service.model.launch.DebuggerProgramLaunchOffer.LaunchResult: ...

    @overload
    def launch(self, __a0: ghidra.program.model.listing.Program, __a1: unicode, __a2: ghidra.util.task.TaskMonitor) -> ghidra.app.plugin.core.debug.service.model.launch.DebuggerProgramLaunchOffer.LaunchResult: ...

    def notify(self) -> None: ...

    def notifyAll(self) -> None: ...

    def openTrace(self, __a0: ghidra.trace.model.Trace) -> None: ...

    def patchEmu(self, __a0: unicode, __a1: ghidra.util.task.TaskMonitor) -> bool: ...

    @overload
    def readMemory(self, __a0: ghidra.program.model.address.Address, __a1: int, __a2: ghidra.util.task.TaskMonitor) -> List[int]: ...

    @overload
    def readMemory(self, __a0: ghidra.program.model.address.Address, __a1: List[int], __a2: ghidra.util.task.TaskMonitor) -> int: ...

    @overload
    def readMemory(self, __a0: ghidra.trace.model.Trace, __a1: long, __a2: ghidra.program.model.address.Address, __a3: int, __a4: ghidra.util.task.TaskMonitor) -> List[int]: ...

    @overload
    def readMemory(self, __a0: ghidra.trace.model.Trace, __a1: long, __a2: ghidra.program.model.address.Address, __a3: List[int], __a4: ghidra.util.task.TaskMonitor) -> int: ...

    @overload
    def readRegister(self, __a0: unicode) -> ghidra.program.model.lang.RegisterValue: ...

    @overload
    def readRegister(self, __a0: ghidra.program.model.lang.Register) -> ghidra.program.model.lang.RegisterValue: ...

    @overload
    def readRegister(self, __a0: ghidra.trace.model.guest.TracePlatform, __a1: ghidra.program.model.lang.Register) -> ghidra.program.model.lang.RegisterValue: ...

    @overload
    def readRegister(self, __a0: ghidra.trace.model.guest.TracePlatform, __a1: ghidra.trace.model.thread.TraceThread, __a2: int, __a3: long, __a4: ghidra.program.model.lang.Register) -> ghidra.program.model.lang.RegisterValue: ...

    @overload
    def readRegisters(self, __a0: java.util.Collection) -> List[object]: ...

    @overload
    def readRegisters(self, __a0: ghidra.trace.model.guest.TracePlatform, __a1: ghidra.trace.model.thread.TraceThread, __a2: int, __a3: long, __a4: java.util.Collection) -> List[object]: ...

    def readRegistersNamed(self, __a0: java.util.Collection) -> List[object]: ...

    def refreshMemoryIfLive(self, __a0: ghidra.trace.model.Trace, __a1: long, __a2: ghidra.program.model.address.Address, __a3: int, __a4: ghidra.util.task.TaskMonitor) -> None: ...

    def refreshObjectChildren(self, __a0: ghidra.dbg.target.TargetObject) -> java.util.Set: ...

    def refreshRegistersIfLive(self, __a0: ghidra.trace.model.guest.TracePlatform, __a1: ghidra.trace.model.thread.TraceThread, __a2: int, __a3: long, __a4: java.util.Collection) -> None: ...

    def refreshSubtree(self, __a0: ghidra.dbg.target.TargetObject) -> bool: ...

    def requireCurrentPlatform(self) -> ghidra.trace.model.guest.TracePlatform: ...

    def requireCurrentProgram(self) -> ghidra.program.model.listing.Program: ...

    def requireCurrentThread(self) -> ghidra.trace.model.thread.TraceThread: ...

    def requireCurrentTrace(self) -> ghidra.trace.model.Trace: ...

    def requireCurrentView(self) -> ghidra.trace.model.program.TraceProgramView: ...

    def requireLaunchOffer(self, __a0: ghidra.program.model.listing.Program) -> ghidra.app.plugin.core.debug.service.model.launch.DebuggerProgramLaunchOffer: ...

    def requirePlatform(self, __a0: ghidra.trace.model.guest.TracePlatform) -> ghidra.trace.model.guest.TracePlatform: ...

    def requireService(self, __a0: java.lang.Class) -> object: ...

    def requireThread(self, __a0: ghidra.trace.model.thread.TraceThread) -> ghidra.trace.model.thread.TraceThread: ...

    def requireTrace(self, __a0: ghidra.trace.model.Trace) -> ghidra.trace.model.Trace: ...

    @overload
    def resume(self) -> bool: ...

    @overload
    def resume(self, __a0: ghidra.dbg.target.TargetResumable) -> bool: ...

    @overload
    def resume(self, __a0: ghidra.trace.model.Trace) -> bool: ...

    @overload
    def resume(self, __a0: ghidra.trace.model.thread.TraceThread) -> bool: ...

    def safeRange(self, __a0: ghidra.program.model.address.Address, __a1: int) -> ghidra.program.model.address.AddressRange: ...

    @overload
    def searchMemory(self, __a0: ghidra.trace.model.Trace, __a1: long, __a2: ghidra.program.model.address.AddressRange, __a3: List[int], __a4: List[int], __a5: bool, __a6: ghidra.util.task.TaskMonitor) -> ghidra.program.model.address.Address: ...

    @overload
    def searchMemory(self, __a0: ghidra.trace.model.Trace, __a1: long, __a2: ghidra.program.model.address.AddressRange, __a3: java.nio.ByteBuffer, __a4: java.nio.ByteBuffer, __a5: bool, __a6: ghidra.util.task.TaskMonitor) -> ghidra.program.model.address.Address: ...

    @overload
    def setEditingMode(self, __a0: ghidra.app.services.DebuggerStateEditingService.StateEditingMode) -> None: ...

    @overload
    def setEditingMode(self, __a0: ghidra.trace.model.Trace, __a1: ghidra.app.services.DebuggerStateEditingService.StateEditingMode) -> None: ...

    def skipEmuInstruction(self, __a0: long, __a1: ghidra.util.task.TaskMonitor) -> bool: ...

    def skipEmuPcodeOp(self, __a0: int, __a1: ghidra.util.task.TaskMonitor) -> bool: ...

    @overload
    def staticLocation(self, __a0: unicode) -> ghidra.program.util.ProgramLocation: ...

    @overload
    def staticLocation(self, __a0: ghidra.program.model.address.Address) -> ghidra.program.util.ProgramLocation: ...

    @overload
    def staticLocation(self, __a0: ghidra.program.model.listing.Program, __a1: unicode) -> ghidra.program.util.ProgramLocation: ...

    @overload
    def staticLocation(self, __a0: ghidra.program.model.listing.Program, __a1: ghidra.program.model.address.Address) -> ghidra.program.util.ProgramLocation: ...

    @overload
    def step(self, __a0: ghidra.dbg.target.TargetSteppable, __a1: ghidra.dbg.target.TargetSteppable.TargetStepKind) -> bool: ...

    @overload
    def step(self, __a0: ghidra.trace.model.thread.TraceThread, __a1: ghidra.dbg.target.TargetSteppable.TargetStepKind) -> bool: ...

    def stepEmuInstruction(self, __a0: long, __a1: ghidra.util.task.TaskMonitor) -> bool: ...

    def stepEmuPcodeOp(self, __a0: int, __a1: ghidra.util.task.TaskMonitor) -> bool: ...

    def stepInto(self) -> bool: ...

    def stepOut(self) -> bool: ...

    def stepOver(self) -> bool: ...

    def toString(self) -> unicode: ...

    @overload
    def translateDynamicToStatic(self, __a0: ghidra.program.model.address.Address) -> ghidra.program.model.address.Address: ...

    @overload
    def translateDynamicToStatic(self, __a0: ghidra.program.util.ProgramLocation) -> ghidra.program.util.ProgramLocation: ...

    @overload
    def translateStaticToDynamic(self, __a0: ghidra.program.model.address.Address) -> ghidra.program.model.address.Address: ...

    @overload
    def translateStaticToDynamic(self, __a0: ghidra.program.util.ProgramLocation) -> ghidra.program.util.ProgramLocation: ...

    def validateRegisterName(self, __a0: ghidra.program.model.lang.Language, __a1: unicode) -> ghidra.program.model.lang.Register: ...

    def validateRegisterNames(self, __a0: ghidra.program.model.lang.Language, __a1: java.util.Collection) -> List[object]: ...

    @overload
    def wait(self) -> None: ...

    @overload
    def wait(self, __a0: long) -> None: ...

    @overload
    def wait(self, __a0: long, __a1: int) -> None: ...

    @overload
    def waitForBreak(self, __a0: long, __a1: java.util.concurrent.TimeUnit) -> None: ...

    @overload
    def waitForBreak(self, __a0: ghidra.dbg.target.TargetObject, __a1: long, __a2: java.util.concurrent.TimeUnit) -> None: ...

    @overload
    def waitForBreak(self, __a0: ghidra.trace.model.Trace, __a1: long, __a2: java.util.concurrent.TimeUnit) -> None: ...

    def waitOn(self, __a0: java.util.concurrent.CompletableFuture) -> object: ...

    @overload
    def writeMemory(self, __a0: ghidra.program.model.address.Address, __a1: List[int]) -> bool: ...

    @overload
    def writeMemory(self, __a0: ghidra.app.services.DebuggerStateEditingService.StateEditor, __a1: ghidra.program.model.address.Address, __a2: List[int]) -> bool: ...

    @overload
    def writeMemory(self, __a0: ghidra.trace.model.Trace, __a1: long, __a2: ghidra.program.model.address.Address, __a3: List[int]) -> bool: ...

    @overload
    def writeRegister(self, __a0: ghidra.program.model.lang.RegisterValue) -> bool: ...

    @overload
    def writeRegister(self, __a0: unicode, __a1: long) -> bool: ...

    @overload
    def writeRegister(self, __a0: ghidra.app.services.DebuggerStateEditingService.StateEditor, __a1: ghidra.program.model.lang.RegisterValue) -> bool: ...

    @overload
    def writeRegister(self, __a0: ghidra.trace.model.thread.TraceThread, __a1: int, __a2: long, __a3: ghidra.program.model.lang.RegisterValue) -> bool: ...

    @overload
    def writeRegister(self, __a0: ghidra.trace.model.thread.TraceThread, __a1: int, __a2: long, __a3: unicode, __a4: long) -> bool: ...

    @property
    def allBreakpoints(self) -> java.util.Set: ...

    @property
    def breakpointService(self) -> ghidra.app.services.DebuggerLogicalBreakpointService: ...

    @property
    def currentDebuggerAddress(self) -> ghidra.program.model.address.Address: ...

    @property
    def currentDebuggerCoordinates(self) -> ghidra.app.plugin.core.debug.DebuggerCoordinates: ...

    @property
    def currentDebuggerProgramLocation(self) -> ghidra.program.util.ProgramLocation: ...

    @property
    def currentEmulationSchedule(self) -> ghidra.trace.model.time.schedule.TraceSchedule: ...

    @property
    def currentFrame(self) -> int: ...

    @property
    def currentPlatform(self) -> ghidra.trace.model.guest.TracePlatform: ...

    @property
    def currentProgram(self) -> ghidra.program.model.listing.Program: ...

    @property
    def currentRecorder(self) -> ghidra.app.services.TraceRecorder: ...

    @property
    def currentSnap(self) -> long: ...

    @property
    def currentThread(self) -> ghidra.trace.model.thread.TraceThread: ...

    @property
    def currentTrace(self) -> ghidra.trace.model.Trace: ...

    @property
    def currentView(self) -> ghidra.trace.model.program.TraceProgramView: ...

    @property
    def debuggerListing(self) -> ghidra.app.services.DebuggerListingService: ...

    @property
    def editingMode(self) -> None: ...  # No getter available.

    @editingMode.setter
    def editingMode(self, value: ghidra.app.services.DebuggerStateEditingService.StateEditingMode) -> None: ...

    @property
    def editingService(self) -> ghidra.app.services.DebuggerStateEditingService: ...

    @property
    def emulationService(self) -> ghidra.app.services.DebuggerEmulationService: ...

    @property
    def launchOffers(self) -> List[object]: ...

    @property
    def mappingService(self) -> ghidra.app.services.DebuggerStaticMappingService: ...

    @property
    def modelService(self) -> ghidra.app.services.DebuggerModelService: ...

    @property
    def programCounter(self) -> ghidra.program.model.address.Address: ...

    @property
    def stackPointer(self) -> ghidra.program.model.address.Address: ...

    @property
    def state(self) -> ghidra.app.script.GhidraState: ...

    @property
    def targetAlive(self) -> bool: ...

    @property
    def threadAlive(self) -> bool: ...

    @property
    def traceManager(self) -> ghidra.app.services.DebuggerTraceManagerService: ...