from typing import List
import docking
import docking.action
import docking.actions
import ghidra.app.plugin.core.functioncompare
import ghidra.feature.vt.api.main
import ghidra.feature.vt.gui.filters
import ghidra.feature.vt.gui.plugin
import ghidra.feature.vt.gui.util
import ghidra.framework.model
import ghidra.framework.options
import ghidra.framework.plugintool
import ghidra.program.util
import ghidra.util
import java.awt.event
import java.lang
import javax.swing


class VTMarkupItemsTableProvider(ghidra.framework.plugintool.ComponentProviderAdapter, ghidra.feature.vt.gui.filters.FilterDialogModel, ghidra.feature.vt.gui.plugin.VTControllerListener, docking.actions.PopupActionProvider):




    def __init__(self, __a0: ghidra.feature.vt.gui.plugin.VTController): ...



    def addFilter(self, __a0: ghidra.feature.vt.gui.filters.Filter) -> None: ...

    def addLocalAction(self, __a0: docking.action.DockingActionIf) -> None: ...

    def addToTool(self) -> None: ...

    def canBeParent(self) -> bool: ...

    def closeComponent(self) -> None: ...

    def componentActivated(self) -> None: ...

    def componentDeactived(self) -> None: ...

    def componentHidden(self) -> None: ...

    def componentShown(self) -> None: ...

    def contextChanged(self) -> None: ...

    def dialogVisibilityChanged(self, __a0: bool) -> None: ...

    def disposed(self) -> None: ...

    def equals(self, __a0: object) -> bool: ...

    def forceRefilter(self) -> None: ...

    def getActionContext(self, __a0: java.awt.event.MouseEvent) -> docking.ActionContext: ...

    def getClass(self) -> java.lang.Class: ...

    def getComponent(self) -> javax.swing.JComponent: ...

    def getContextType(self) -> java.lang.Class: ...

    def getDefaultWindowPosition(self) -> docking.WindowPosition: ...

    def getFunctionComparisonPanel(self) -> ghidra.app.plugin.core.functioncompare.FunctionComparisonPanel: ...

    def getHelpInfo(self) -> unicode: ...

    def getHelpLocation(self) -> ghidra.util.HelpLocation: ...

    def getHelpObject(self) -> object: ...

    def getIcon(self) -> javax.swing.Icon: ...

    def getInstanceID(self) -> long: ...

    def getIntraGroupPosition(self) -> docking.WindowPosition: ...

    @staticmethod
    def getMappedName(__a0: unicode, __a1: unicode) -> unicode: ...

    @staticmethod
    def getMappedOwner(__a0: unicode, __a1: unicode) -> unicode: ...

    def getName(self) -> unicode: ...

    def getOwner(self) -> unicode: ...

    def getPopupActions(self, __a0: docking.Tool, __a1: docking.ActionContext) -> List[object]: ...

    def getSubTitle(self) -> unicode: ...

    def getTabText(self) -> unicode: ...

    def getTitle(self) -> unicode: ...

    def getTool(self) -> docking.Tool: ...

    def getWindowGroup(self) -> unicode: ...

    def getWindowSubMenuName(self) -> unicode: ...

    def hashCode(self) -> int: ...

    def isActive(self) -> bool: ...

    def isDualListingShowing(self) -> bool: ...

    def isFocusedProvider(self) -> bool: ...

    def isInTool(self) -> bool: ...

    def isSnapshot(self) -> bool: ...

    def isTransient(self) -> bool: ...

    def isVisible(self) -> bool: ...

    def load(self, __a0: ghidra.feature.vt.gui.util.MatchInfo) -> None: ...

    def markupItemSelected(self, __a0: ghidra.feature.vt.api.main.VTMarkupItem) -> None: ...

    def matchSelected(self, __a0: ghidra.feature.vt.gui.util.MatchInfo) -> None: ...

    def notify(self) -> None: ...

    def notifyAll(self) -> None: ...

    def optionsChanged(self, __a0: ghidra.framework.options.Options) -> None: ...

    def processDestinationLocationChange(self, __a0: ghidra.program.util.ProgramLocation) -> None: ...

    def processSourceLocationChange(self, __a0: ghidra.program.util.ProgramLocation) -> None: ...

    def readConfigState(self, __a0: ghidra.framework.options.SaveState) -> None: ...

    @staticmethod
    def registerProviderNameOwnerChange(__a0: unicode, __a1: unicode, __a2: unicode, __a3: unicode) -> None: ...

    def reload(self) -> None: ...

    def removeFromTool(self) -> None: ...

    def requestFocus(self) -> None: ...

    def sessionChanged(self, __a0: ghidra.feature.vt.api.main.VTSession) -> None: ...

    def sessionUpdated(self, __a0: ghidra.framework.model.DomainObjectChangedEvent) -> None: ...

    def setHelpLocation(self, __a0: ghidra.util.HelpLocation) -> None: ...

    def setIntraGroupPosition(self, __a0: docking.WindowPosition) -> None: ...

    def setSubTitle(self, __a0: unicode) -> None: ...

    def setTabText(self, __a0: unicode) -> None: ...

    def setTitle(self, __a0: unicode) -> None: ...

    def setVisible(self, __a0: bool) -> None: ...

    def toFront(self) -> None: ...

    def toString(self) -> unicode: ...

    @overload
    def wait(self) -> None: ...

    @overload
    def wait(self, __a0: long) -> None: ...

    @overload
    def wait(self, __a0: long, __a1: int) -> None: ...

    def writeConfigState(self, __a0: ghidra.framework.options.SaveState) -> None: ...

    @property
    def component(self) -> javax.swing.JComponent: ...

    @property
    def dualListingShowing(self) -> bool: ...

    @property
    def functionComparisonPanel(self) -> ghidra.app.plugin.core.functioncompare.FunctionComparisonPanel: ...