import ghidra.app.util.bin
import ghidra.file.formats.android.art
import ghidra.program.model.data
import java.lang


class ArtBlock(object, ghidra.app.util.bin.StructConverter, ghidra.file.formats.android.art.ArtCompression):
    ASCII: ghidra.program.model.data.DataType = char
    BYTE: ghidra.program.model.data.DataType = byte
    DWORD: ghidra.program.model.data.DataType = dword
    IBO32: ghidra.program.model.data.DataType = IBO32DataType: typedef ImageBaseOffset32 pointer32
    IBO64: ghidra.program.model.data.DataType = IBO64DataType: typedef ImageBaseOffset64 pointer64
    POINTER: ghidra.program.model.data.DataType = pointer
    QWORD: ghidra.program.model.data.DataType = qword
    STRING: ghidra.program.model.data.DataType = string
    UTF16: ghidra.program.model.data.DataType = unicode
    UTF8: ghidra.program.model.data.DataType = string-utf8
    VOID: ghidra.program.model.data.DataType = void
    WORD: ghidra.program.model.data.DataType = word



    def __init__(self, __a0: ghidra.app.util.bin.BinaryReader): ...



    def equals(self, __a0: object) -> bool: ...

    def getClass(self) -> java.lang.Class: ...

    def getCompressedOffset(self) -> long: ...

    def getCompressedSize(self) -> int: ...

    def getDataOffset(self) -> int: ...

    def getDataSize(self) -> int: ...

    def getDecompressedOffset(self) -> long: ...

    def getDecompressedSize(self) -> int: ...

    def getImageOffset(self) -> int: ...

    def getImageSize(self) -> int: ...

    def getStorageMode(self) -> ghidra.file.formats.android.art.ArtStorageMode: ...

    def hashCode(self) -> int: ...

    def notify(self) -> None: ...

    def notifyAll(self) -> None: ...

    def toDataType(self) -> ghidra.program.model.data.DataType: ...

    def toString(self) -> unicode: ...

    @overload
    def wait(self) -> None: ...

    @overload
    def wait(self, __a0: long) -> None: ...

    @overload
    def wait(self, __a0: long, __a1: int) -> None: ...

    @property
    def compressedOffset(self) -> long: ...

    @property
    def compressedSize(self) -> int: ...

    @property
    def dataOffset(self) -> int: ...

    @property
    def dataSize(self) -> int: ...

    @property
    def decompressedOffset(self) -> long: ...

    @property
    def decompressedSize(self) -> int: ...

    @property
    def imageOffset(self) -> int: ...

    @property
    def imageSize(self) -> int: ...

    @property
    def storageMode(self) -> ghidra.file.formats.android.art.ArtStorageMode: ...