import ghidra.app.util.bin
import ghidra.program.model.data
import ghidra.program.model.listing
import ghidra.util.task
import java.lang


class ArtHeader(object, ghidra.app.util.bin.StructConverter):
    ASCII: ghidra.program.model.data.DataType = char
    BYTE: ghidra.program.model.data.DataType = byte
    DWORD: ghidra.program.model.data.DataType = dword
    IBO32: ghidra.program.model.data.DataType = IBO32DataType: typedef ImageBaseOffset32 pointer32
    IBO64: ghidra.program.model.data.DataType = IBO64DataType: typedef ImageBaseOffset64 pointer64
    POINTER: ghidra.program.model.data.DataType = pointer
    QWORD: ghidra.program.model.data.DataType = qword
    STRING: ghidra.program.model.data.DataType = string
    UTF16: ghidra.program.model.data.DataType = unicode
    UTF8: ghidra.program.model.data.DataType = string-utf8
    VOID: ghidra.program.model.data.DataType = void
    WORD: ghidra.program.model.data.DataType = word







    def equals(self, __a0: object) -> bool: ...

    def getArtMethodCountForVersion(self) -> int: ...

    def getClass(self) -> java.lang.Class: ...

    def getImageBegin(self) -> int: ...

    def getImageSize(self) -> int: ...

    def getMagic(self) -> unicode: ...

    def getOatChecksum(self) -> int: ...

    def getOatDataBegin(self) -> int: ...

    def getOatDataEnd(self) -> int: ...

    def getOatFileBegin(self) -> int: ...

    def getOatFileEnd(self) -> int: ...

    def getPointerSize(self) -> int: ...

    def getVersion(self) -> unicode: ...

    def hashCode(self) -> int: ...

    def markup(self, __a0: ghidra.program.model.listing.Program, __a1: ghidra.util.task.TaskMonitor) -> None: ...

    def notify(self) -> None: ...

    def notifyAll(self) -> None: ...

    def toDataType(self) -> ghidra.program.model.data.DataType: ...

    def toString(self) -> unicode: ...

    @overload
    def wait(self) -> None: ...

    @overload
    def wait(self, __a0: long) -> None: ...

    @overload
    def wait(self, __a0: long, __a1: int) -> None: ...

    @property
    def artMethodCountForVersion(self) -> int: ...

    @property
    def imageBegin(self) -> int: ...

    @property
    def imageSize(self) -> int: ...

    @property
    def magic(self) -> unicode: ...

    @property
    def oatChecksum(self) -> int: ...

    @property
    def oatDataBegin(self) -> int: ...

    @property
    def oatDataEnd(self) -> int: ...

    @property
    def oatFileBegin(self) -> int: ...

    @property
    def oatFileEnd(self) -> int: ...

    @property
    def pointerSize(self) -> int: ...

    @property
    def version(self) -> unicode: ...