import ghidra.app.util.bin
import ghidra.program.model.data
import java.lang


class BootImageHeader(object, ghidra.app.util.bin.StructConverter):
    ASCII: ghidra.program.model.data.DataType = char
    BYTE: ghidra.program.model.data.DataType = byte
    DWORD: ghidra.program.model.data.DataType = dword
    IBO32: ghidra.program.model.data.DataType = IBO32DataType: typedef ImageBaseOffset32 pointer32
    IBO64: ghidra.program.model.data.DataType = IBO64DataType: typedef ImageBaseOffset64 pointer64
    POINTER: ghidra.program.model.data.DataType = pointer
    QWORD: ghidra.program.model.data.DataType = qword
    STRING: ghidra.program.model.data.DataType = string
    UTF16: ghidra.program.model.data.DataType = unicode
    UTF8: ghidra.program.model.data.DataType = string-utf8
    VOID: ghidra.program.model.data.DataType = void
    WORD: ghidra.program.model.data.DataType = word



    def __init__(self): ...



    def equals(self, __a0: object) -> bool: ...

    def getClass(self) -> java.lang.Class: ...

    def getCommandLine(self) -> unicode: ...

    def getKernelOffset(self) -> long: ...

    def getKernelPageCount(self) -> int: ...

    def getKernelSize(self) -> int: ...

    def getMagic(self) -> unicode: ...

    def getPageSize(self) -> int: ...

    def getRamdiskOffset(self) -> int: ...

    def getRamdiskPageCount(self) -> int: ...

    def getRamdiskSize(self) -> int: ...

    def getSecondOffset(self) -> long: ...

    def getSecondPageCount(self) -> int: ...

    def getSecondSize(self) -> int: ...

    def hashCode(self) -> int: ...

    def notify(self) -> None: ...

    def notifyAll(self) -> None: ...

    def pageAlign(self, __a0: long) -> long: ...

    def toDataType(self) -> ghidra.program.model.data.DataType: ...

    def toString(self) -> unicode: ...

    @overload
    def wait(self) -> None: ...

    @overload
    def wait(self, __a0: long) -> None: ...

    @overload
    def wait(self, __a0: long, __a1: int) -> None: ...

    @property
    def commandLine(self) -> unicode: ...

    @property
    def kernelOffset(self) -> long: ...

    @property
    def kernelPageCount(self) -> int: ...

    @property
    def kernelSize(self) -> int: ...

    @property
    def magic(self) -> unicode: ...

    @property
    def pageSize(self) -> int: ...

    @property
    def ramdiskOffset(self) -> int: ...

    @property
    def ramdiskPageCount(self) -> int: ...

    @property
    def ramdiskSize(self) -> int: ...

    @property
    def secondOffset(self) -> long: ...

    @property
    def secondPageCount(self) -> int: ...

    @property
    def secondSize(self) -> int: ...