from typing import List
import ghidra.file.formats.android.fbpk
import ghidra.program.model.data
import java.lang


class FBPKv2(object, ghidra.file.formats.android.fbpk.FBPK):
    ASCII: ghidra.program.model.data.DataType = char
    BYTE: ghidra.program.model.data.DataType = byte
    DWORD: ghidra.program.model.data.DataType = dword
    IBO32: ghidra.program.model.data.DataType = IBO32DataType: typedef ImageBaseOffset32 pointer32
    IBO64: ghidra.program.model.data.DataType = IBO64DataType: typedef ImageBaseOffset64 pointer64
    POINTER: ghidra.program.model.data.DataType = pointer
    QWORD: ghidra.program.model.data.DataType = qword
    STRING: ghidra.program.model.data.DataType = string
    UTF16: ghidra.program.model.data.DataType = unicode
    UTF8: ghidra.program.model.data.DataType = string-utf8
    VOID: ghidra.program.model.data.DataType = void
    WORD: ghidra.program.model.data.DataType = word



    def __init__(self, __a0: ghidra.app.util.bin.BinaryReader): ...



    def equals(self, __a0: object) -> bool: ...

    def getClass(self) -> java.lang.Class: ...

    def getMagic(self) -> int: ...

    def getPartitionCount(self) -> int: ...

    def getPartitions(self) -> List[object]: ...

    def getSize(self) -> int: ...

    def getString1(self) -> unicode: ...

    def getString2(self) -> unicode: ...

    def getUnknown1(self) -> int: ...

    def getUnknown2(self) -> int: ...

    def getUnknown3(self) -> int: ...

    def getVersion(self) -> int: ...

    def hashCode(self) -> int: ...

    def notify(self) -> None: ...

    def notifyAll(self) -> None: ...

    def toDataType(self) -> ghidra.program.model.data.DataType: ...

    def toString(self) -> unicode: ...

    @overload
    def wait(self) -> None: ...

    @overload
    def wait(self, __a0: long) -> None: ...

    @overload
    def wait(self, __a0: long, __a1: int) -> None: ...

    @property
    def magic(self) -> int: ...

    @property
    def partitionCount(self) -> int: ...

    @property
    def partitions(self) -> List[object]: ...

    @property
    def size(self) -> int: ...

    @property
    def string1(self) -> unicode: ...

    @property
    def string2(self) -> unicode: ...

    @property
    def unknown1(self) -> int: ...

    @property
    def unknown2(self) -> int: ...

    @property
    def unknown3(self) -> int: ...

    @property
    def version(self) -> int: ...