import ghidra.app.util.bin
import ghidra.program.model.data
import java.lang


class KdDebuggerData(object, ghidra.app.util.bin.StructConverter):
    ASCII: ghidra.program.model.data.DataType = char
    BYTE: ghidra.program.model.data.DataType = byte
    DWORD: ghidra.program.model.data.DataType = dword
    IBO32: ghidra.program.model.data.DataType = IBO32DataType: typedef ImageBaseOffset32 pointer32
    IBO64: ghidra.program.model.data.DataType = IBO64DataType: typedef ImageBaseOffset64 pointer64
    NAME: unicode = u'_KD_DEBUGGER_DATA'
    POINTER: ghidra.program.model.data.DataType = pointer
    QWORD: ghidra.program.model.data.DataType = qword
    STRING: ghidra.program.model.data.DataType = string
    UTF16: ghidra.program.model.data.DataType = unicode
    UTF8: ghidra.program.model.data.DataType = string-utf8
    VOID: ghidra.program.model.data.DataType = void
    WORD: ghidra.program.model.data.DataType = word







    def equals(self, __a0: object) -> bool: ...

    def getBreakpointWithStatus(self) -> long: ...

    def getClass(self) -> java.lang.Class: ...

    def getCmNtCSDVersion(self) -> long: ...

    def getEtwpDebuggerData(self) -> long: ...

    def getExpNumberOfPagedPools(self) -> long: ...

    def getExpPagedPoolDescriptor(self) -> long: ...

    def getExpSystemResourcesList(self) -> long: ...

    def getFlags(self) -> int: ...

    def getFramePointer(self) -> int: ...

    def getGdt64R3CmCode(self) -> int: ...

    def getGdt64R3CmTeb(self) -> int: ...

    def getGdtLdt(self) -> int: ...

    def getGdtR0Code(self) -> int: ...

    def getGdtR0Data(self) -> int: ...

    def getGdtR0Pcr(self) -> int: ...

    def getGdtR3Code(self) -> int: ...

    def getGdtR3Data(self) -> int: ...

    def getGdtR3Teb(self) -> int: ...

    def getGdtTss(self) -> int: ...

    def getIopErrorLogListHead(self) -> long: ...

    def getIopNumTriageDumpDataBlocks(self) -> long: ...

    def getIopTriageDumpDataBlocks(self) -> long: ...

    def getKdPrintBufferSize(self) -> long: ...

    def getKdPrintCircularBuffer(self) -> long: ...

    def getKdPrintCircularBufferEnd(self) -> long: ...

    def getKdPrintCircularBufferPtr(self) -> long: ...

    def getKdPrintRolloverCount(self) -> long: ...

    def getKdPrintWritePointer(self) -> long: ...

    def getKeBugCheckCallbackListHead(self) -> long: ...

    def getKeLoaderBlock(self) -> long: ...

    def getKeTimeIncrement(self) -> long: ...

    def getKeUserCallbackDispatcher(self) -> long: ...

    def getKernBase(self) -> long: ...

    def getKernelVerifier(self) -> long: ...

    def getKiBugcheckData(self) -> long: ...

    def getKiCallUserMode(self) -> long: ...

    def getKiNormalSystemCall(self) -> long: ...

    def getKiProcessorBlock(self) -> long: ...

    def getL1tfHighPhysicalBitIndex(self) -> int: ...

    def getL1tfSwizzleBitIndex(self) -> int: ...

    def getList_Blink(self) -> long: ...

    def getList_Flink(self) -> long: ...

    def getMmAllocatedNonPagedPool(self) -> long: ...

    def getMmAvailablePages(self) -> long: ...

    def getMmBadPagesDetected(self) -> long: ...

    def getMmDriverCommit(self) -> long: ...

    def getMmExtendedCommit(self) -> long: ...

    def getMmFreePageListHead(self) -> long: ...

    def getMmHighestPhysicalPage(self) -> long: ...

    def getMmHighestUserAddress(self) -> long: ...

    def getMmLastUnloadedDriver(self) -> long: ...

    def getMmLoadedUserImageList(self) -> long: ...

    def getMmLowestPhysicalPage(self) -> long: ...

    def getMmMaximumNonPagedPoolInBytes(self) -> long: ...

    def getMmModifiedNoWritePageListHead(self) -> long: ...

    def getMmModifiedPageListHead(self) -> long: ...

    def getMmNonPagedPoolEnd(self) -> long: ...

    def getMmNonPagedPoolStart(self) -> long: ...

    def getMmNonPagedSystemStart(self) -> long: ...

    def getMmNumberOfPagingFiles(self) -> long: ...

    def getMmNumberOfPhysicalPages(self) -> long: ...

    def getMmPageSize(self) -> long: ...

    def getMmPagedPoolCommit(self) -> long: ...

    def getMmPagedPoolEnd(self) -> long: ...

    def getMmPagedPoolInformation(self) -> long: ...

    def getMmPagedPoolStart(self) -> long: ...

    def getMmPeakCommitment(self) -> long: ...

    def getMmPfnDatabase(self) -> long: ...

    def getMmPhysicalMemoryBlock(self) -> long: ...

    def getMmProcessCommit(self) -> long: ...

    def getMmResidentAvailablePages(self) -> long: ...

    def getMmSessionBase(self) -> long: ...

    def getMmSessionSize(self) -> long: ...

    def getMmSharedCommit(self) -> long: ...

    def getMmSizeOfPagedPoolInBytes(self) -> long: ...

    def getMmSpecialPoolTag(self) -> long: ...

    def getMmStandbyPageListHead(self) -> long: ...

    def getMmSubsectionBase(self) -> long: ...

    def getMmSystemCacheEnd(self) -> long: ...

    def getMmSystemCacheStart(self) -> long: ...

    def getMmSystemCacheWs(self) -> long: ...

    def getMmSystemParentTablePage(self) -> long: ...

    def getMmSystemPtesEnd(self) -> long: ...

    def getMmSystemPtesStart(self) -> long: ...

    def getMmSystemRangeStart(self) -> long: ...

    def getMmTotalCommitLimit(self) -> long: ...

    def getMmTotalCommitLimitMaximum(self) -> long: ...

    def getMmTotalCommittedPages(self) -> long: ...

    def getMmTriageActionTaken(self) -> long: ...

    def getMmUnloadedDrivers(self) -> long: ...

    def getMmUserProbeAddress(self) -> long: ...

    def getMmVerifierData(self) -> long: ...

    def getMmVirtualTranslationBase(self) -> long: ...

    def getMmZeroedPageListHead(self) -> long: ...

    def getMmZeroedPageSingleBitErrorsDetected(self) -> long: ...

    def getNextCallback(self) -> int: ...

    def getNonPagedPoolDescriptor(self) -> long: ...

    def getNtBuildLab(self) -> long: ...

    def getObpRootDirectoryObject(self) -> long: ...

    def getObpTypeObjectType(self) -> long: ...

    def getOffsetEProcessMmHotPatchContext(self) -> int: ...

    def getOffsetEThreadIrpList(self) -> int: ...

    def getOffsetEprocessDirectoryTableBase(self) -> int: ...

    def getOffsetEprocessParentCID(self) -> int: ...

    def getOffsetEprocessPeb(self) -> int: ...

    def getOffsetKPriQueueThreadListHead(self) -> int: ...

    def getOffsetKThreadApcProcess(self) -> int: ...

    def getOffsetKThreadBStore(self) -> int: ...

    def getOffsetKThreadBStoreLimit(self) -> int: ...

    def getOffsetKThreadInitialStack(self) -> int: ...

    def getOffsetKThreadKernelStack(self) -> int: ...

    def getOffsetKThreadNextProcessor(self) -> int: ...

    def getOffsetKThreadQueueListEntry(self) -> int: ...

    def getOffsetKThreadStackBase(self) -> int: ...

    def getOffsetKThreadStackLimit(self) -> int: ...

    def getOffsetKThreadState(self) -> int: ...

    def getOffsetKThreadTeb(self) -> int: ...

    def getOffsetKThreadWaitReason(self) -> int: ...

    def getOffsetPcrBStoreLimit(self) -> int: ...

    def getOffsetPcrContainedPrcb(self) -> int: ...

    def getOffsetPcrCurrentPrcb(self) -> int: ...

    def getOffsetPcrInitialBStore(self) -> int: ...

    def getOffsetPcrInitialStack(self) -> int: ...

    def getOffsetPcrSelfPcr(self) -> int: ...

    def getOffsetPcrStackLimit(self) -> int: ...

    def getOffsetPrcbContext(self) -> int: ...

    def getOffsetPrcbCpuType(self) -> int: ...

    def getOffsetPrcbCurrentThread(self) -> int: ...

    def getOffsetPrcbDpcRoutine(self) -> int: ...

    def getOffsetPrcbDpcStack(self) -> int: ...

    def getOffsetPrcbIdleThread(self) -> int: ...

    def getOffsetPrcbIsrStack(self) -> int: ...

    def getOffsetPrcbMaxBreakpoints(self) -> int: ...

    def getOffsetPrcbMaxWatchpoints(self) -> int: ...

    def getOffsetPrcbMhz(self) -> int: ...

    def getOffsetPrcbNormalDpcState(self) -> int: ...

    def getOffsetPrcbNumber(self) -> int: ...

    def getOffsetPrcbPcrPage(self) -> int: ...

    def getOffsetPrcbProcStateContext(self) -> int: ...

    def getOffsetPrcbProcStateSpecialReg(self) -> int: ...

    def getOffsetPrcbVendorString(self) -> int: ...

    def getOwnerTag(self) -> int: ...

    def getPadding0(self) -> int: ...

    def getPadding1(self) -> int: ...

    def getPoolTrackTable(self) -> long: ...

    def getPsActiveProcessHead(self) -> long: ...

    def getPsLoadedModuleList(self) -> long: ...

    def getPspCidTable(self) -> long: ...

    def getPteBase(self) -> long: ...

    def getRetpolineStubFunctionTable(self) -> long: ...

    def getRetpolineStubFunctionTableSize(self) -> int: ...

    def getRetpolineStubOffset(self) -> int: ...

    def getRetpolineStubSize(self) -> int: ...

    def getSavedContext(self) -> long: ...

    def getSize(self) -> int: ...

    def getSizeEProcess(self) -> int: ...

    def getSizeEThread(self) -> int: ...

    def getSizeKDPC_STACK_FRAME(self) -> int: ...

    def getSizePcr(self) -> int: ...

    def getSizePrcb(self) -> int: ...

    def getThCallbackStack(self) -> int: ...

    def getVfCrashDataBlock(self) -> long: ...

    def hashCode(self) -> int: ...

    def notify(self) -> None: ...

    def notifyAll(self) -> None: ...

    def setBreakpointWithStatus(self, __a0: long) -> None: ...

    def setCmNtCSDVersion(self, __a0: long) -> None: ...

    def setEtwpDebuggerData(self, __a0: long) -> None: ...

    def setExpNumberOfPagedPools(self, __a0: long) -> None: ...

    def setExpPagedPoolDescriptor(self, __a0: long) -> None: ...

    def setExpSystemResourcesList(self, __a0: long) -> None: ...

    def setFlags(self, __a0: int) -> None: ...

    def setFramePointer(self, __a0: int) -> None: ...

    def setGdt64R3CmCode(self, __a0: int) -> None: ...

    def setGdt64R3CmTeb(self, __a0: int) -> None: ...

    def setGdtLdt(self, __a0: int) -> None: ...

    def setGdtR0Code(self, __a0: int) -> None: ...

    def setGdtR0Data(self, __a0: int) -> None: ...

    def setGdtR0Pcr(self, __a0: int) -> None: ...

    def setGdtR3Code(self, __a0: int) -> None: ...

    def setGdtR3Data(self, __a0: int) -> None: ...

    def setGdtR3Teb(self, __a0: int) -> None: ...

    def setGdtTss(self, __a0: int) -> None: ...

    def setIopErrorLogListHead(self, __a0: long) -> None: ...

    def setIopNumTriageDumpDataBlocks(self, __a0: long) -> None: ...

    def setIopTriageDumpDataBlocks(self, __a0: long) -> None: ...

    def setKdPrintBufferSize(self, __a0: long) -> None: ...

    def setKdPrintCircularBuffer(self, __a0: long) -> None: ...

    def setKdPrintCircularBufferEnd(self, __a0: long) -> None: ...

    def setKdPrintCircularBufferPtr(self, __a0: long) -> None: ...

    def setKdPrintRolloverCount(self, __a0: long) -> None: ...

    def setKdPrintWritePointer(self, __a0: long) -> None: ...

    def setKeBugCheckCallbackListHead(self, __a0: long) -> None: ...

    def setKeLoaderBlock(self, __a0: long) -> None: ...

    def setKeTimeIncrement(self, __a0: long) -> None: ...

    def setKeUserCallbackDispatcher(self, __a0: long) -> None: ...

    def setKernBase(self, __a0: long) -> None: ...

    def setKernelVerifier(self, __a0: long) -> None: ...

    def setKiBugcheckData(self, __a0: long) -> None: ...

    def setKiCallUserMode(self, __a0: long) -> None: ...

    def setKiNormalSystemCall(self, __a0: long) -> None: ...

    def setKiProcessorBlock(self, __a0: long) -> None: ...

    def setL1tfHighPhysicalBitIndex(self, __a0: int) -> None: ...

    def setL1tfSwizzleBitIndex(self, __a0: int) -> None: ...

    def setList_Blink(self, __a0: long) -> None: ...

    def setList_Flink(self, __a0: long) -> None: ...

    def setMmAllocatedNonPagedPool(self, __a0: long) -> None: ...

    def setMmAvailablePages(self, __a0: long) -> None: ...

    def setMmBadPagesDetected(self, __a0: long) -> None: ...

    def setMmDriverCommit(self, __a0: long) -> None: ...

    def setMmExtendedCommit(self, __a0: long) -> None: ...

    def setMmFreePageListHead(self, __a0: long) -> None: ...

    def setMmHighestPhysicalPage(self, __a0: long) -> None: ...

    def setMmHighestUserAddress(self, __a0: long) -> None: ...

    def setMmLastUnloadedDriver(self, __a0: long) -> None: ...

    def setMmLoadedUserImageList(self, __a0: long) -> None: ...

    def setMmLowestPhysicalPage(self, __a0: long) -> None: ...

    def setMmMaximumNonPagedPoolInBytes(self, __a0: long) -> None: ...

    def setMmModifiedNoWritePageListHead(self, __a0: long) -> None: ...

    def setMmModifiedPageListHead(self, __a0: long) -> None: ...

    def setMmNonPagedPoolEnd(self, __a0: long) -> None: ...

    def setMmNonPagedPoolStart(self, __a0: long) -> None: ...

    def setMmNonPagedSystemStart(self, __a0: long) -> None: ...

    def setMmNumberOfPagingFiles(self, __a0: long) -> None: ...

    def setMmNumberOfPhysicalPages(self, __a0: long) -> None: ...

    def setMmPageSize(self, __a0: long) -> None: ...

    def setMmPagedPoolCommit(self, __a0: long) -> None: ...

    def setMmPagedPoolEnd(self, __a0: long) -> None: ...

    def setMmPagedPoolInformation(self, __a0: long) -> None: ...

    def setMmPagedPoolStart(self, __a0: long) -> None: ...

    def setMmPeakCommitment(self, __a0: long) -> None: ...

    def setMmPfnDatabase(self, __a0: long) -> None: ...

    def setMmPhysicalMemoryBlock(self, __a0: long) -> None: ...

    def setMmProcessCommit(self, __a0: long) -> None: ...

    def setMmResidentAvailablePages(self, __a0: long) -> None: ...

    def setMmSessionBase(self, __a0: long) -> None: ...

    def setMmSessionSize(self, __a0: long) -> None: ...

    def setMmSharedCommit(self, __a0: long) -> None: ...

    def setMmSizeOfPagedPoolInBytes(self, __a0: long) -> None: ...

    def setMmSpecialPoolTag(self, __a0: long) -> None: ...

    def setMmStandbyPageListHead(self, __a0: long) -> None: ...

    def setMmSubsectionBase(self, __a0: long) -> None: ...

    def setMmSystemCacheEnd(self, __a0: long) -> None: ...

    def setMmSystemCacheStart(self, __a0: long) -> None: ...

    def setMmSystemCacheWs(self, __a0: long) -> None: ...

    def setMmSystemParentTablePage(self, __a0: long) -> None: ...

    def setMmSystemPtesEnd(self, __a0: long) -> None: ...

    def setMmSystemPtesStart(self, __a0: long) -> None: ...

    def setMmSystemRangeStart(self, __a0: long) -> None: ...

    def setMmTotalCommitLimit(self, __a0: long) -> None: ...

    def setMmTotalCommitLimitMaximum(self, __a0: long) -> None: ...

    def setMmTotalCommittedPages(self, __a0: long) -> None: ...

    def setMmTriageActionTaken(self, __a0: long) -> None: ...

    def setMmUnloadedDrivers(self, __a0: long) -> None: ...

    def setMmUserProbeAddress(self, __a0: long) -> None: ...

    def setMmVerifierData(self, __a0: long) -> None: ...

    def setMmVirtualTranslationBase(self, __a0: long) -> None: ...

    def setMmZeroedPageListHead(self, __a0: long) -> None: ...

    def setMmZeroedPageSingleBitErrorsDetected(self, __a0: long) -> None: ...

    def setNextCallback(self, __a0: int) -> None: ...

    def setNonPagedPoolDescriptor(self, __a0: long) -> None: ...

    def setNtBuildLab(self, __a0: long) -> None: ...

    def setObpRootDirectoryObject(self, __a0: long) -> None: ...

    def setObpTypeObjectType(self, __a0: long) -> None: ...

    def setOffsetEProcessMmHotPatchContext(self, __a0: int) -> None: ...

    def setOffsetEThreadIrpList(self, __a0: int) -> None: ...

    def setOffsetEprocessDirectoryTableBase(self, __a0: int) -> None: ...

    def setOffsetEprocessParentCID(self, __a0: int) -> None: ...

    def setOffsetEprocessPeb(self, __a0: int) -> None: ...

    def setOffsetKPriQueueThreadListHead(self, __a0: int) -> None: ...

    def setOffsetKThreadApcProcess(self, __a0: int) -> None: ...

    def setOffsetKThreadBStore(self, __a0: int) -> None: ...

    def setOffsetKThreadBStoreLimit(self, __a0: int) -> None: ...

    def setOffsetKThreadInitialStack(self, __a0: int) -> None: ...

    def setOffsetKThreadKernelStack(self, __a0: int) -> None: ...

    def setOffsetKThreadNextProcessor(self, __a0: int) -> None: ...

    def setOffsetKThreadQueueListEntry(self, __a0: int) -> None: ...

    def setOffsetKThreadStackBase(self, __a0: int) -> None: ...

    def setOffsetKThreadStackLimit(self, __a0: int) -> None: ...

    def setOffsetKThreadState(self, __a0: int) -> None: ...

    def setOffsetKThreadTeb(self, __a0: int) -> None: ...

    def setOffsetKThreadWaitReason(self, __a0: int) -> None: ...

    def setOffsetPcrBStoreLimit(self, __a0: int) -> None: ...

    def setOffsetPcrContainedPrcb(self, __a0: int) -> None: ...

    def setOffsetPcrCurrentPrcb(self, __a0: int) -> None: ...

    def setOffsetPcrInitialBStore(self, __a0: int) -> None: ...

    def setOffsetPcrInitialStack(self, __a0: int) -> None: ...

    def setOffsetPcrSelfPcr(self, __a0: int) -> None: ...

    def setOffsetPcrStackLimit(self, __a0: int) -> None: ...

    def setOffsetPrcbContext(self, __a0: int) -> None: ...

    def setOffsetPrcbCpuType(self, __a0: int) -> None: ...

    def setOffsetPrcbCurrentThread(self, __a0: int) -> None: ...

    def setOffsetPrcbDpcRoutine(self, __a0: int) -> None: ...

    def setOffsetPrcbDpcStack(self, __a0: int) -> None: ...

    def setOffsetPrcbIdleThread(self, __a0: int) -> None: ...

    def setOffsetPrcbIsrStack(self, __a0: int) -> None: ...

    def setOffsetPrcbMaxBreakpoints(self, __a0: int) -> None: ...

    def setOffsetPrcbMaxWatchpoints(self, __a0: int) -> None: ...

    def setOffsetPrcbMhz(self, __a0: int) -> None: ...

    def setOffsetPrcbNormalDpcState(self, __a0: int) -> None: ...

    def setOffsetPrcbNumber(self, __a0: int) -> None: ...

    def setOffsetPrcbPcrPage(self, __a0: int) -> None: ...

    def setOffsetPrcbProcStateContext(self, __a0: int) -> None: ...

    def setOffsetPrcbProcStateSpecialReg(self, __a0: int) -> None: ...

    def setOffsetPrcbVendorString(self, __a0: int) -> None: ...

    def setOwnerTag(self, __a0: int) -> None: ...

    def setPadding0(self, __a0: int) -> None: ...

    def setPadding1(self, __a0: int) -> None: ...

    def setPoolTrackTable(self, __a0: long) -> None: ...

    def setPsActiveProcessHead(self, __a0: long) -> None: ...

    def setPsLoadedModuleList(self, __a0: long) -> None: ...

    def setPspCidTable(self, __a0: long) -> None: ...

    def setPteBase(self, __a0: long) -> None: ...

    def setRetpolineStubFunctionTable(self, __a0: long) -> None: ...

    def setRetpolineStubFunctionTableSize(self, __a0: int) -> None: ...

    def setRetpolineStubOffset(self, __a0: int) -> None: ...

    def setRetpolineStubSize(self, __a0: int) -> None: ...

    def setSavedContext(self, __a0: long) -> None: ...

    def setSize(self, __a0: int) -> None: ...

    def setSizeEProcess(self, __a0: int) -> None: ...

    def setSizeEThread(self, __a0: int) -> None: ...

    def setSizeKDPC_STACK_FRAME(self, __a0: int) -> None: ...

    def setSizePcr(self, __a0: int) -> None: ...

    def setSizePrcb(self, __a0: int) -> None: ...

    def setThCallbackStack(self, __a0: int) -> None: ...

    def setVfCrashDataBlock(self, __a0: long) -> None: ...

    def toDataType(self) -> ghidra.program.model.data.DataType: ...

    def toString(self) -> unicode: ...

    @overload
    def wait(self) -> None: ...

    @overload
    def wait(self, __a0: long) -> None: ...

    @overload
    def wait(self, __a0: long, __a1: int) -> None: ...

    @property
    def breakpointWithStatus(self) -> long: ...

    @breakpointWithStatus.setter
    def breakpointWithStatus(self, value: long) -> None: ...

    @property
    def cmNtCSDVersion(self) -> long: ...

    @cmNtCSDVersion.setter
    def cmNtCSDVersion(self, value: long) -> None: ...

    @property
    def etwpDebuggerData(self) -> long: ...

    @etwpDebuggerData.setter
    def etwpDebuggerData(self, value: long) -> None: ...

    @property
    def expNumberOfPagedPools(self) -> long: ...

    @expNumberOfPagedPools.setter
    def expNumberOfPagedPools(self, value: long) -> None: ...

    @property
    def expPagedPoolDescriptor(self) -> long: ...

    @expPagedPoolDescriptor.setter
    def expPagedPoolDescriptor(self, value: long) -> None: ...

    @property
    def expSystemResourcesList(self) -> long: ...

    @expSystemResourcesList.setter
    def expSystemResourcesList(self, value: long) -> None: ...

    @property
    def flags(self) -> int: ...

    @flags.setter
    def flags(self, value: int) -> None: ...

    @property
    def framePointer(self) -> int: ...

    @framePointer.setter
    def framePointer(self, value: int) -> None: ...

    @property
    def gdt64R3CmCode(self) -> int: ...

    @gdt64R3CmCode.setter
    def gdt64R3CmCode(self, value: int) -> None: ...

    @property
    def gdt64R3CmTeb(self) -> int: ...

    @gdt64R3CmTeb.setter
    def gdt64R3CmTeb(self, value: int) -> None: ...

    @property
    def gdtLdt(self) -> int: ...

    @gdtLdt.setter
    def gdtLdt(self, value: int) -> None: ...

    @property
    def gdtR0Code(self) -> int: ...

    @gdtR0Code.setter
    def gdtR0Code(self, value: int) -> None: ...

    @property
    def gdtR0Data(self) -> int: ...

    @gdtR0Data.setter
    def gdtR0Data(self, value: int) -> None: ...

    @property
    def gdtR0Pcr(self) -> int: ...

    @gdtR0Pcr.setter
    def gdtR0Pcr(self, value: int) -> None: ...

    @property
    def gdtR3Code(self) -> int: ...

    @gdtR3Code.setter
    def gdtR3Code(self, value: int) -> None: ...

    @property
    def gdtR3Data(self) -> int: ...

    @gdtR3Data.setter
    def gdtR3Data(self, value: int) -> None: ...

    @property
    def gdtR3Teb(self) -> int: ...

    @gdtR3Teb.setter
    def gdtR3Teb(self, value: int) -> None: ...

    @property
    def gdtTss(self) -> int: ...

    @gdtTss.setter
    def gdtTss(self, value: int) -> None: ...

    @property
    def iopErrorLogListHead(self) -> long: ...

    @iopErrorLogListHead.setter
    def iopErrorLogListHead(self, value: long) -> None: ...

    @property
    def iopNumTriageDumpDataBlocks(self) -> long: ...

    @iopNumTriageDumpDataBlocks.setter
    def iopNumTriageDumpDataBlocks(self, value: long) -> None: ...

    @property
    def iopTriageDumpDataBlocks(self) -> long: ...

    @iopTriageDumpDataBlocks.setter
    def iopTriageDumpDataBlocks(self, value: long) -> None: ...

    @property
    def kdPrintBufferSize(self) -> long: ...

    @kdPrintBufferSize.setter
    def kdPrintBufferSize(self, value: long) -> None: ...

    @property
    def kdPrintCircularBuffer(self) -> long: ...

    @kdPrintCircularBuffer.setter
    def kdPrintCircularBuffer(self, value: long) -> None: ...

    @property
    def kdPrintCircularBufferEnd(self) -> long: ...

    @kdPrintCircularBufferEnd.setter
    def kdPrintCircularBufferEnd(self, value: long) -> None: ...

    @property
    def kdPrintCircularBufferPtr(self) -> long: ...

    @kdPrintCircularBufferPtr.setter
    def kdPrintCircularBufferPtr(self, value: long) -> None: ...

    @property
    def kdPrintRolloverCount(self) -> long: ...

    @kdPrintRolloverCount.setter
    def kdPrintRolloverCount(self, value: long) -> None: ...

    @property
    def kdPrintWritePointer(self) -> long: ...

    @kdPrintWritePointer.setter
    def kdPrintWritePointer(self, value: long) -> None: ...

    @property
    def keBugCheckCallbackListHead(self) -> long: ...

    @keBugCheckCallbackListHead.setter
    def keBugCheckCallbackListHead(self, value: long) -> None: ...

    @property
    def keLoaderBlock(self) -> long: ...

    @keLoaderBlock.setter
    def keLoaderBlock(self, value: long) -> None: ...

    @property
    def keTimeIncrement(self) -> long: ...

    @keTimeIncrement.setter
    def keTimeIncrement(self, value: long) -> None: ...

    @property
    def keUserCallbackDispatcher(self) -> long: ...

    @keUserCallbackDispatcher.setter
    def keUserCallbackDispatcher(self, value: long) -> None: ...

    @property
    def kernBase(self) -> long: ...

    @kernBase.setter
    def kernBase(self, value: long) -> None: ...

    @property
    def kernelVerifier(self) -> long: ...

    @kernelVerifier.setter
    def kernelVerifier(self, value: long) -> None: ...

    @property
    def kiBugcheckData(self) -> long: ...

    @kiBugcheckData.setter
    def kiBugcheckData(self, value: long) -> None: ...

    @property
    def kiCallUserMode(self) -> long: ...

    @kiCallUserMode.setter
    def kiCallUserMode(self, value: long) -> None: ...

    @property
    def kiNormalSystemCall(self) -> long: ...

    @kiNormalSystemCall.setter
    def kiNormalSystemCall(self, value: long) -> None: ...

    @property
    def kiProcessorBlock(self) -> long: ...

    @kiProcessorBlock.setter
    def kiProcessorBlock(self, value: long) -> None: ...

    @property
    def l1tfHighPhysicalBitIndex(self) -> int: ...

    @l1tfHighPhysicalBitIndex.setter
    def l1tfHighPhysicalBitIndex(self, value: int) -> None: ...

    @property
    def l1tfSwizzleBitIndex(self) -> int: ...

    @l1tfSwizzleBitIndex.setter
    def l1tfSwizzleBitIndex(self, value: int) -> None: ...

    @property
    def list_Blink(self) -> long: ...

    @list_Blink.setter
    def list_Blink(self, value: long) -> None: ...

    @property
    def list_Flink(self) -> long: ...

    @list_Flink.setter
    def list_Flink(self, value: long) -> None: ...

    @property
    def mmAllocatedNonPagedPool(self) -> long: ...

    @mmAllocatedNonPagedPool.setter
    def mmAllocatedNonPagedPool(self, value: long) -> None: ...

    @property
    def mmAvailablePages(self) -> long: ...

    @mmAvailablePages.setter
    def mmAvailablePages(self, value: long) -> None: ...

    @property
    def mmBadPagesDetected(self) -> long: ...

    @mmBadPagesDetected.setter
    def mmBadPagesDetected(self, value: long) -> None: ...

    @property
    def mmDriverCommit(self) -> long: ...

    @mmDriverCommit.setter
    def mmDriverCommit(self, value: long) -> None: ...

    @property
    def mmExtendedCommit(self) -> long: ...

    @mmExtendedCommit.setter
    def mmExtendedCommit(self, value: long) -> None: ...

    @property
    def mmFreePageListHead(self) -> long: ...

    @mmFreePageListHead.setter
    def mmFreePageListHead(self, value: long) -> None: ...

    @property
    def mmHighestPhysicalPage(self) -> long: ...

    @mmHighestPhysicalPage.setter
    def mmHighestPhysicalPage(self, value: long) -> None: ...

    @property
    def mmHighestUserAddress(self) -> long: ...

    @mmHighestUserAddress.setter
    def mmHighestUserAddress(self, value: long) -> None: ...

    @property
    def mmLastUnloadedDriver(self) -> long: ...

    @mmLastUnloadedDriver.setter
    def mmLastUnloadedDriver(self, value: long) -> None: ...

    @property
    def mmLoadedUserImageList(self) -> long: ...

    @mmLoadedUserImageList.setter
    def mmLoadedUserImageList(self, value: long) -> None: ...

    @property
    def mmLowestPhysicalPage(self) -> long: ...

    @mmLowestPhysicalPage.setter
    def mmLowestPhysicalPage(self, value: long) -> None: ...

    @property
    def mmMaximumNonPagedPoolInBytes(self) -> long: ...

    @mmMaximumNonPagedPoolInBytes.setter
    def mmMaximumNonPagedPoolInBytes(self, value: long) -> None: ...

    @property
    def mmModifiedNoWritePageListHead(self) -> long: ...

    @mmModifiedNoWritePageListHead.setter
    def mmModifiedNoWritePageListHead(self, value: long) -> None: ...

    @property
    def mmModifiedPageListHead(self) -> long: ...

    @mmModifiedPageListHead.setter
    def mmModifiedPageListHead(self, value: long) -> None: ...

    @property
    def mmNonPagedPoolEnd(self) -> long: ...

    @mmNonPagedPoolEnd.setter
    def mmNonPagedPoolEnd(self, value: long) -> None: ...

    @property
    def mmNonPagedPoolStart(self) -> long: ...

    @mmNonPagedPoolStart.setter
    def mmNonPagedPoolStart(self, value: long) -> None: ...

    @property
    def mmNonPagedSystemStart(self) -> long: ...

    @mmNonPagedSystemStart.setter
    def mmNonPagedSystemStart(self, value: long) -> None: ...

    @property
    def mmNumberOfPagingFiles(self) -> long: ...

    @mmNumberOfPagingFiles.setter
    def mmNumberOfPagingFiles(self, value: long) -> None: ...

    @property
    def mmNumberOfPhysicalPages(self) -> long: ...

    @mmNumberOfPhysicalPages.setter
    def mmNumberOfPhysicalPages(self, value: long) -> None: ...

    @property
    def mmPageSize(self) -> long: ...

    @mmPageSize.setter
    def mmPageSize(self, value: long) -> None: ...

    @property
    def mmPagedPoolCommit(self) -> long: ...

    @mmPagedPoolCommit.setter
    def mmPagedPoolCommit(self, value: long) -> None: ...

    @property
    def mmPagedPoolEnd(self) -> long: ...

    @mmPagedPoolEnd.setter
    def mmPagedPoolEnd(self, value: long) -> None: ...

    @property
    def mmPagedPoolInformation(self) -> long: ...

    @mmPagedPoolInformation.setter
    def mmPagedPoolInformation(self, value: long) -> None: ...

    @property
    def mmPagedPoolStart(self) -> long: ...

    @mmPagedPoolStart.setter
    def mmPagedPoolStart(self, value: long) -> None: ...

    @property
    def mmPeakCommitment(self) -> long: ...

    @mmPeakCommitment.setter
    def mmPeakCommitment(self, value: long) -> None: ...

    @property
    def mmPfnDatabase(self) -> long: ...

    @mmPfnDatabase.setter
    def mmPfnDatabase(self, value: long) -> None: ...

    @property
    def mmPhysicalMemoryBlock(self) -> long: ...

    @mmPhysicalMemoryBlock.setter
    def mmPhysicalMemoryBlock(self, value: long) -> None: ...

    @property
    def mmProcessCommit(self) -> long: ...

    @mmProcessCommit.setter
    def mmProcessCommit(self, value: long) -> None: ...

    @property
    def mmResidentAvailablePages(self) -> long: ...

    @mmResidentAvailablePages.setter
    def mmResidentAvailablePages(self, value: long) -> None: ...

    @property
    def mmSessionBase(self) -> long: ...

    @mmSessionBase.setter
    def mmSessionBase(self, value: long) -> None: ...

    @property
    def mmSessionSize(self) -> long: ...

    @mmSessionSize.setter
    def mmSessionSize(self, value: long) -> None: ...

    @property
    def mmSharedCommit(self) -> long: ...

    @mmSharedCommit.setter
    def mmSharedCommit(self, value: long) -> None: ...

    @property
    def mmSizeOfPagedPoolInBytes(self) -> long: ...

    @mmSizeOfPagedPoolInBytes.setter
    def mmSizeOfPagedPoolInBytes(self, value: long) -> None: ...

    @property
    def mmSpecialPoolTag(self) -> long: ...

    @mmSpecialPoolTag.setter
    def mmSpecialPoolTag(self, value: long) -> None: ...

    @property
    def mmStandbyPageListHead(self) -> long: ...

    @mmStandbyPageListHead.setter
    def mmStandbyPageListHead(self, value: long) -> None: ...

    @property
    def mmSubsectionBase(self) -> long: ...

    @mmSubsectionBase.setter
    def mmSubsectionBase(self, value: long) -> None: ...

    @property
    def mmSystemCacheEnd(self) -> long: ...

    @mmSystemCacheEnd.setter
    def mmSystemCacheEnd(self, value: long) -> None: ...

    @property
    def mmSystemCacheStart(self) -> long: ...

    @mmSystemCacheStart.setter
    def mmSystemCacheStart(self, value: long) -> None: ...

    @property
    def mmSystemCacheWs(self) -> long: ...

    @mmSystemCacheWs.setter
    def mmSystemCacheWs(self, value: long) -> None: ...

    @property
    def mmSystemParentTablePage(self) -> long: ...

    @mmSystemParentTablePage.setter
    def mmSystemParentTablePage(self, value: long) -> None: ...

    @property
    def mmSystemPtesEnd(self) -> long: ...

    @mmSystemPtesEnd.setter
    def mmSystemPtesEnd(self, value: long) -> None: ...

    @property
    def mmSystemPtesStart(self) -> long: ...

    @mmSystemPtesStart.setter
    def mmSystemPtesStart(self, value: long) -> None: ...

    @property
    def mmSystemRangeStart(self) -> long: ...

    @mmSystemRangeStart.setter
    def mmSystemRangeStart(self, value: long) -> None: ...

    @property
    def mmTotalCommitLimit(self) -> long: ...

    @mmTotalCommitLimit.setter
    def mmTotalCommitLimit(self, value: long) -> None: ...

    @property
    def mmTotalCommitLimitMaximum(self) -> long: ...

    @mmTotalCommitLimitMaximum.setter
    def mmTotalCommitLimitMaximum(self, value: long) -> None: ...

    @property
    def mmTotalCommittedPages(self) -> long: ...

    @mmTotalCommittedPages.setter
    def mmTotalCommittedPages(self, value: long) -> None: ...

    @property
    def mmTriageActionTaken(self) -> long: ...

    @mmTriageActionTaken.setter
    def mmTriageActionTaken(self, value: long) -> None: ...

    @property
    def mmUnloadedDrivers(self) -> long: ...

    @mmUnloadedDrivers.setter
    def mmUnloadedDrivers(self, value: long) -> None: ...

    @property
    def mmUserProbeAddress(self) -> long: ...

    @mmUserProbeAddress.setter
    def mmUserProbeAddress(self, value: long) -> None: ...

    @property
    def mmVerifierData(self) -> long: ...

    @mmVerifierData.setter
    def mmVerifierData(self, value: long) -> None: ...

    @property
    def mmVirtualTranslationBase(self) -> long: ...

    @mmVirtualTranslationBase.setter
    def mmVirtualTranslationBase(self, value: long) -> None: ...

    @property
    def mmZeroedPageListHead(self) -> long: ...

    @mmZeroedPageListHead.setter
    def mmZeroedPageListHead(self, value: long) -> None: ...

    @property
    def mmZeroedPageSingleBitErrorsDetected(self) -> long: ...

    @mmZeroedPageSingleBitErrorsDetected.setter
    def mmZeroedPageSingleBitErrorsDetected(self, value: long) -> None: ...

    @property
    def nextCallback(self) -> int: ...

    @nextCallback.setter
    def nextCallback(self, value: int) -> None: ...

    @property
    def nonPagedPoolDescriptor(self) -> long: ...

    @nonPagedPoolDescriptor.setter
    def nonPagedPoolDescriptor(self, value: long) -> None: ...

    @property
    def ntBuildLab(self) -> long: ...

    @ntBuildLab.setter
    def ntBuildLab(self, value: long) -> None: ...

    @property
    def obpRootDirectoryObject(self) -> long: ...

    @obpRootDirectoryObject.setter
    def obpRootDirectoryObject(self, value: long) -> None: ...

    @property
    def obpTypeObjectType(self) -> long: ...

    @obpTypeObjectType.setter
    def obpTypeObjectType(self, value: long) -> None: ...

    @property
    def offsetEProcessMmHotPatchContext(self) -> int: ...

    @offsetEProcessMmHotPatchContext.setter
    def offsetEProcessMmHotPatchContext(self, value: int) -> None: ...

    @property
    def offsetEThreadIrpList(self) -> int: ...

    @offsetEThreadIrpList.setter
    def offsetEThreadIrpList(self, value: int) -> None: ...

    @property
    def offsetEprocessDirectoryTableBase(self) -> int: ...

    @offsetEprocessDirectoryTableBase.setter
    def offsetEprocessDirectoryTableBase(self, value: int) -> None: ...

    @property
    def offsetEprocessParentCID(self) -> int: ...

    @offsetEprocessParentCID.setter
    def offsetEprocessParentCID(self, value: int) -> None: ...

    @property
    def offsetEprocessPeb(self) -> int: ...

    @offsetEprocessPeb.setter
    def offsetEprocessPeb(self, value: int) -> None: ...

    @property
    def offsetKPriQueueThreadListHead(self) -> int: ...

    @offsetKPriQueueThreadListHead.setter
    def offsetKPriQueueThreadListHead(self, value: int) -> None: ...

    @property
    def offsetKThreadApcProcess(self) -> int: ...

    @offsetKThreadApcProcess.setter
    def offsetKThreadApcProcess(self, value: int) -> None: ...

    @property
    def offsetKThreadBStore(self) -> int: ...

    @offsetKThreadBStore.setter
    def offsetKThreadBStore(self, value: int) -> None: ...

    @property
    def offsetKThreadBStoreLimit(self) -> int: ...

    @offsetKThreadBStoreLimit.setter
    def offsetKThreadBStoreLimit(self, value: int) -> None: ...

    @property
    def offsetKThreadInitialStack(self) -> int: ...

    @offsetKThreadInitialStack.setter
    def offsetKThreadInitialStack(self, value: int) -> None: ...

    @property
    def offsetKThreadKernelStack(self) -> int: ...

    @offsetKThreadKernelStack.setter
    def offsetKThreadKernelStack(self, value: int) -> None: ...

    @property
    def offsetKThreadNextProcessor(self) -> int: ...

    @offsetKThreadNextProcessor.setter
    def offsetKThreadNextProcessor(self, value: int) -> None: ...

    @property
    def offsetKThreadQueueListEntry(self) -> int: ...

    @offsetKThreadQueueListEntry.setter
    def offsetKThreadQueueListEntry(self, value: int) -> None: ...

    @property
    def offsetKThreadStackBase(self) -> int: ...

    @offsetKThreadStackBase.setter
    def offsetKThreadStackBase(self, value: int) -> None: ...

    @property
    def offsetKThreadStackLimit(self) -> int: ...

    @offsetKThreadStackLimit.setter
    def offsetKThreadStackLimit(self, value: int) -> None: ...

    @property
    def offsetKThreadState(self) -> int: ...

    @offsetKThreadState.setter
    def offsetKThreadState(self, value: int) -> None: ...

    @property
    def offsetKThreadTeb(self) -> int: ...

    @offsetKThreadTeb.setter
    def offsetKThreadTeb(self, value: int) -> None: ...

    @property
    def offsetKThreadWaitReason(self) -> int: ...

    @offsetKThreadWaitReason.setter
    def offsetKThreadWaitReason(self, value: int) -> None: ...

    @property
    def offsetPcrBStoreLimit(self) -> int: ...

    @offsetPcrBStoreLimit.setter
    def offsetPcrBStoreLimit(self, value: int) -> None: ...

    @property
    def offsetPcrContainedPrcb(self) -> int: ...

    @offsetPcrContainedPrcb.setter
    def offsetPcrContainedPrcb(self, value: int) -> None: ...

    @property
    def offsetPcrCurrentPrcb(self) -> int: ...

    @offsetPcrCurrentPrcb.setter
    def offsetPcrCurrentPrcb(self, value: int) -> None: ...

    @property
    def offsetPcrInitialBStore(self) -> int: ...

    @offsetPcrInitialBStore.setter
    def offsetPcrInitialBStore(self, value: int) -> None: ...

    @property
    def offsetPcrInitialStack(self) -> int: ...

    @offsetPcrInitialStack.setter
    def offsetPcrInitialStack(self, value: int) -> None: ...

    @property
    def offsetPcrSelfPcr(self) -> int: ...

    @offsetPcrSelfPcr.setter
    def offsetPcrSelfPcr(self, value: int) -> None: ...

    @property
    def offsetPcrStackLimit(self) -> int: ...

    @offsetPcrStackLimit.setter
    def offsetPcrStackLimit(self, value: int) -> None: ...

    @property
    def offsetPrcbContext(self) -> int: ...

    @offsetPrcbContext.setter
    def offsetPrcbContext(self, value: int) -> None: ...

    @property
    def offsetPrcbCpuType(self) -> int: ...

    @offsetPrcbCpuType.setter
    def offsetPrcbCpuType(self, value: int) -> None: ...

    @property
    def offsetPrcbCurrentThread(self) -> int: ...

    @offsetPrcbCurrentThread.setter
    def offsetPrcbCurrentThread(self, value: int) -> None: ...

    @property
    def offsetPrcbDpcRoutine(self) -> int: ...

    @offsetPrcbDpcRoutine.setter
    def offsetPrcbDpcRoutine(self, value: int) -> None: ...

    @property
    def offsetPrcbDpcStack(self) -> int: ...

    @offsetPrcbDpcStack.setter
    def offsetPrcbDpcStack(self, value: int) -> None: ...

    @property
    def offsetPrcbIdleThread(self) -> int: ...

    @offsetPrcbIdleThread.setter
    def offsetPrcbIdleThread(self, value: int) -> None: ...

    @property
    def offsetPrcbIsrStack(self) -> int: ...

    @offsetPrcbIsrStack.setter
    def offsetPrcbIsrStack(self, value: int) -> None: ...

    @property
    def offsetPrcbMaxBreakpoints(self) -> int: ...

    @offsetPrcbMaxBreakpoints.setter
    def offsetPrcbMaxBreakpoints(self, value: int) -> None: ...

    @property
    def offsetPrcbMaxWatchpoints(self) -> int: ...

    @offsetPrcbMaxWatchpoints.setter
    def offsetPrcbMaxWatchpoints(self, value: int) -> None: ...

    @property
    def offsetPrcbMhz(self) -> int: ...

    @offsetPrcbMhz.setter
    def offsetPrcbMhz(self, value: int) -> None: ...

    @property
    def offsetPrcbNormalDpcState(self) -> int: ...

    @offsetPrcbNormalDpcState.setter
    def offsetPrcbNormalDpcState(self, value: int) -> None: ...

    @property
    def offsetPrcbNumber(self) -> int: ...

    @offsetPrcbNumber.setter
    def offsetPrcbNumber(self, value: int) -> None: ...

    @property
    def offsetPrcbPcrPage(self) -> int: ...

    @offsetPrcbPcrPage.setter
    def offsetPrcbPcrPage(self, value: int) -> None: ...

    @property
    def offsetPrcbProcStateContext(self) -> int: ...

    @offsetPrcbProcStateContext.setter
    def offsetPrcbProcStateContext(self, value: int) -> None: ...

    @property
    def offsetPrcbProcStateSpecialReg(self) -> int: ...

    @offsetPrcbProcStateSpecialReg.setter
    def offsetPrcbProcStateSpecialReg(self, value: int) -> None: ...

    @property
    def offsetPrcbVendorString(self) -> int: ...

    @offsetPrcbVendorString.setter
    def offsetPrcbVendorString(self, value: int) -> None: ...

    @property
    def ownerTag(self) -> int: ...

    @ownerTag.setter
    def ownerTag(self, value: int) -> None: ...

    @property
    def padding0(self) -> int: ...

    @padding0.setter
    def padding0(self, value: int) -> None: ...

    @property
    def padding1(self) -> int: ...

    @padding1.setter
    def padding1(self, value: int) -> None: ...

    @property
    def poolTrackTable(self) -> long: ...

    @poolTrackTable.setter
    def poolTrackTable(self, value: long) -> None: ...

    @property
    def psActiveProcessHead(self) -> long: ...

    @psActiveProcessHead.setter
    def psActiveProcessHead(self, value: long) -> None: ...

    @property
    def psLoadedModuleList(self) -> long: ...

    @psLoadedModuleList.setter
    def psLoadedModuleList(self, value: long) -> None: ...

    @property
    def pspCidTable(self) -> long: ...

    @pspCidTable.setter
    def pspCidTable(self, value: long) -> None: ...

    @property
    def pteBase(self) -> long: ...

    @pteBase.setter
    def pteBase(self, value: long) -> None: ...

    @property
    def retpolineStubFunctionTable(self) -> long: ...

    @retpolineStubFunctionTable.setter
    def retpolineStubFunctionTable(self, value: long) -> None: ...

    @property
    def retpolineStubFunctionTableSize(self) -> int: ...

    @retpolineStubFunctionTableSize.setter
    def retpolineStubFunctionTableSize(self, value: int) -> None: ...

    @property
    def retpolineStubOffset(self) -> int: ...

    @retpolineStubOffset.setter
    def retpolineStubOffset(self, value: int) -> None: ...

    @property
    def retpolineStubSize(self) -> int: ...

    @retpolineStubSize.setter
    def retpolineStubSize(self, value: int) -> None: ...

    @property
    def savedContext(self) -> long: ...

    @savedContext.setter
    def savedContext(self, value: long) -> None: ...

    @property
    def size(self) -> int: ...

    @size.setter
    def size(self, value: int) -> None: ...

    @property
    def sizeEProcess(self) -> int: ...

    @sizeEProcess.setter
    def sizeEProcess(self, value: int) -> None: ...

    @property
    def sizeEThread(self) -> int: ...

    @sizeEThread.setter
    def sizeEThread(self, value: int) -> None: ...

    @property
    def sizeKDPC_STACK_FRAME(self) -> int: ...

    @sizeKDPC_STACK_FRAME.setter
    def sizeKDPC_STACK_FRAME(self, value: int) -> None: ...

    @property
    def sizePcr(self) -> int: ...

    @sizePcr.setter
    def sizePcr(self, value: int) -> None: ...

    @property
    def sizePrcb(self) -> int: ...

    @sizePrcb.setter
    def sizePrcb(self, value: int) -> None: ...

    @property
    def thCallbackStack(self) -> int: ...

    @thCallbackStack.setter
    def thCallbackStack(self, value: int) -> None: ...

    @property
    def vfCrashDataBlock(self) -> long: ...

    @vfCrashDataBlock.setter
    def vfCrashDataBlock(self, value: long) -> None: ...