import ghidra.app.util.bin
import ghidra.program.model.data
import java.lang


class DebugInfo(object, ghidra.app.util.bin.StructConverter):
    ASCII: ghidra.program.model.data.DataType = char
    BYTE: ghidra.program.model.data.DataType = byte
    DWORD: ghidra.program.model.data.DataType = dword
    IBO32: ghidra.program.model.data.DataType = IBO32DataType: typedef ImageBaseOffset32 pointer32
    IBO64: ghidra.program.model.data.DataType = IBO64DataType: typedef ImageBaseOffset64 pointer64
    NAME: unicode = u'DEBUG_EVENT'
    POINTER: ghidra.program.model.data.DataType = pointer
    QWORD: ghidra.program.model.data.DataType = qword
    STRING: ghidra.program.model.data.DataType = string
    UTF16: ghidra.program.model.data.DataType = unicode
    UTF8: ghidra.program.model.data.DataType = string-utf8
    VOID: ghidra.program.model.data.DataType = void
    WORD: ghidra.program.model.data.DataType = word







    def equals(self, __a0: object) -> bool: ...

    def getClass(self) -> java.lang.Class: ...

    def getEventCode(self) -> int: ...

    def getExceptionAddress(self) -> long: ...

    def getExceptionCode(self) -> int: ...

    def getExceptionFlags(self) -> int: ...

    def getExceptionRecord(self) -> long: ...

    def getProcessId(self) -> int: ...

    def getThreadId(self) -> int: ...

    def hashCode(self) -> int: ...

    def notify(self) -> None: ...

    def notifyAll(self) -> None: ...

    def setEventCode(self, __a0: int) -> None: ...

    def setExceptionAddress(self, __a0: long) -> None: ...

    def setExceptionCode(self, __a0: int) -> None: ...

    def setExceptionFlags(self, __a0: int) -> None: ...

    def setExceptionRecord(self, __a0: long) -> None: ...

    def setProcessId(self, __a0: int) -> None: ...

    def setThreadId(self, __a0: int) -> None: ...

    def toDataType(self) -> ghidra.program.model.data.DataType: ...

    def toString(self) -> unicode: ...

    @overload
    def wait(self) -> None: ...

    @overload
    def wait(self, __a0: long) -> None: ...

    @overload
    def wait(self, __a0: long, __a1: int) -> None: ...

    @property
    def eventCode(self) -> int: ...

    @eventCode.setter
    def eventCode(self, value: int) -> None: ...

    @property
    def exceptionAddress(self) -> long: ...

    @exceptionAddress.setter
    def exceptionAddress(self, value: long) -> None: ...

    @property
    def exceptionCode(self) -> int: ...

    @exceptionCode.setter
    def exceptionCode(self, value: int) -> None: ...

    @property
    def exceptionFlags(self) -> int: ...

    @exceptionFlags.setter
    def exceptionFlags(self, value: int) -> None: ...

    @property
    def exceptionRecord(self) -> long: ...

    @exceptionRecord.setter
    def exceptionRecord(self, value: long) -> None: ...

    @property
    def processId(self) -> int: ...

    @processId.setter
    def processId(self, value: int) -> None: ...

    @property
    def threadId(self) -> int: ...

    @threadId.setter
    def threadId(self, value: int) -> None: ...