import ghidra.app.util.bin
import ghidra.program.model.data
import java.lang


class MemoryInfo(object, ghidra.app.util.bin.StructConverter):
    ASCII: ghidra.program.model.data.DataType = char
    BYTE: ghidra.program.model.data.DataType = byte
    DWORD: ghidra.program.model.data.DataType = dword
    IBO32: ghidra.program.model.data.DataType = IBO32DataType: typedef ImageBaseOffset32 pointer32
    IBO64: ghidra.program.model.data.DataType = IBO64DataType: typedef ImageBaseOffset64 pointer64
    NAME: unicode = u'MEMORY_INFO'
    POINTER: ghidra.program.model.data.DataType = pointer
    QWORD: ghidra.program.model.data.DataType = qword
    STRING: ghidra.program.model.data.DataType = string
    UTF16: ghidra.program.model.data.DataType = unicode
    UTF8: ghidra.program.model.data.DataType = string-utf8
    VOID: ghidra.program.model.data.DataType = void
    WORD: ghidra.program.model.data.DataType = word







    def equals(self, __a0: object) -> bool: ...

    def getAllocationBase(self) -> long: ...

    def getAllocationProtect(self) -> int: ...

    def getBaseAddress(self) -> long: ...

    def getClass(self) -> java.lang.Class: ...

    def getComment(self) -> unicode: ...

    def getProtect(self) -> int: ...

    def getRegionSize(self) -> long: ...

    def getState(self) -> int: ...

    def getType(self) -> int: ...

    def hashCode(self) -> int: ...

    def notify(self) -> None: ...

    def notifyAll(self) -> None: ...

    def setAllocationBase(self, __a0: long) -> None: ...

    def setAllocationProtect(self, __a0: int) -> None: ...

    def setBaseAddress(self, __a0: long) -> None: ...

    def setProtect(self, __a0: int) -> None: ...

    def setRegionSize(self, __a0: long) -> None: ...

    def setState(self, __a0: int) -> None: ...

    def setType(self, __a0: int) -> None: ...

    def toDataType(self) -> ghidra.program.model.data.DataType: ...

    def toString(self) -> unicode: ...

    @overload
    def wait(self) -> None: ...

    @overload
    def wait(self, __a0: long) -> None: ...

    @overload
    def wait(self, __a0: long, __a1: int) -> None: ...

    @property
    def allocationBase(self) -> long: ...

    @allocationBase.setter
    def allocationBase(self, value: long) -> None: ...

    @property
    def allocationProtect(self) -> int: ...

    @allocationProtect.setter
    def allocationProtect(self, value: int) -> None: ...

    @property
    def baseAddress(self) -> long: ...

    @baseAddress.setter
    def baseAddress(self, value: long) -> None: ...

    @property
    def comment(self) -> unicode: ...

    @property
    def protect(self) -> int: ...

    @protect.setter
    def protect(self, value: int) -> None: ...

    @property
    def regionSize(self) -> long: ...

    @regionSize.setter
    def regionSize(self, value: long) -> None: ...

    @property
    def state(self) -> int: ...

    @state.setter
    def state(self, value: int) -> None: ...

    @property
    def type(self) -> int: ...

    @type.setter
    def type(self, value: int) -> None: ...