from typing import List
import ghidra.app.util.bin
import ghidra.program.model.data
import java.lang


class Img2(object, ghidra.app.util.bin.StructConverter):
    ASCII: ghidra.program.model.data.DataType = char
    BYTE: ghidra.program.model.data.DataType = byte
    DWORD: ghidra.program.model.data.DataType = dword
    IBO32: ghidra.program.model.data.DataType = IBO32DataType: typedef ImageBaseOffset32 pointer32
    IBO64: ghidra.program.model.data.DataType = IBO64DataType: typedef ImageBaseOffset64 pointer64
    POINTER: ghidra.program.model.data.DataType = pointer
    QWORD: ghidra.program.model.data.DataType = qword
    STRING: ghidra.program.model.data.DataType = string
    UTF16: ghidra.program.model.data.DataType = unicode
    UTF8: ghidra.program.model.data.DataType = string-utf8
    VOID: ghidra.program.model.data.DataType = void
    WORD: ghidra.program.model.data.DataType = word



    @overload
    def __init__(self, __a0: ghidra.app.util.bin.BinaryReader): ...

    @overload
    def __init__(self, __a0: ghidra.app.util.bin.ByteProvider): ...



    def equals(self, __a0: object) -> bool: ...

    def getChecksum2(self) -> int: ...

    def getClass(self) -> java.lang.Class: ...

    def getDataLen(self) -> int: ...

    def getDataLenPadded(self) -> int: ...

    def getFlags1(self) -> int: ...

    def getFlags2(self) -> int: ...

    def getHeaderChecksum(self) -> int: ...

    def getImageType(self) -> unicode: ...

    def getReserved(self) -> List[int]: ...

    def getSecurityEpoch(self) -> int: ...

    def getSignature(self) -> unicode: ...

    def getUnknown(self, __a0: int) -> List[int]: ...

    def hashCode(self) -> int: ...

    def isValid(self) -> bool: ...

    def notify(self) -> None: ...

    def notifyAll(self) -> None: ...

    def toDataType(self) -> ghidra.program.model.data.DataType: ...

    def toString(self) -> unicode: ...

    @overload
    def wait(self) -> None: ...

    @overload
    def wait(self, __a0: long) -> None: ...

    @overload
    def wait(self, __a0: long, __a1: int) -> None: ...

    @property
    def checksum2(self) -> int: ...

    @property
    def dataLen(self) -> int: ...

    @property
    def dataLenPadded(self) -> int: ...

    @property
    def flags1(self) -> int: ...

    @property
    def flags2(self) -> int: ...

    @property
    def headerChecksum(self) -> int: ...

    @property
    def imageType(self) -> unicode: ...

    @property
    def reserved(self) -> List[int]: ...

    @property
    def securityEpoch(self) -> int: ...

    @property
    def signature(self) -> unicode: ...

    @property
    def valid(self) -> bool: ...