import ghidra.app.util.bin
import ghidra.program.model.data
import java.lang


class YAFFS2Header(object, ghidra.app.util.bin.StructConverter):
    ASCII: ghidra.program.model.data.DataType = char
    BYTE: ghidra.program.model.data.DataType = byte
    DWORD: ghidra.program.model.data.DataType = dword
    IBO32: ghidra.program.model.data.DataType = IBO32DataType: typedef ImageBaseOffset32 pointer32
    IBO64: ghidra.program.model.data.DataType = IBO64DataType: typedef ImageBaseOffset64 pointer64
    POINTER: ghidra.program.model.data.DataType = pointer
    QWORD: ghidra.program.model.data.DataType = qword
    STRING: ghidra.program.model.data.DataType = string
    UTF16: ghidra.program.model.data.DataType = unicode
    UTF8: ghidra.program.model.data.DataType = string-utf8
    VOID: ghidra.program.model.data.DataType = void
    WORD: ghidra.program.model.data.DataType = word



    @overload
    def __init__(self): ...

    @overload
    def __init__(self, __a0: List[int]): ...



    def equals(self, __a0: object) -> bool: ...

    def getAliasFileName(self) -> unicode: ...

    def getChecksum(self) -> int: ...

    def getClass(self) -> java.lang.Class: ...

    def getEquivId(self) -> long: ...

    def getFileSizeHigh(self) -> long: ...

    def getInbandIsShrink(self) -> long: ...

    def getInbandObjId(self) -> long: ...

    def getIsShrink(self) -> long: ...

    def getName(self) -> unicode: ...

    def getObjectType(self) -> long: ...

    def getParentObjectId(self) -> long: ...

    def getShadowsObject(self) -> long: ...

    def getSize(self) -> long: ...

    def getWinATime(self) -> long: ...

    def getWinCTime(self) -> long: ...

    def getWinMTime(self) -> long: ...

    def getYstATime(self) -> unicode: ...

    def getYstCTime(self) -> unicode: ...

    def getYstGId(self) -> long: ...

    def getYstMTime(self) -> unicode: ...

    def getYstMode(self) -> long: ...

    def getYstRDev(self) -> long: ...

    def getYstUId(self) -> long: ...

    def hashCode(self) -> int: ...

    def isDirectory(self) -> bool: ...

    def isFile(self) -> bool: ...

    def notify(self) -> None: ...

    def notifyAll(self) -> None: ...

    def toDataType(self) -> ghidra.program.model.data.DataType: ...

    def toString(self) -> unicode: ...

    @overload
    def wait(self) -> None: ...

    @overload
    def wait(self, __a0: long) -> None: ...

    @overload
    def wait(self, __a0: long, __a1: int) -> None: ...

    @property
    def aliasFileName(self) -> unicode: ...

    @property
    def checksum(self) -> int: ...

    @property
    def directory(self) -> bool: ...

    @property
    def equivId(self) -> long: ...

    @property
    def file(self) -> bool: ...

    @property
    def fileSizeHigh(self) -> long: ...

    @property
    def inbandIsShrink(self) -> long: ...

    @property
    def inbandObjId(self) -> long: ...

    @property
    def isShrink(self) -> long: ...

    @property
    def name(self) -> unicode: ...

    @property
    def objectType(self) -> long: ...

    @property
    def parentObjectId(self) -> long: ...

    @property
    def shadowsObject(self) -> long: ...

    @property
    def size(self) -> long: ...

    @property
    def winATime(self) -> long: ...

    @property
    def winCTime(self) -> long: ...

    @property
    def winMTime(self) -> long: ...

    @property
    def ystATime(self) -> unicode: ...

    @property
    def ystCTime(self) -> unicode: ...

    @property
    def ystGId(self) -> long: ...

    @property
    def ystMTime(self) -> unicode: ...

    @property
    def ystMode(self) -> long: ...

    @property
    def ystRDev(self) -> long: ...

    @property
    def ystUId(self) -> long: ...