from typing import List
import docking.widgets.tree
import docking.widgets.tree.internal
import docking.widgets.tree.support
import docking.widgets.tree.support.GTreeSelectionEvent
import docking.widgets.tree.tasks
import ghidra.util
import ghidra.util.task
import java.awt
import java.awt.dnd
import java.awt.event
import java.awt.im
import java.awt.image
import java.beans
import java.io
import java.lang
import java.util
import java.util.function
import javax.accessibility
import javax.swing
import javax.swing.border
import javax.swing.event
import javax.swing.plaf
import javax.swing.tree


class DataTree(docking.widgets.tree.GTree):
    """
    Tree that shows the folders and domain files in a Project
    """









    def action(self, __a0: java.awt.Event, __a1: object) -> bool: ...

    @overload
    def add(self, __a0: java.awt.Component) -> java.awt.Component: ...

    @overload
    def add(self, __a0: java.awt.PopupMenu) -> None: ...

    @overload
    def add(self, __a0: java.awt.Component, __a1: int) -> java.awt.Component: ...

    @overload
    def add(self, __a0: unicode, __a1: java.awt.Component) -> java.awt.Component: ...

    @overload
    def add(self, __a0: java.awt.Component, __a1: object) -> None: ...

    @overload
    def add(self, __a0: java.awt.Component, __a1: object, __a2: int) -> None: ...

    def addAncestorListener(self, __a0: javax.swing.event.AncestorListener) -> None: ...

    def addComponentListener(self, __a0: java.awt.event.ComponentListener) -> None: ...

    def addContainerListener(self, __a0: java.awt.event.ContainerListener) -> None: ...

    def addFocusListener(self, __a0: java.awt.event.FocusListener) -> None: ...

    def addGTModelListener(self, listener: javax.swing.event.TreeModelListener) -> None: ...

    def addGTreeSelectionListener(self, listener: docking.widgets.tree.support.GTreeSelectionListener) -> None: ...

    def addHierarchyBoundsListener(self, __a0: java.awt.event.HierarchyBoundsListener) -> None: ...

    def addHierarchyListener(self, __a0: java.awt.event.HierarchyListener) -> None: ...

    def addInputMethodListener(self, __a0: java.awt.event.InputMethodListener) -> None: ...

    def addKeyListener(self, __a0: java.awt.event.KeyListener) -> None: ...

    def addMouseListener(self, listener: java.awt.event.MouseListener) -> None: ...

    def addMouseMotionListener(self, __a0: java.awt.event.MouseMotionListener) -> None: ...

    def addMouseWheelListener(self, __a0: java.awt.event.MouseWheelListener) -> None: ...

    def addNotify(self) -> None: ...

    @overload
    def addPropertyChangeListener(self, __a0: java.beans.PropertyChangeListener) -> None: ...

    @overload
    def addPropertyChangeListener(self, __a0: unicode, __a1: java.beans.PropertyChangeListener) -> None: ...

    def addSelectionPath(self, path: javax.swing.tree.TreePath) -> None: ...

    def addTreeExpansionListener(self, listener: javax.swing.event.TreeExpansionListener) -> None: ...

    def addVetoableChangeListener(self, __a0: java.beans.VetoableChangeListener) -> None: ...

    def applyComponentOrientation(self, __a0: java.awt.ComponentOrientation) -> None: ...

    def areFocusTraversalKeysSet(self, __a0: int) -> bool: ...

    def cancelEditing(self) -> None: ...

    def cancelWork(self) -> None:
        """
        Signals that any multithreaded work should be cancelled.
        """
        ...

    @overload
    def checkImage(self, __a0: java.awt.Image, __a1: java.awt.image.ImageObserver) -> int: ...

    @overload
    def checkImage(self, __a0: java.awt.Image, __a1: int, __a2: int, __a3: java.awt.image.ImageObserver) -> int: ...

    def clearFilter(self) -> None: ...

    def clearSelection(self) -> None: ...

    def clearSelectionPaths(self) -> None: ...

    def clearSizeCache(self) -> None: ...

    def collapseAll(self, node: docking.widgets.tree.GTreeNode) -> None: ...

    def computeVisibleRect(self, __a0: java.awt.Rectangle) -> None: ...

    @overload
    def contains(self, __a0: java.awt.Point) -> bool: ...

    @overload
    def contains(self, __a0: int, __a1: int) -> bool: ...

    def countComponents(self) -> int: ...

    @overload
    def createImage(self, __a0: java.awt.image.ImageProducer) -> java.awt.Image: ...

    @overload
    def createImage(self, __a0: int, __a1: int) -> java.awt.Image: ...

    def createToolTip(self) -> javax.swing.JToolTip: ...

    @overload
    def createVolatileImage(self, __a0: int, __a1: int) -> java.awt.image.VolatileImage: ...

    @overload
    def createVolatileImage(self, __a0: int, __a1: int, __a2: java.awt.ImageCapabilities) -> java.awt.image.VolatileImage: ...

    def deliverEvent(self, __a0: java.awt.Event) -> None: ...

    def disable(self) -> None: ...

    def dispatchEvent(self, __a0: java.awt.AWTEvent) -> None: ...

    def dispose(self) -> None: ...

    def doLayout(self) -> None: ...

    @overload
    def enable(self) -> None: ...

    @overload
    def enable(self, __a0: bool) -> None: ...

    def enableInputMethods(self, __a0: bool) -> None: ...

    def equals(self, __a0: object) -> bool: ...

    def expandAll(self) -> None: ...

    @overload
    def expandPath(self, node: docking.widgets.tree.GTreeNode) -> None: ...

    @overload
    def expandPath(self, path: javax.swing.tree.TreePath) -> None: ...

    @overload
    def expandPaths(self, paths: List[javax.swing.tree.TreePath]) -> None: ...

    @overload
    def expandPaths(self, __a0: List[object]) -> None: ...

    def expandTree(self, node: docking.widgets.tree.GTreeNode) -> None: ...

    def expandedStateRestored(self, taskMonitor: ghidra.util.task.TaskMonitor) -> None:
        """
        A method that subclasses can use to be notified when tree state has been restored. This
         method is called after a major structural tree change has happened <b>and</b> the paths that
         should be opened have been opened. Thus any other nodes are closed and can be disposed, if
         desired.
        @param taskMonitor the TaskMonitor
        """
        ...

    def filterChanged(self) -> None: ...

    @overload
    def findComponentAt(self, __a0: java.awt.Point) -> java.awt.Component: ...

    @overload
    def findComponentAt(self, __a0: int, __a1: int) -> java.awt.Component: ...

    @overload
    def firePropertyChange(self, __a0: unicode, __a1: long, __a2: long) -> None: ...

    @overload
    def firePropertyChange(self, __a0: unicode, __a1: int, __a2: int) -> None: ...

    @overload
    def firePropertyChange(self, __a0: unicode, __a1: int, __a2: int) -> None: ...

    @overload
    def firePropertyChange(self, __a0: unicode, __a1: int, __a2: int) -> None: ...

    @overload
    def firePropertyChange(self, __a0: unicode, __a1: int, __a2: int) -> None: ...

    @overload
    def firePropertyChange(self, __a0: unicode, __a1: float, __a2: float) -> None: ...

    @overload
    def firePropertyChange(self, __a0: unicode, __a1: float, __a2: float) -> None: ...

    @overload
    def firePropertyChange(self, __a0: unicode, __a1: bool, __a2: bool) -> None: ...

    def forceNewNodeIntoView(self, parent: docking.widgets.tree.GTreeNode, childName: unicode, consumer: java.util.function.Consumer) -> None:
        """
        A specialized method that will get the child node from the given parent node when it becomes
         available to the model. This method will ensure that the named child passes any current
         filter in order for the child to appear in the tree. This effect is temporary and will be
         undone when next the filter changes.

         <p>
         This method is intended to be used by clients using an asynchronous node model, where new
         nodes will get created by application-level events. Such clients may wish to perform work
         when newly created nodes become available. This method simplifies the concurrent nature of
         the GTree, asynchronous nodes and the processing of asynchronous application-level events by
         providing a callback mechanism for clients. <b>This method is non-blocking.</b>

         <p>
         Note: this method assumes that the given parent node is in the view and not filtered out of
         the view. This method makes no attempt to ensure the given parent node passes any existing
         filter.

         <p>
         Note: this method will not wait forever for the given node to appear. It will eventually give
         up if the node never arrives.
        @param parent the model's parent node. If the view's parent node is passed, it will be
                    translated to the model node.
        @param childName the name of the desired child
        @param consumer the consumer callback to which the child node will be given when available
        """
        ...

    def getAccessibleContext(self) -> javax.accessibility.AccessibleContext: ...

    def getActionForKeyStroke(self, __a0: javax.swing.KeyStroke) -> java.awt.event.ActionListener: ...

    def getActionMap(self) -> javax.swing.ActionMap: ...

    def getAlignmentX(self) -> float: ...

    def getAlignmentY(self) -> float: ...

    def getAncestorListeners(self) -> List[javax.swing.event.AncestorListener]: ...

    def getAutoscrolls(self) -> bool: ...

    def getBackground(self) -> java.awt.Color: ...

    def getBaseline(self, __a0: int, __a1: int) -> int: ...

    def getBaselineResizeBehavior(self) -> java.awt.Component.BaselineResizeBehavior: ...

    def getBorder(self) -> javax.swing.border.Border: ...

    @overload
    def getBounds(self) -> java.awt.Rectangle: ...

    @overload
    def getBounds(self, __a0: java.awt.Rectangle) -> java.awt.Rectangle: ...

    def getCellEditor(self) -> javax.swing.CellEditor: ...

    def getCellRenderer(self) -> docking.widgets.tree.support.GTreeRenderer: ...

    def getClass(self) -> java.lang.Class: ...

    def getClientProperty(self, __a0: object) -> object: ...

    def getColorModel(self) -> java.awt.image.ColorModel: ...

    def getComponent(self, __a0: int) -> java.awt.Component: ...

    @overload
    def getComponentAt(self, __a0: java.awt.Point) -> java.awt.Component: ...

    @overload
    def getComponentAt(self, __a0: int, __a1: int) -> java.awt.Component: ...

    def getComponentCount(self) -> int: ...

    def getComponentListeners(self) -> List[java.awt.event.ComponentListener]: ...

    def getComponentOrientation(self) -> java.awt.ComponentOrientation: ...

    def getComponentPopupMenu(self) -> javax.swing.JPopupMenu: ...

    def getComponentZOrder(self, __a0: java.awt.Component) -> int: ...

    def getComponents(self) -> List[java.awt.Component]: ...

    def getConditionForKeyStroke(self, __a0: javax.swing.KeyStroke) -> int: ...

    def getContainerListeners(self) -> List[java.awt.event.ContainerListener]: ...

    def getCursor(self) -> java.awt.Cursor: ...

    def getDebugGraphicsOptions(self) -> int: ...

    @staticmethod
    def getDefaultLocale() -> java.util.Locale: ...

    def getDragNDropHandler(self) -> docking.widgets.tree.support.GTreeDragNDropHandler: ...

    def getDropTarget(self) -> java.awt.dnd.DropTarget: ...

    @overload
    def getExpandedPaths(self) -> List[javax.swing.tree.TreePath]: ...

    @overload
    def getExpandedPaths(self, node: docking.widgets.tree.GTreeNode) -> List[javax.swing.tree.TreePath]: ...

    def getFilter(self) -> docking.widgets.tree.support.GTreeFilter: ...

    def getFilterField(self) -> java.awt.Component:
        """
        Returns the filter text field in this tree.
        @return the filter text field in this tree.
        """
        ...

    def getFilterProvider(self) -> docking.widgets.tree.GTreeFilterProvider: ...

    def getFilterText(self) -> unicode: ...

    def getFocusCycleRootAncestor(self) -> java.awt.Container: ...

    def getFocusListeners(self) -> List[java.awt.event.FocusListener]: ...

    def getFocusTraversalKeys(self, __a0: int) -> java.util.Set: ...

    def getFocusTraversalKeysEnabled(self) -> bool: ...

    def getFocusTraversalPolicy(self) -> java.awt.FocusTraversalPolicy: ...

    def getFont(self) -> java.awt.Font: ...

    def getFontMetrics(self, __a0: java.awt.Font) -> java.awt.FontMetrics: ...

    def getForeground(self) -> java.awt.Color: ...

    def getGTSelectionModel(self) -> docking.widgets.tree.internal.GTreeSelectionModel: ...

    def getGraphics(self) -> java.awt.Graphics: ...

    def getGraphicsConfiguration(self) -> java.awt.GraphicsConfiguration: ...

    def getHeight(self) -> int: ...

    def getHierarchyBoundsListeners(self) -> List[java.awt.event.HierarchyBoundsListener]: ...

    def getHierarchyListeners(self) -> List[java.awt.event.HierarchyListener]: ...

    def getIgnoreRepaint(self) -> bool: ...

    def getInheritsPopupMenu(self) -> bool: ...

    def getInputContext(self) -> java.awt.im.InputContext: ...

    @overload
    def getInputMap(self) -> javax.swing.InputMap: ...

    @overload
    def getInputMap(self, __a0: int) -> javax.swing.InputMap: ...

    def getInputMethodListeners(self) -> List[java.awt.event.InputMethodListener]: ...

    def getInputMethodRequests(self) -> java.awt.im.InputMethodRequests: ...

    def getInputVerifier(self) -> javax.swing.InputVerifier: ...

    @overload
    def getInsets(self) -> java.awt.Insets: ...

    @overload
    def getInsets(self, __a0: java.awt.Insets) -> java.awt.Insets: ...

    def getKeyListeners(self) -> List[java.awt.event.KeyListener]: ...

    def getLastSelectedPathComponent(self) -> docking.widgets.tree.GTreeNode: ...

    def getLayout(self) -> java.awt.LayoutManager: ...

    def getListeners(self, __a0: java.lang.Class) -> List[java.util.EventListener]: ...

    def getLocale(self) -> java.util.Locale: ...

    @overload
    def getLocation(self) -> java.awt.Point: ...

    @overload
    def getLocation(self, __a0: java.awt.Point) -> java.awt.Point: ...

    def getLocationOnScreen(self) -> java.awt.Point: ...

    def getMaximumSize(self) -> java.awt.Dimension: ...

    def getMinimumSize(self) -> java.awt.Dimension: ...

    def getModel(self) -> docking.widgets.tree.internal.GTreeModel:
        """
        Returns the model for this tree
        @return the model for this tree
        """
        ...

    def getModelNode(self, node: docking.widgets.tree.GTreeNode) -> docking.widgets.tree.GTreeNode:
        """
        Gets the model node for the given node. This is useful if the node that is in the path has
         been replaced by a new node that is equal, but a different instance. One way this happens is
         if the tree is filtered and therefor the displayed nodes are clones of the model nodes. This
         can also happen if the tree nodes are rebuilt for some reason.
        @param node the node
        @return the corresponding model node in the tree. If the tree is filtered the viewed node
                 will be a clone of the corresponding model node.
        """
        ...

    def getModelNodeForPath(self, path: javax.swing.tree.TreePath) -> docking.widgets.tree.GTreeNode:
        """
        Gets the model node for the given path. This is useful if the node that is in the path has
         been replaced by a new node that is equal, but a different instance. One way this happens is
         if the tree is filtered and therefor the displayed nodes are clones of the model nodes. This
         can also happen if the tree nodes are rebuilt for some reason.
        @param path the path of the node
        @return the corresponding model node in the tree. If the tree is filtered the viewed node
                 will be a clone of the corresponding model node.
        """
        ...

    def getModelRoot(self) -> docking.widgets.tree.GTreeNode:
        """
        This method returns the root node that was provided to the tree by the client, whether from
         the constructor or from {@link #setRootNode(GTreeNode)}. This node represents the data model
         and always contains all the nodes regardless of any filter being applied. If a filter is
         applied to the tree, then this is not the actual root node being displayed by the
         {@link JTree}.
        @return the root node as provided by the client.
        """
        ...

    def getMouseListeners(self) -> List[java.awt.event.MouseListener]: ...

    def getMouseMotionListeners(self) -> List[java.awt.event.MouseMotionListener]: ...

    @overload
    def getMousePosition(self) -> java.awt.Point: ...

    @overload
    def getMousePosition(self, __a0: bool) -> java.awt.Point: ...

    def getMouseWheelListeners(self) -> List[java.awt.event.MouseWheelListener]: ...

    def getName(self) -> unicode: ...

    def getNextFocusableComponent(self) -> java.awt.Component: ...

    def getNodeForLocation(self, x: int, y: int) -> docking.widgets.tree.GTreeNode: ...

    def getParent(self) -> java.awt.Container: ...

    def getPathBounds(self, path: javax.swing.tree.TreePath) -> java.awt.Rectangle: ...

    def getPathForLocation(self, x: int, y: int) -> javax.swing.tree.TreePath: ...

    def getPathForRow(self, row: int) -> javax.swing.tree.TreePath: ...

    def getPopupLocation(self, __a0: java.awt.event.MouseEvent) -> java.awt.Point: ...

    def getPreferredSize(self) -> java.awt.Dimension: ...

    @overload
    def getPropertyChangeListeners(self) -> List[java.beans.PropertyChangeListener]: ...

    @overload
    def getPropertyChangeListeners(self, __a0: unicode) -> List[java.beans.PropertyChangeListener]: ...

    def getRegisteredKeyStrokes(self) -> List[javax.swing.KeyStroke]: ...

    def getRootPane(self) -> javax.swing.JRootPane: ...

    def getRowCount(self) -> int: ...

    def getRowForPath(self, treePath: javax.swing.tree.TreePath) -> int: ...

    def getSelectedNodes(self) -> List[docking.widgets.tree.GTreeNode]: ...

    def getSelectionCount(self) -> int: ...

    def getSelectionModel(self) -> javax.swing.tree.TreeSelectionModel: ...

    def getSelectionPath(self) -> javax.swing.tree.TreePath: ...

    def getSelectionPaths(self) -> List[javax.swing.tree.TreePath]: ...

    @overload
    def getSize(self) -> java.awt.Dimension: ...

    @overload
    def getSize(self, __a0: java.awt.Dimension) -> java.awt.Dimension: ...

    def getToolTipLocation(self, __a0: java.awt.event.MouseEvent) -> java.awt.Point: ...

    @overload
    def getToolTipText(self) -> unicode: ...

    @overload
    def getToolTipText(self, event: java.awt.event.MouseEvent) -> unicode: ...

    def getToolkit(self) -> java.awt.Toolkit: ...

    def getTopLevelAncestor(self) -> java.awt.Container: ...

    def getTransferHandler(self) -> javax.swing.TransferHandler: ...

    def getTreeLock(self) -> object: ...

    @overload
    def getTreeState(self) -> docking.widgets.tree.GTreeState:
        """
        Returns a state object that allows this tree to later restore its expanded and selected
         state.
         <p>
         <b>Note: </b>See the usage note at the header of this class concerning how tree state is used
         relative to the <code>equals()</code> method.
        @return the saved state
        """
        ...

    @overload
    def getTreeState(self, node: docking.widgets.tree.GTreeNode) -> docking.widgets.tree.GTreeState: ...

    def getUI(self) -> javax.swing.plaf.ComponentUI: ...

    def getUIClassID(self) -> unicode: ...

    def getVerifyInputWhenFocusTarget(self) -> bool: ...

    def getVetoableChangeListeners(self) -> List[java.beans.VetoableChangeListener]: ...

    def getViewNode(self, node: docking.widgets.tree.GTreeNode) -> docking.widgets.tree.GTreeNode:
        """
        Gets the view node for the given node. This is useful to translate to a tree path that is
         valid for the currently displayed tree. (Remember that if the tree is filtered, then the
         displayed nodes are clones of the model nodes.)
        @param node the node
        @return the current node in the displayed (possibly filtered) tree
        """
        ...

    def getViewNodeForPath(self, path: javax.swing.tree.TreePath) -> docking.widgets.tree.GTreeNode:
        """
        Gets the view node for the given path. This is useful to translate to a tree path that is
         valid for the currently displayed tree. (Remember that if the tree is filtered, then the
         displayed nodes are clones of the model nodes.)
        @param path the path of the node
        @return the current node in the displayed (possibly filtered) tree
        """
        ...

    def getViewPosition(self) -> java.awt.Point:
        """
        Returns the current viewport position of the scrollable tree.
        @return the current viewport position of the scrollable tree.
        """
        ...

    def getViewRect(self) -> java.awt.Rectangle: ...

    def getViewRoot(self) -> docking.widgets.tree.GTreeNode:
        """
        This method returns the root node currently being displayed by the {@link JTree}. If there
         are no filters applied, then this will be the same as the model root (See
         {@link #getModelRoot()}). If a filter is applied, then this will be a clone of the model root
         that contains clones of all nodes matching the filter.
        @return the root node currently being display by the {@link JTree}
        """
        ...

    def getVisibleRect(self) -> java.awt.Rectangle: ...

    def getWidth(self) -> int: ...

    def getX(self) -> int: ...

    def getY(self) -> int: ...

    def gotFocus(self, __a0: java.awt.Event, __a1: object) -> bool: ...

    def grabFocus(self) -> None: ...

    def handleEvent(self, __a0: java.awt.Event) -> bool: ...

    def hasFilterText(self) -> bool: ...

    def hasFocus(self) -> bool: ...

    def hashCode(self) -> int: ...

    def hide(self) -> None: ...

    def imageUpdate(self, __a0: java.awt.Image, __a1: int, __a2: int, __a3: int, __a4: int, __a5: int) -> bool: ...

    def inside(self, __a0: int, __a1: int) -> bool: ...

    def invalidate(self) -> None: ...

    def isAncestorOf(self, __a0: java.awt.Component) -> bool: ...

    def isBackgroundSet(self) -> bool: ...

    def isBusy(self) -> bool: ...

    def isCollapsed(self, path: javax.swing.tree.TreePath) -> bool: ...

    def isCursorSet(self) -> bool: ...

    def isDisplayable(self) -> bool: ...

    def isDisposed(self) -> bool: ...

    def isDoubleBuffered(self) -> bool: ...

    def isEditing(self) -> bool: ...

    def isEnabled(self) -> bool: ...

    def isExpanded(self, treePath: javax.swing.tree.TreePath) -> bool: ...

    def isFiltered(self) -> bool: ...

    def isFilteringEnabled(self) -> bool: ...

    @overload
    def isFocusCycleRoot(self) -> bool: ...

    @overload
    def isFocusCycleRoot(self, __a0: java.awt.Container) -> bool: ...

    def isFocusOwner(self) -> bool: ...

    def isFocusTraversable(self) -> bool: ...

    def isFocusTraversalPolicyProvider(self) -> bool: ...

    def isFocusTraversalPolicySet(self) -> bool: ...

    def isFocusable(self) -> bool: ...

    def isFontSet(self) -> bool: ...

    def isForegroundSet(self) -> bool: ...

    def isLightweight(self) -> bool: ...

    @staticmethod
    def isLightweightComponent(__a0: java.awt.Component) -> bool: ...

    def isManagingFocus(self) -> bool: ...

    def isMaximumSizeSet(self) -> bool: ...

    def isMinimumSizeSet(self) -> bool: ...

    def isMyJTree(self, jTree: javax.swing.JTree) -> bool:
        """
        Returns true if the given JTree is the actual JTree used by this GTree.
        @param jTree the tree to test
        @return true if the given JTree is the actual JTree used by this GTree.
        """
        ...

    def isOpaque(self) -> bool: ...

    def isOptimizedDrawingEnabled(self) -> bool: ...

    def isPaintingForPrint(self) -> bool: ...

    def isPaintingTile(self) -> bool: ...

    def isPathEditable(self, path: javax.swing.tree.TreePath) -> bool: ...

    def isPathSelected(self, treePath: javax.swing.tree.TreePath) -> bool: ...

    def isPreferredSizeSet(self) -> bool: ...

    def isRequestFocusEnabled(self) -> bool: ...

    def isRootAllowedToCollapse(self) -> bool: ...

    def isRootVisible(self) -> bool: ...

    def isShowing(self) -> bool: ...

    def isValid(self) -> bool: ...

    def isValidateRoot(self) -> bool: ...

    def isVisible(self) -> bool: ...

    def keyDown(self, __a0: java.awt.Event, __a1: int) -> bool: ...

    def keyUp(self, __a0: java.awt.Event, __a1: int) -> bool: ...

    @overload
    def list(self) -> None: ...

    @overload
    def list(self, __a0: java.io.PrintStream) -> None: ...

    @overload
    def list(self, __a0: java.io.PrintWriter) -> None: ...

    @overload
    def list(self, __a0: java.io.PrintStream, __a1: int) -> None: ...

    @overload
    def list(self, __a0: java.io.PrintWriter, __a1: int) -> None: ...

    def locate(self, __a0: int, __a1: int) -> java.awt.Component: ...

    def location(self) -> java.awt.Point: ...

    def lostFocus(self, __a0: java.awt.Event, __a1: object) -> bool: ...

    def mouseDown(self, __a0: java.awt.Event, __a1: int, __a2: int) -> bool: ...

    def mouseDrag(self, __a0: java.awt.Event, __a1: int, __a2: int) -> bool: ...

    def mouseEnter(self, __a0: java.awt.Event, __a1: int, __a2: int) -> bool: ...

    def mouseExit(self, __a0: java.awt.Event, __a1: int, __a2: int) -> bool: ...

    def mouseMove(self, __a0: java.awt.Event, __a1: int, __a2: int) -> bool: ...

    def mouseUp(self, __a0: java.awt.Event, __a1: int, __a2: int) -> bool: ...

    def move(self, __a0: int, __a1: int) -> None: ...

    def nextFocus(self) -> None: ...

    def notify(self) -> None: ...

    def notifyAll(self) -> None: ...

    def paint(self, __a0: java.awt.Graphics) -> None: ...

    def paintAll(self, __a0: java.awt.Graphics) -> None: ...

    def paintComponents(self, __a0: java.awt.Graphics) -> None: ...

    @overload
    def paintImmediately(self, __a0: java.awt.Rectangle) -> None: ...

    @overload
    def paintImmediately(self, __a0: int, __a1: int, __a2: int, __a3: int) -> None: ...

    def postEvent(self, __a0: java.awt.Event) -> bool: ...

    @overload
    def prepareImage(self, __a0: java.awt.Image, __a1: java.awt.image.ImageObserver) -> bool: ...

    @overload
    def prepareImage(self, __a0: java.awt.Image, __a1: int, __a2: int, __a3: java.awt.image.ImageObserver) -> bool: ...

    def print(self, __a0: java.awt.Graphics) -> None: ...

    def printAll(self, __a0: java.awt.Graphics) -> None: ...

    def printComponents(self, __a0: java.awt.Graphics) -> None: ...

    @staticmethod
    def printEvent(out: java.io.PrintWriter, name: unicode, e: javax.swing.event.TreeModelEvent) -> None:
        """
        This method is useful for debugging tree problems. Don't know where else to put it.
        @param out the output writer
        @param name use this to indicate what tree event occurred ("node inserted" "node removed",
                    etc.)
        @param e the TreeModelEvent;
        """
        ...

    def putClientProperty(self, __a0: object, __a1: object) -> None: ...

    @overload
    def refilterLater(self) -> None:
        """
        Causes the tree to refilter some time later
        """
        ...

    @overload
    def refilterLater(self, newNode: docking.widgets.tree.GTreeNode) -> None:
        """
        Re-filters the tree if the newNode should be included in the current filter results. If the
         new node doesn't match the filter, there is no need to refilter the tree.
        @param newNode the node that may cause the tree to refilter.
        """
        ...

    def refilterNow(self) -> None:
        """
        Causes the tree to refilter immediately (before this method returns)
        """
        ...

    @overload
    def registerKeyboardAction(self, __a0: java.awt.event.ActionListener, __a1: javax.swing.KeyStroke, __a2: int) -> None: ...

    @overload
    def registerKeyboardAction(self, __a0: java.awt.event.ActionListener, __a1: unicode, __a2: javax.swing.KeyStroke, __a3: int) -> None: ...

    @overload
    def remove(self, __a0: int) -> None: ...

    @overload
    def remove(self, __a0: java.awt.Component) -> None: ...

    @overload
    def remove(self, __a0: java.awt.MenuComponent) -> None: ...

    def removeAll(self) -> None: ...

    def removeAncestorListener(self, __a0: javax.swing.event.AncestorListener) -> None: ...

    def removeComponentListener(self, __a0: java.awt.event.ComponentListener) -> None: ...

    def removeContainerListener(self, __a0: java.awt.event.ContainerListener) -> None: ...

    def removeFocusListener(self, __a0: java.awt.event.FocusListener) -> None: ...

    def removeGTModelListener(self, listener: javax.swing.event.TreeModelListener) -> None: ...

    def removeGTreeSelectionListener(self, listener: docking.widgets.tree.support.GTreeSelectionListener) -> None: ...

    def removeHierarchyBoundsListener(self, __a0: java.awt.event.HierarchyBoundsListener) -> None: ...

    def removeHierarchyListener(self, __a0: java.awt.event.HierarchyListener) -> None: ...

    def removeInputMethodListener(self, __a0: java.awt.event.InputMethodListener) -> None: ...

    def removeKeyListener(self, __a0: java.awt.event.KeyListener) -> None: ...

    def removeMouseListener(self, listener: java.awt.event.MouseListener) -> None: ...

    def removeMouseMotionListener(self, __a0: java.awt.event.MouseMotionListener) -> None: ...

    def removeMouseWheelListener(self, __a0: java.awt.event.MouseWheelListener) -> None: ...

    def removeNotify(self) -> None: ...

    @overload
    def removePropertyChangeListener(self, __a0: java.beans.PropertyChangeListener) -> None: ...

    @overload
    def removePropertyChangeListener(self, __a0: unicode, __a1: java.beans.PropertyChangeListener) -> None: ...

    def removeSelectionPath(self, path: javax.swing.tree.TreePath) -> None: ...

    def removeTreeExpansionListener(self, listener: javax.swing.event.TreeExpansionListener) -> None: ...

    def removeVetoableChangeListener(self, __a0: java.beans.VetoableChangeListener) -> None: ...

    @overload
    def repaint(self) -> None: ...

    @overload
    def repaint(self, __a0: long) -> None: ...

    @overload
    def repaint(self, __a0: java.awt.Rectangle) -> None: ...

    @overload
    def repaint(self, __a0: int, __a1: int, __a2: int, __a3: int) -> None: ...

    @overload
    def repaint(self, __a0: long, __a1: int, __a2: int, __a3: int, __a4: int) -> None: ...

    def requestDefaultFocus(self) -> bool: ...

    @overload
    def requestFocus(self) -> None: ...

    @overload
    def requestFocus(self, __a0: bool) -> bool: ...

    @overload
    def requestFocus(self, __a0: java.awt.event.FocusEvent.Cause) -> None: ...

    @overload
    def requestFocusInWindow(self) -> bool: ...

    @overload
    def requestFocusInWindow(self, __a0: java.awt.event.FocusEvent.Cause) -> bool: ...

    def resetKeyboardActions(self) -> None: ...

    def reshape(self, __a0: int, __a1: int, __a2: int, __a3: int) -> None: ...

    @overload
    def resize(self, __a0: java.awt.Dimension) -> None: ...

    @overload
    def resize(self, __a0: int, __a1: int) -> None: ...

    def restoreTreeState(self, state: docking.widgets.tree.GTreeState) -> None:
        """
        Restores the expanded and selected state of this tree to that contained in the given state
         object.
         <p>
         <b>Note: </b>See the usage note at the header of this class concerning how tree state is used
         relative to the <code>equals()</code> method.
        @param state the state to restore
        @see #getTreeState()
        @see #getTreeState(GTreeNode)
        """
        ...

    def revalidate(self) -> None: ...

    def runBulkTask(self, task: docking.widgets.tree.tasks.GTreeBulkTask) -> None: ...

    @overload
    def runTask(self, task: docking.widgets.tree.GTreeTask) -> None:
        """
        Used to run tree tasks. This method is not meant for general clients of this tree, but rather
         for tasks to tell the tree to perform subtasks.
        @param task the task to run
        """
        ...

    @overload
    def runTask(self, runnableTask: ghidra.util.task.MonitoredRunnable) -> None:
        """
        Used to run simple GTree tasks that can be expressed as a {@link MonitoredRunnable} (or a
         lambda taking a {@link TaskMonitor}).
         <p>
        @param runnableTask {@link TaskMonitor} to watch and update with progress.
        """
        ...

    def scrollPathToVisible(self, treePath: javax.swing.tree.TreePath) -> None: ...

    def scrollRectToVisible(self, __a0: java.awt.Rectangle) -> None: ...

    def setActionMap(self, __a0: javax.swing.ActionMap) -> None: ...

    def setActiveDropTargetNode(self, node: docking.widgets.tree.GTreeNode) -> None: ...

    def setAlignmentX(self, __a0: float) -> None: ...

    def setAlignmentY(self, __a0: float) -> None: ...

    def setAutoscrolls(self, __a0: bool) -> None: ...

    def setBackground(self, __a0: java.awt.Color) -> None: ...

    def setBorder(self, __a0: javax.swing.border.Border) -> None: ...

    @overload
    def setBounds(self, __a0: java.awt.Rectangle) -> None: ...

    @overload
    def setBounds(self, __a0: int, __a1: int, __a2: int, __a3: int) -> None: ...

    def setBusy(self, busy: bool) -> None: ...

    def setCellEditor(self, editor: javax.swing.tree.TreeCellEditor) -> None: ...

    def setCellRenderer(self, renderer: docking.widgets.tree.support.GTreeRenderer) -> None: ...

    def setComponentOrientation(self, __a0: java.awt.ComponentOrientation) -> None: ...

    def setComponentPopupMenu(self, __a0: javax.swing.JPopupMenu) -> None: ...

    def setComponentZOrder(self, __a0: java.awt.Component, __a1: int) -> None: ...

    def setCursor(self, __a0: java.awt.Cursor) -> None: ...

    def setDataTransformer(self, transformer: ghidra.util.FilterTransformer) -> None:
        """
        Sets a transformer object used to perform filtering. This object is responsible for turning
         the tree's nodes into a list of strings that can be searched when filtering.
        @param transformer the transformer to set
        """
        ...

    def setDebugGraphicsOptions(self, __a0: int) -> None: ...

    @staticmethod
    def setDefaultLocale(__a0: java.util.Locale) -> None: ...

    def setDoubleBuffered(self, __a0: bool) -> None: ...

    def setDragNDropHandler(self, dragNDropHandler: docking.widgets.tree.support.GTreeDragNDropHandler) -> None: ...

    def setDropTarget(self, __a0: java.awt.dnd.DropTarget) -> None: ...

    def setEditable(self, editable: bool) -> None: ...

    def setEnabled(self, enabled: bool) -> None: ...

    def setEventsEnabled(self, b: bool) -> None:
        """
        Turns tree event notifications on/off
        @param b true to enable events, false to disable events
        """
        ...

    def setFilterFieldEnabled(self, enabled: bool) -> None:
        """
        Disabled the filter text field, but allows the tree to still filter. This is useful if you
         want to allow programmatic filtering, but to not allow the user to filter.
        @param enabled True makes the filter field editable; false makes it uneditable
        @see #setFilteringEnabled(boolean)
        """
        ...

    def setFilterProvider(self, filterProvider: docking.widgets.tree.GTreeFilterProvider) -> None: ...

    def setFilterText(self, text: unicode) -> None: ...

    def setFilterVisible(self, visible: bool) -> None:
        """
        Hides the filter field. Filtering will still take place, as defined by the
         {@link GTreeFilterProvider}.
        @param visible true to show the filter; false to hide it.
        @see #setFilteringEnabled(boolean)
        """
        ...

    def setFilteringEnabled(self, enabled: bool) -> None:
        """
        Disables all filtering performed by this tree. Also, the filter field of the tree will be
         disabled.
         <p>
         Use this method to temporarily disable filtering.
        @param enabled True to allow normal filtering; false to disable all filtering
        @see #setFilterFieldEnabled(boolean)
        """
        ...

    def setFocusCycleRoot(self, __a0: bool) -> None: ...

    def setFocusTraversalKeys(self, __a0: int, __a1: java.util.Set) -> None: ...

    def setFocusTraversalKeysEnabled(self, __a0: bool) -> None: ...

    def setFocusTraversalPolicy(self, __a0: java.awt.FocusTraversalPolicy) -> None: ...

    def setFocusTraversalPolicyProvider(self, __a0: bool) -> None: ...

    def setFocusable(self, __a0: bool) -> None: ...

    def setFont(self, __a0: java.awt.Font) -> None: ...

    def setForeground(self, __a0: java.awt.Color) -> None: ...

    def setHorizontalScrollPolicy(self, policy: int) -> None: ...

    def setIgnoreRepaint(self, __a0: bool) -> None: ...

    def setInheritsPopupMenu(self, __a0: bool) -> None: ...

    def setInputMap(self, __a0: int, __a1: javax.swing.InputMap) -> None: ...

    def setInputVerifier(self, __a0: javax.swing.InputVerifier) -> None: ...

    def setLayout(self, __a0: java.awt.LayoutManager) -> None: ...

    def setLocale(self, __a0: java.util.Locale) -> None: ...

    @overload
    def setLocation(self, __a0: java.awt.Point) -> None: ...

    @overload
    def setLocation(self, __a0: int, __a1: int) -> None: ...

    def setMaximumSize(self, __a0: java.awt.Dimension) -> None: ...

    def setMinimumSize(self, __a0: java.awt.Dimension) -> None: ...

    def setMixingCutoutShape(self, __a0: java.awt.Shape) -> None: ...

    def setName(self, __a0: unicode) -> None: ...

    def setNextFocusableComponent(self, __a0: java.awt.Component) -> None: ...

    def setNodeEditable(self, child: docking.widgets.tree.GTreeNode) -> None: ...

    def setOpaque(self, __a0: bool) -> None: ...

    def setPaintHandlesForLeafNodes(self, enable: bool) -> None:
        """
        Passing a value of <code>false</code> signals to disable the {@link JTree}'s default behavior
         of showing handles for leaf nodes until they are opened.
        @param enable False to disable the default JTree behavior
        """
        ...

    def setPreferredSize(self, __a0: java.awt.Dimension) -> None: ...

    def setRequestFocusEnabled(self, __a0: bool) -> None: ...

    def setRootNode(self, rootNode: docking.widgets.tree.GTreeNode) -> None:
        """
        Sets the root node for this tree.
         <P>
         NOTE: if this method is not called from the Swing thread, then the root node will be set
         later on the Swing thread. That is, this method will return before the work has been done.
        @param rootNode The node to set as the new root.
        """
        ...

    def setRootNodeAllowedToCollapse(self, allowed: bool) -> None: ...

    def setRootVisible(self, b: bool) -> None: ...

    def setRowHeight(self, rowHeight: int) -> None: ...

    def setScrollableUnitIncrement(self, increment: int) -> None:
        """
        Sets the size of the scroll when mouse scrolling or pressing the scroll up/down buttons. Most
         clients will not need this method, as the default behavior of the tree is correct, which is
         to scroll based upon the size of the nodes (which is usually uniform and a single row in
         size). However, some clients that have variable row height, with potentially large rows, may
         wish to change the scrolling behavior so that it is not too fast.
        @param increment the new (uniform) scroll increment.
        """
        ...

    def setSelectedNode(self, node: docking.widgets.tree.GTreeNode) -> None: ...

    def setSelectedNodeByNamePath(self, namePath: List[unicode]) -> None:
        """
        A convenience method to select a node by a path, starting with the tree root name, down each
         level until the desired node name.
        @param namePath The path to select
        """
        ...

    def setSelectedNodeByPathName(self, treePath: javax.swing.tree.TreePath) -> None:
        """
        Selects the node that matches the each name in the given tree path. It is worth noting that
         the items in the tree path themselves are not used to identify nodes, but the
         {@link #toString()} of those items will be used.
        @param treePath The path containing the names of the path of the node to select
        """
        ...

    @overload
    def setSelectedNodes(self, nodes: List[docking.widgets.tree.GTreeNode]) -> None: ...

    @overload
    def setSelectedNodes(self, nodes: java.util.Collection) -> None: ...

    def setSelectionModel(self, selectionModel: docking.widgets.tree.internal.GTreeSelectionModel) -> None: ...

    def setSelectionPath(self, path: javax.swing.tree.TreePath) -> None: ...

    @overload
    def setSelectionPaths(self, paths: List[javax.swing.tree.TreePath]) -> None: ...

    @overload
    def setSelectionPaths(self, __a0: List[object]) -> None: ...

    @overload
    def setSelectionPaths(self, path: List[javax.swing.tree.TreePath], origin: docking.widgets.tree.support.GTreeSelectionEvent.EventOrigin) -> None: ...

    def setSeletedNodeByName(self, parentNode: docking.widgets.tree.GTreeNode, childName: unicode) -> None:
        """
        A convenience method that allows clients that have created a new child node to select that
         node in the tree, without having to lookup the actual GTreeNode implementation.
        @param parentNode The parent containing a child by the given name
        @param childName The name of the child to select
        """
        ...

    def setShowsRootHandles(self, b: bool) -> None: ...

    @overload
    def setSize(self, __a0: java.awt.Dimension) -> None: ...

    @overload
    def setSize(self, __a0: int, __a1: int) -> None: ...

    def setToolTipText(self, __a0: unicode) -> None: ...

    def setTransferHandler(self, handler: javax.swing.TransferHandler) -> None: ...

    def setUI(self, __a0: javax.swing.plaf.PanelUI) -> None: ...

    def setVerifyInputWhenFocusTarget(self, __a0: bool) -> None: ...

    def setViewPosition(self, p: java.awt.Point) -> None: ...

    def setVisible(self, __a0: bool) -> None: ...

    @overload
    def show(self) -> None: ...

    @overload
    def show(self, __a0: bool) -> None: ...

    @overload
    def startEditing(self, node: docking.widgets.tree.GTreeNode) -> None:
        """
        Requests that the node be edited. This operation is asynchronous.
        @param node the node to edit
        """
        ...

    @overload
    def startEditing(self, parent: docking.widgets.tree.GTreeNode, childName: unicode) -> None:
        """
        Requests that the node with the given name, in the given parent, be edited. This operation is
         asynchronous. This request will be buffered as needed to wait for the given node to be added
         to the parent, up to a timeout period.
        @param parent the parent node
        @param childName the name of the child to edit
        """
        ...

    def stopEditing(self) -> None: ...

    def toString(self) -> unicode: ...

    def transferFocus(self) -> None: ...

    def transferFocusBackward(self) -> None: ...

    def transferFocusDownCycle(self) -> None: ...

    def transferFocusUpCycle(self) -> None: ...

    def unregisterKeyboardAction(self, __a0: javax.swing.KeyStroke) -> None: ...

    def update(self, __a0: java.awt.Graphics) -> None: ...

    def updateUI(self) -> None: ...

    def validate(self) -> None: ...

    @overload
    def wait(self) -> None: ...

    @overload
    def wait(self, __a0: long) -> None: ...

    @overload
    def wait(self, __a0: long, __a1: int) -> None: ...

    @property
    def lastSelectedPathComponent(self) -> docking.widgets.tree.GTreeNode: ...

    @property
    def selectionCount(self) -> int: ...