from typing import List
import ghidra.app.plugin.processors.sleigh
import ghidra.pcode.exec
import ghidra.program.model.listing
import ghidra.program.model.pcode
import java.lang
import java.lang.reflect
import java.util


class EmuSyscallLibrary(ghidra.pcode.exec.PcodeUseropLibrary, object):
    NIL: ghidra.pcode.exec.PcodeUseropLibrary = ghidra.pcode.exec.PcodeUseropLibrary$EmptyPcodeUseropLibrary@74fb254b
    SYSCALL_CONVENTION_NAME: unicode = u'syscall'
    SYSCALL_SPACE_NAME: unicode = u'syscall'




    class EmuSyscallDefinition(object):








        def equals(self, __a0: object) -> bool: ...

        def getClass(self) -> java.lang.Class: ...

        def hashCode(self) -> int: ...

        def invoke(self, __a0: ghidra.pcode.exec.PcodeExecutor, __a1: ghidra.pcode.exec.PcodeUseropLibrary) -> None: ...

        def notify(self) -> None: ...

        def notifyAll(self) -> None: ...

        def toString(self) -> unicode: ...

        @overload
        def wait(self) -> None: ...

        @overload
        def wait(self, __a0: long) -> None: ...

        @overload
        def wait(self, __a0: long, __a1: int) -> None: ...






    class SyscallPcodeUseropDefinition(object, ghidra.pcode.exec.PcodeUseropLibrary.PcodeUseropDefinition):




        def __init__(self, __a0: ghidra.pcode.emu.sys.EmuSyscallLibrary): ...



        def equals(self, __a0: object) -> bool: ...

        def execute(self, __a0: ghidra.pcode.exec.PcodeExecutor, __a1: ghidra.pcode.exec.PcodeUseropLibrary, __a2: ghidra.program.model.pcode.Varnode, __a3: List[object]) -> None: ...

        def getClass(self) -> java.lang.Class: ...

        def getInputCount(self) -> int: ...

        def getName(self) -> unicode: ...

        def hashCode(self) -> int: ...

        def notify(self) -> None: ...

        def notifyAll(self) -> None: ...

        def toString(self) -> unicode: ...

        @overload
        def wait(self) -> None: ...

        @overload
        def wait(self, __a0: long) -> None: ...

        @overload
        def wait(self, __a0: long, __a1: int) -> None: ...

        @property
        def inputCount(self) -> int: ...

        @property
        def name(self) -> unicode: ...





    def compose(self, __a0: ghidra.pcode.exec.PcodeUseropLibrary) -> ghidra.pcode.exec.PcodeUseropLibrary: ...

    def equals(self, __a0: object) -> bool: ...

    def getClass(self) -> java.lang.Class: ...

    @staticmethod
    def getOperandType(__a0: java.lang.Class) -> java.lang.reflect.Type: ...

    def getSymbols(self, __a0: ghidra.app.plugin.processors.sleigh.SleighLanguage) -> java.util.Map: ...

    def getSyscallUserop(self) -> ghidra.pcode.exec.PcodeUseropLibrary.PcodeUseropDefinition: ...

    def getSyscalls(self) -> java.util.Map: ...

    def getUserops(self) -> java.util.Map: ...

    def handleError(self, __a0: ghidra.pcode.exec.PcodeExecutor, __a1: ghidra.pcode.exec.PcodeExecutionException) -> bool: ...

    def hashCode(self) -> int: ...

    @staticmethod
    def loadSyscallConventionMap(__a0: ghidra.program.model.listing.Program) -> java.util.Map: ...

    @staticmethod
    def loadSyscallFunctionMap(__a0: ghidra.program.model.listing.Program) -> java.util.Map: ...

    @overload
    @staticmethod
    def loadSyscallNumberMap(__a0: unicode) -> java.util.Map: ...

    @overload
    @staticmethod
    def loadSyscallNumberMap(__a0: ghidra.program.model.listing.Program) -> java.util.Map: ...

    @staticmethod
    def nil() -> ghidra.pcode.exec.PcodeUseropLibrary: ...

    def notify(self) -> None: ...

    def notifyAll(self) -> None: ...

    def readSyscallNumber(self, __a0: ghidra.pcode.exec.PcodeExecutorState, __a1: ghidra.pcode.exec.PcodeExecutorStatePiece.Reason) -> long: ...

    def syscall(self, __a0: ghidra.pcode.exec.PcodeExecutor, __a1: ghidra.pcode.exec.PcodeUseropLibrary) -> None: ...

    def toString(self) -> unicode: ...

    @overload
    def wait(self) -> None: ...

    @overload
    def wait(self, __a0: long) -> None: ...

    @overload
    def wait(self, __a0: long, __a1: int) -> None: ...

    @property
    def syscallUserop(self) -> ghidra.pcode.exec.PcodeUseropLibrary.PcodeUseropDefinition: ...

    @property
    def syscalls(self) -> java.util.Map: ...

    @property
    def userops(self) -> java.util.Map: ...