from typing import List
import java.io
import java.lang


class DataTypeDependencyException(java.lang.Exception):
    """
    DataTypeDependencyException corresponds to a datatype dependency failure.
     This can occur under various situations, including when trying to replace a dataType 
     with a dataType that depends on the dataType being replaced.  This error may also occur
     when a datatype dependency can not be satisfied.
    """





    @overload
    def __init__(self): ...

    @overload
    def __init__(self, message: unicode): ...

    @overload
    def __init__(self, cause: java.lang.Throwable): ...

    @overload
    def __init__(self, message: unicode, cause: java.lang.Throwable): ...



    def addSuppressed(self, __a0: java.lang.Throwable) -> None: ...

    def equals(self, __a0: object) -> bool: ...

    def fillInStackTrace(self) -> java.lang.Throwable: ...

    def getCause(self) -> java.lang.Throwable: ...

    def getClass(self) -> java.lang.Class: ...

    def getLocalizedMessage(self) -> unicode: ...

    def getMessage(self) -> unicode: ...

    def getStackTrace(self) -> List[java.lang.StackTraceElement]: ...

    def getSuppressed(self) -> List[java.lang.Throwable]: ...

    def hashCode(self) -> int: ...

    def initCause(self, __a0: java.lang.Throwable) -> java.lang.Throwable: ...

    def notify(self) -> None: ...

    def notifyAll(self) -> None: ...

    @overload
    def printStackTrace(self) -> None: ...

    @overload
    def printStackTrace(self, __a0: java.io.PrintStream) -> None: ...

    @overload
    def printStackTrace(self, __a0: java.io.PrintWriter) -> None: ...

    def setStackTrace(self, __a0: List[java.lang.StackTraceElement]) -> None: ...

    def toString(self) -> unicode: ...

    @overload
    def wait(self) -> None: ...

    @overload
    def wait(self, __a0: long) -> None: ...

    @overload
    def wait(self, __a0: long, __a1: int) -> None: ...

