import ghidra.program.model.address
import ghidra.program.model.pcode
import java.io
import java.lang


class PackedEncodeOverlay(ghidra.program.model.pcode.PackedEncode):
    """
    Alter address space encoding for a specific overlay space.
     Any space that matches the overlay space is encoded as the overlayed space.
     This causes addresses in the overlay space to be converted into the underlying space.
    """





    def __init__(self, spc: ghidra.program.model.address.OverlayAddressSpace): ...



    def clear(self) -> None: ...

    def closeElement(self, elemId: ghidra.program.model.pcode.ElementId) -> None: ...

    def equals(self, __a0: object) -> bool: ...

    def getClass(self) -> java.lang.Class: ...

    def hashCode(self) -> int: ...

    def isEmpty(self) -> bool: ...

    def notify(self) -> None: ...

    def notifyAll(self) -> None: ...

    def openElement(self, elemId: ghidra.program.model.pcode.ElementId) -> None: ...

    def patchIntegerAttribute(self, pos: int, attribId: ghidra.program.model.pcode.AttributeId, val: long) -> bool: ...

    def setOverlay(self, spc: ghidra.program.model.address.OverlayAddressSpace) -> None: ...

    def size(self) -> int: ...

    def toString(self) -> unicode: ...

    @overload
    def wait(self) -> None: ...

    @overload
    def wait(self, __a0: long) -> None: ...

    @overload
    def wait(self, __a0: long, __a1: int) -> None: ...

    def writeBool(self, attribId: ghidra.program.model.pcode.AttributeId, val: bool) -> None: ...

    def writeSignedInteger(self, attribId: ghidra.program.model.pcode.AttributeId, val: long) -> None: ...

    def writeSpace(self, attribId: ghidra.program.model.pcode.AttributeId, spc: ghidra.program.model.address.AddressSpace) -> None: ...

    def writeSpaceId(self, attribId: ghidra.program.model.pcode.AttributeId, spaceId: long) -> None: ...

    def writeString(self, attribId: ghidra.program.model.pcode.AttributeId, val: unicode) -> None: ...

    def writeTo(self, stream: java.io.OutputStream) -> None: ...

    def writeUnsignedInteger(self, attribId: ghidra.program.model.pcode.AttributeId, val: long) -> None: ...

    @property
    def overlay(self) -> None: ...  # No getter available.

    @overlay.setter
    def overlay(self, value: ghidra.program.model.address.OverlayAddressSpace) -> None: ...