import com.google.common.collect
import ghidra.program.model.address
import ghidra.program.model.lang
import ghidra.trace.database.space
import ghidra.trace.model.bookmark
import ghidra.trace.model.thread
import java.lang
import java.util


class DBTraceBookmarkSpace(object, ghidra.trace.model.bookmark.TraceBookmarkSpace, ghidra.trace.database.space.DBTraceSpaceBased):




    def __init__(self, __a0: ghidra.trace.database.bookmark.DBTraceBookmarkManager, __a1: ghidra.program.model.address.AddressSpace, __a2: ghidra.trace.model.thread.TraceThread, __a3: int): ...



    @overload
    def addBookmark(self, __a0: com.google.common.collect.Range, __a1: ghidra.program.model.address.Address, __a2: ghidra.trace.model.bookmark.TraceBookmarkType, __a3: unicode, __a4: unicode) -> ghidra.trace.model.bookmark.TraceBookmark: ...

    @overload
    def addBookmark(self, __a0: com.google.common.collect.Range, __a1: ghidra.program.model.lang.Register, __a2: ghidra.trace.model.bookmark.TraceBookmarkType, __a3: unicode, __a4: unicode) -> ghidra.trace.model.bookmark.TraceBookmark: ...

    @overload
    def assertInSpace(self, __a0: ghidra.program.model.address.Address) -> long: ...

    @overload
    def assertInSpace(self, __a0: ghidra.program.model.address.AddressRange) -> None: ...

    @staticmethod
    def create(__a0: ghidra.program.model.address.AddressSpace, __a1: ghidra.trace.model.thread.TraceThread, __a2: int) -> ghidra.trace.database.space.DBTraceSpaceKey: ...

    def equals(self, __a0: object) -> bool: ...

    def explainLanguages(self, __a0: ghidra.program.model.address.AddressSpace) -> unicode: ...

    def getAddressSpace(self) -> ghidra.program.model.address.AddressSpace: ...

    def getAllBookmarks(self) -> java.util.Collection: ...

    def getBookmarksAt(self, __a0: long, __a1: ghidra.program.model.address.Address) -> java.lang.Iterable: ...

    def getBookmarksByType(self, __a0: unicode) -> java.util.Collection: ...

    @overload
    def getBookmarksEnclosed(self, __a0: com.google.common.collect.Range, __a1: ghidra.program.model.address.AddressRange) -> java.lang.Iterable: ...

    @overload
    def getBookmarksEnclosed(self, __a0: com.google.common.collect.Range, __a1: ghidra.program.model.lang.Register) -> java.lang.Iterable: ...

    @overload
    def getBookmarksIntersecting(self, __a0: com.google.common.collect.Range, __a1: ghidra.program.model.address.AddressRange) -> java.lang.Iterable: ...

    @overload
    def getBookmarksIntersecting(self, __a0: com.google.common.collect.Range, __a1: ghidra.program.model.lang.Register) -> java.lang.Iterable: ...

    def getCategoriesForType(self, __a0: ghidra.trace.model.bookmark.TraceBookmarkType) -> java.util.Set: ...

    def getClass(self) -> java.lang.Class: ...

    def getFrameLevel(self) -> int: ...

    def getThread(self) -> ghidra.trace.model.thread.TraceThread: ...

    def hashCode(self) -> int: ...

    def invalidateCache(self) -> None: ...

    def isMySpace(self, __a0: ghidra.program.model.address.AddressSpace) -> bool: ...

    def notify(self) -> None: ...

    def notifyAll(self) -> None: ...

    def toAddress(self, __a0: long) -> ghidra.program.model.address.Address: ...

    def toOverlay(self, __a0: ghidra.program.model.address.Address) -> ghidra.program.model.address.Address: ...

    def toString(self) -> unicode: ...

    @overload
    def wait(self) -> None: ...

    @overload
    def wait(self, __a0: long) -> None: ...

    @overload
    def wait(self, __a0: long, __a1: int) -> None: ...

    @property
    def addressSpace(self) -> ghidra.program.model.address.AddressSpace: ...

    @property
    def allBookmarks(self) -> java.util.Collection: ...

    @property
    def frameLevel(self) -> int: ...

    @property
    def thread(self) -> ghidra.trace.model.thread.TraceThread: ...