import com.google.common.collect
import ghidra.program.model.address
import ghidra.program.model.lang
import ghidra.trace.database
import ghidra.trace.database.data
import ghidra.trace.database.map
import ghidra.trace.database.space
import ghidra.trace.model
import ghidra.trace.model.map
import ghidra.trace.model.stack
import ghidra.trace.model.thread
import ghidra.trace.util
import ghidra.util.database
import ghidra.util.database.spatial
import java.io
import java.lang
import java.util
import java.util.concurrent.locks
import java.util.function


class DBTraceDataSettingsAdapter(ghidra.trace.database.map.DBTraceAddressSnapRangePropertyMap, ghidra.trace.database.data.DBTraceDataSettingsOperations):
    NAME: unicode = u'DataSettings'




    class DBTraceDataSettingsSpace(ghidra.trace.database.map.DBTraceAddressSnapRangePropertyMapSpace, ghidra.trace.database.data.DBTraceDataSettingsOperations):




        def __init__(self, __a0: ghidra.trace.database.data.DBTraceDataSettingsAdapter, __a1: unicode, __a2: ghidra.util.database.DBCachedObjectStoreFactory, __a3: java.util.concurrent.locks.ReadWriteLock, __a4: ghidra.program.model.address.AddressSpace, __a5: ghidra.trace.model.thread.TraceThread, __a6: int, __a7: java.lang.Class, __a8: ghidra.trace.database.map.DBTraceAddressSnapRangePropertyMap.DBTraceAddressSnapRangePropertyMapDataFactory): ...



        @overload
        def assertInSpace(self, __a0: ghidra.program.model.address.Address) -> long: ...

        @overload
        def assertInSpace(self, __a0: ghidra.program.model.address.AddressRange) -> None: ...

        @staticmethod
        def assertKnownType(__a0: object) -> None: ...

        def checkIntegrity(self) -> None: ...

        def clear(self) -> None: ...

        @staticmethod
        def create(__a0: ghidra.program.model.address.AddressSpace, __a1: ghidra.trace.model.thread.TraceThread, __a2: int) -> ghidra.trace.database.space.DBTraceSpaceKey: ...

        def deleteData(self, __a0: ghidra.trace.database.map.DBTraceAddressSnapRangePropertyMapTree.AbstractDBTraceAddressSnapRangePropertyMapData) -> None: ...

        def deleteValue(self, __a0: object) -> None: ...

        def doExactOrNew(self, __a0: com.google.common.collect.Range, __a1: ghidra.program.model.address.Address, __a2: unicode) -> ghidra.trace.database.data.DBTraceDataSettingsAdapter.DBTraceSettingsEntry: ...

        def doGetEntry(self, __a0: long, __a1: ghidra.program.model.address.Address, __a2: unicode) -> ghidra.trace.database.data.DBTraceDataSettingsAdapter.DBTraceSettingsEntry: ...

        def doGetExactEntry(self, __a0: com.google.common.collect.Range, __a1: ghidra.program.model.address.Address, __a2: unicode) -> ghidra.trace.database.data.DBTraceDataSettingsAdapter.DBTraceSettingsEntry: ...

        def doMakeWay(self, __a0: com.google.common.collect.Range, __a1: ghidra.program.model.address.Address, __a2: unicode) -> None: ...

        @staticmethod
        def emptyMap() -> ghidra.util.database.spatial.SpatialMap: ...

        def entries(self) -> java.util.Collection: ...

        def equals(self, __a0: object) -> bool: ...

        def explainLanguages(self, __a0: ghidra.program.model.address.AddressSpace) -> unicode: ...

        def firstEntry(self) -> java.util.Map.Entry: ...

        def firstKey(self) -> ghidra.util.database.spatial.BoundedShape: ...

        def firstValue(self) -> object: ...

        @overload
        def getAddressSetView(self, __a0: com.google.common.collect.Range) -> ghidra.program.model.address.AddressSetView: ...

        @overload
        def getAddressSetView(self, __a0: com.google.common.collect.Range, __a1: java.util.function.Predicate) -> ghidra.program.model.address.AddressSetView: ...

        def getAddressSpace(self) -> ghidra.program.model.address.AddressSpace: ...

        def getClass(self) -> java.lang.Class: ...

        def getDataByKey(self, __a0: long) -> ghidra.trace.database.map.DBTraceAddressSnapRangePropertyMapTree.AbstractDBTraceAddressSnapRangePropertyMapData: ...

        def getFrameLevel(self) -> int: ...

        def getLock(self) -> java.util.concurrent.locks.ReadWriteLock: ...

        def getLong(self, __a0: long, __a1: ghidra.program.model.address.Address, __a2: unicode) -> long: ...

        def getSettingNames(self, __a0: com.google.common.collect.Range, __a1: ghidra.program.model.address.Address) -> java.util.Collection: ...

        def getString(self, __a0: long, __a1: ghidra.program.model.address.Address, __a2: unicode) -> unicode: ...

        def getThread(self) -> ghidra.trace.model.thread.TraceThread: ...

        def getUserIndex(self, __a0: java.lang.Class, __a1: ghidra.util.database.DBObjectColumn) -> ghidra.util.database.DBCachedObjectIndex: ...

        def getValue(self, __a0: long, __a1: ghidra.program.model.address.Address, __a2: unicode) -> object: ...

        def hashCode(self) -> int: ...

        def invalidateCache(self) -> None: ...

        def isEmpty(self) -> bool: ...

        def isMySpace(self, __a0: ghidra.program.model.address.AddressSpace) -> bool: ...

        def keys(self) -> java.util.Collection: ...

        def makeWay(self, __a0: ghidra.trace.database.data.DBTraceDataSettingsAdapter.DBTraceSettingsEntry, __a1: com.google.common.collect.Range) -> None: ...

        def notify(self) -> None: ...

        def notifyAll(self) -> None: ...

        def orderedEntries(self) -> java.util.Collection: ...

        def orderedKeys(self) -> java.util.Collection: ...

        def orderedValues(self) -> java.util.Collection: ...

        @overload
        def put(self, __a0: ghidra.trace.model.TraceAddressSnapRange, __a1: object) -> object: ...

        @overload
        def put(self, __a0: ghidra.util.database.spatial.BoundedShape, __a1: object) -> object: ...

        @overload
        def put(self, __a0: ghidra.program.model.address.Address, __a1: com.google.common.collect.Range, __a2: object) -> object: ...

        @overload
        def put(self, __a0: ghidra.program.model.address.AddressRange, __a1: com.google.common.collect.Range, __a2: object) -> object: ...

        @overload
        def put(self, __a0: ghidra.program.model.address.Address, __a1: ghidra.program.model.address.Address, __a2: long, __a3: object) -> object: ...

        @overload
        def put(self, __a0: ghidra.program.model.address.Address, __a1: ghidra.program.model.address.Address, __a2: long, __a3: long, __a4: object) -> object: ...

        @overload
        def reduce(self, __a0: ghidra.trace.database.map.DBTraceAddressSnapRangePropertyMapTree.TraceAddressSnapRangeQuery) -> ghidra.util.database.spatial.SpatialMap: ...

        @overload
        def reduce(self, __a0: object) -> ghidra.util.database.spatial.SpatialMap: ...

        @overload
        def remove(self, __a0: java.util.Map.Entry) -> bool: ...

        @overload
        def remove(self, __a0: ghidra.trace.model.TraceAddressSnapRange, __a1: object) -> bool: ...

        @overload
        def remove(self, __a0: ghidra.util.database.spatial.BoundedShape, __a1: object) -> bool: ...

        def setLong(self, __a0: com.google.common.collect.Range, __a1: ghidra.program.model.address.Address, __a2: unicode, __a3: long) -> None: ...

        def setString(self, __a0: com.google.common.collect.Range, __a1: ghidra.program.model.address.Address, __a2: unicode, __a3: unicode) -> None: ...

        def setValue(self, __a0: com.google.common.collect.Range, __a1: ghidra.program.model.address.Address, __a2: unicode, __a3: object) -> None: ...

        def size(self) -> int: ...

        def toAddress(self, __a0: long) -> ghidra.program.model.address.Address: ...

        def toOverlay(self, __a0: ghidra.program.model.address.Address) -> ghidra.program.model.address.Address: ...

        def toString(self) -> unicode: ...

        def values(self) -> java.util.Collection: ...

        @overload
        def wait(self) -> None: ...

        @overload
        def wait(self, __a0: long) -> None: ...

        @overload
        def wait(self, __a0: long, __a1: int) -> None: ...

        @property
        def lock(self) -> java.util.concurrent.locks.ReadWriteLock: ...

    def __init__(self, __a0: db.DBHandle, __a1: ghidra.util.database.DBOpenMode, __a2: java.util.concurrent.locks.ReadWriteLock, __a3: ghidra.util.task.TaskMonitor, __a4: ghidra.program.model.lang.Language, __a5: ghidra.trace.database.DBTrace, __a6: ghidra.trace.database.thread.DBTraceThreadManager): ...



    @staticmethod
    def assertKnownType(__a0: object) -> None: ...

    def checkIsInMemory(self, __a0: ghidra.program.model.address.AddressSpace) -> None: ...

    def clear(self) -> None: ...

    def dbError(self, __a0: java.io.IOException) -> None: ...

    def delegateAddressSet(self, __a0: java.lang.Iterable, __a1: ghidra.trace.database.space.DBTraceDelegatingManager.ExcFunction) -> ghidra.program.model.address.AddressSetView: ...

    def delegateAny(self, __a0: java.lang.Iterable, __a1: ghidra.trace.database.space.DBTraceDelegatingManager.ExcPredicate) -> bool: ...

    def delegateCollection(self, __a0: java.lang.Iterable, __a1: java.util.function.Function) -> java.util.Collection: ...

    def delegateDeleteB(self, __a0: ghidra.program.model.address.AddressSpace, __a1: java.util.function.Predicate, __a2: bool) -> bool: ...

    def delegateDeleteV(self, __a0: ghidra.program.model.address.AddressSpace, __a1: ghidra.trace.database.space.DBTraceDelegatingManager.ExcConsumer) -> None: ...

    def delegateFirst(self, __a0: java.lang.Iterable, __a1: java.util.function.Function) -> object: ...

    def delegateHashSet(self, __a0: java.lang.Iterable, __a1: java.util.function.Function) -> java.util.HashSet: ...

    @overload
    def delegateRead(self, __a0: ghidra.program.model.address.AddressSpace, __a1: ghidra.trace.database.space.DBTraceDelegatingManager.ExcFunction) -> object: ...

    @overload
    def delegateRead(self, __a0: ghidra.program.model.address.AddressSpace, __a1: ghidra.trace.database.space.DBTraceDelegatingManager.ExcFunction, __a2: object) -> object: ...

    def delegateReadB(self, __a0: ghidra.program.model.address.AddressSpace, __a1: java.util.function.Predicate, __a2: bool) -> bool: ...

    @overload
    def delegateReadI(self, __a0: ghidra.program.model.address.AddressSpace, __a1: java.util.function.ToIntFunction, __a2: int) -> int: ...

    @overload
    def delegateReadI(self, __a0: ghidra.program.model.address.AddressSpace, __a1: java.util.function.ToIntFunction, __a2: java.util.function.IntSupplier) -> int: ...

    def delegateReadOr(self, __a0: ghidra.program.model.address.AddressSpace, __a1: ghidra.trace.database.space.DBTraceDelegatingManager.ExcFunction, __a2: ghidra.trace.database.space.DBTraceDelegatingManager.ExcSupplier) -> object: ...

    def delegateWrite(self, __a0: ghidra.program.model.address.AddressSpace, __a1: ghidra.trace.database.space.DBTraceDelegatingManager.ExcFunction) -> object: ...

    def delegateWriteAll(self, __a0: java.lang.Iterable, __a1: ghidra.trace.database.space.DBTraceDelegatingManager.ExcConsumer) -> None: ...

    def delegateWriteI(self, __a0: ghidra.program.model.address.AddressSpace, __a1: java.util.function.ToIntFunction) -> int: ...

    def delegateWriteV(self, __a0: ghidra.program.model.address.AddressSpace, __a1: ghidra.trace.database.space.DBTraceDelegatingManager.ExcConsumer) -> None: ...

    def deleteData(self, __a0: ghidra.trace.database.map.DBTraceAddressSnapRangePropertyMapTree.AbstractDBTraceAddressSnapRangePropertyMapData) -> None: ...

    def deleteValue(self, __a0: object) -> None: ...

    def doExactOrNew(self, __a0: com.google.common.collect.Range, __a1: ghidra.program.model.address.Address, __a2: unicode) -> ghidra.trace.database.data.DBTraceDataSettingsAdapter.DBTraceSettingsEntry: ...

    def doGetEntry(self, __a0: long, __a1: ghidra.program.model.address.Address, __a2: unicode) -> ghidra.trace.database.data.DBTraceDataSettingsAdapter.DBTraceSettingsEntry: ...

    def doGetExactEntry(self, __a0: com.google.common.collect.Range, __a1: ghidra.program.model.address.Address, __a2: unicode) -> ghidra.trace.database.data.DBTraceDataSettingsAdapter.DBTraceSettingsEntry: ...

    def doMakeWay(self, __a0: com.google.common.collect.Range, __a1: ghidra.program.model.address.Address, __a2: unicode) -> None: ...

    @staticmethod
    def emptyMap() -> ghidra.util.database.spatial.SpatialMap: ...

    def entries(self) -> java.util.Collection: ...

    def equals(self, __a0: object) -> bool: ...

    def firstEntry(self) -> java.util.Map.Entry: ...

    def firstKey(self) -> ghidra.util.database.spatial.BoundedShape: ...

    def firstValue(self) -> object: ...

    def get(self, __a0: ghidra.trace.util.TraceAddressSpace, __a1: bool) -> ghidra.trace.database.space.DBTraceSpaceBased: ...

    def getActiveMemorySpaces(self) -> java.util.Collection: ...

    def getActiveRegisterSpaces(self) -> java.util.Collection: ...

    def getActiveSpaces(self) -> java.util.Collection: ...

    @overload
    def getAddressSetView(self, __a0: com.google.common.collect.Range) -> ghidra.program.model.address.AddressSetView: ...

    @overload
    def getAddressSetView(self, __a0: com.google.common.collect.Range, __a1: java.util.function.Predicate) -> ghidra.program.model.address.AddressSetView: ...

    def getBaseLanguage(self) -> ghidra.program.model.lang.Language: ...

    def getClass(self) -> java.lang.Class: ...

    def getForSpace(self, __a0: ghidra.program.model.address.AddressSpace, __a1: bool) -> ghidra.trace.database.space.DBTraceSpaceBased: ...

    def getLock(self) -> java.util.concurrent.locks.ReadWriteLock: ...

    def getLong(self, __a0: long, __a1: ghidra.program.model.address.Address, __a2: unicode) -> long: ...

    def getName(self) -> unicode: ...

    @overload
    def getRegisterSpace(self, __a0: ghidra.trace.model.stack.TraceStackFrame, __a1: bool) -> ghidra.trace.model.map.TraceAddressSnapRangePropertyMapSpace: ...

    @overload
    def getRegisterSpace(self, __a0: ghidra.trace.model.thread.TraceThread, __a1: bool) -> ghidra.trace.database.data.DBTraceDataSettingsAdapter.DBTraceDataSettingsSpace: ...

    def getSettingNames(self, __a0: com.google.common.collect.Range, __a1: ghidra.program.model.address.Address) -> java.util.Collection: ...

    def getString(self, __a0: long, __a1: ghidra.program.model.address.Address, __a2: unicode) -> unicode: ...

    def getTrace(self) -> ghidra.trace.database.DBTrace: ...

    def getValue(self, __a0: long, __a1: ghidra.program.model.address.Address, __a2: unicode) -> object: ...

    def hashCode(self) -> int: ...

    def invalidateCache(self, __a0: bool) -> None: ...

    def isEmpty(self) -> bool: ...

    def keys(self) -> java.util.Collection: ...

    def makeWay(self, __a0: ghidra.trace.database.data.DBTraceDataSettingsAdapter.DBTraceSettingsEntry, __a1: com.google.common.collect.Range) -> None: ...

    def notify(self) -> None: ...

    def notifyAll(self) -> None: ...

    def orderedEntries(self) -> java.util.Collection: ...

    def orderedKeys(self) -> java.util.Collection: ...

    def orderedValues(self) -> java.util.Collection: ...

    @overload
    def put(self, __a0: ghidra.trace.model.TraceAddressSnapRange, __a1: object) -> object: ...

    @overload
    def put(self, __a0: ghidra.util.database.spatial.BoundedShape, __a1: object) -> object: ...

    @overload
    def put(self, __a0: ghidra.program.model.address.Address, __a1: com.google.common.collect.Range, __a2: object) -> object: ...

    @overload
    def put(self, __a0: ghidra.program.model.address.AddressRange, __a1: com.google.common.collect.Range, __a2: object) -> object: ...

    @overload
    def put(self, __a0: ghidra.program.model.address.Address, __a1: ghidra.program.model.address.Address, __a2: long, __a3: object) -> object: ...

    @overload
    def put(self, __a0: ghidra.program.model.address.Address, __a1: ghidra.program.model.address.Address, __a2: long, __a3: long, __a4: object) -> object: ...

    def readLock(self) -> java.util.concurrent.locks.Lock: ...

    @overload
    def reduce(self, __a0: ghidra.trace.database.map.DBTraceAddressSnapRangePropertyMapTree.TraceAddressSnapRangeQuery) -> ghidra.util.database.spatial.SpatialMap: ...

    @overload
    def reduce(self, __a0: object) -> ghidra.util.database.spatial.SpatialMap: ...

    @overload
    def remove(self, __a0: java.util.Map.Entry) -> bool: ...

    @overload
    def remove(self, __a0: ghidra.trace.model.TraceAddressSnapRange, __a1: object) -> bool: ...

    @overload
    def remove(self, __a0: ghidra.util.database.spatial.BoundedShape, __a1: object) -> bool: ...

    def setLong(self, __a0: com.google.common.collect.Range, __a1: ghidra.program.model.address.Address, __a2: unicode, __a3: long) -> None: ...

    def setString(self, __a0: com.google.common.collect.Range, __a1: ghidra.program.model.address.Address, __a2: unicode, __a3: unicode) -> None: ...

    def setValue(self, __a0: com.google.common.collect.Range, __a1: ghidra.program.model.address.Address, __a2: unicode, __a3: object) -> None: ...

    def size(self) -> int: ...

    def toString(self) -> unicode: ...

    def values(self) -> java.util.Collection: ...

    @overload
    def wait(self) -> None: ...

    @overload
    def wait(self, __a0: long) -> None: ...

    @overload
    def wait(self, __a0: long, __a1: int) -> None: ...

    def writeLock(self) -> java.util.concurrent.locks.Lock: ...

