from typing import List
import com.google.common.collect
import ghidra.program.model.address
import ghidra.trace.database.map
import ghidra.trace.model
import ghidra.trace.model.memory
import ghidra.util
import ghidra.util.database
import ghidra.util.database.spatial
import ghidra.util.database.spatial.rect
import java.lang
import java.util


class DBTraceMemoryRegion(ghidra.trace.database.map.DBTraceAddressSnapRangePropertyMapTree.AbstractDBTraceAddressSnapRangePropertyMapData, ghidra.trace.model.memory.TraceMemoryRegion):
    FLAGS_COLUMN_NAME: unicode = u'Flags'
    NAME_COLUMN_NAME: unicode = u'Name'
    PATH_COLUMN_NAME: unicode = u'Path'
    TABLE_NAME: unicode = u'MemoryRegions'



    def __init__(self, __a0: ghidra.trace.database.memory.DBTraceMemorySpace, __a1: ghidra.trace.database.map.DBTraceAddressSnapRangePropertyMapTree, __a2: ghidra.util.database.DBCachedObjectStore, __a3: db.DBRecord): ...



    @overload
    def addFlags(self, __a0: List[ghidra.trace.model.memory.TraceMemoryFlag]) -> None: ...

    @overload
    def addFlags(self, __a0: java.util.Collection) -> None: ...

    @staticmethod
    def boundsUnion(__a0: java.lang.Iterable) -> ghidra.util.database.spatial.BoundingShape: ...

    @overload
    def clearFlags(self, __a0: List[ghidra.trace.model.memory.TraceMemoryFlag]) -> None: ...

    @overload
    def clearFlags(self, __a0: java.util.Collection) -> None: ...

    @overload
    def computeAreaIntersection(self, __a0: ghidra.util.database.spatial.rect.Rectangle2D) -> float: ...

    @overload
    def computeAreaIntersection(self, __a0: ghidra.util.database.spatial.BoundingShape) -> float: ...

    @overload
    def computeAreaUnionBounds(self, __a0: ghidra.util.database.spatial.rect.Rectangle2D) -> float: ...

    @overload
    def computeAreaUnionBounds(self, __a0: ghidra.util.database.spatial.BoundingShape) -> float: ...

    @overload
    def computeCentroidDistance(self, __a0: ghidra.util.database.spatial.rect.Rectangle2D) -> float: ...

    @overload
    def computeCentroidDistance(self, __a0: ghidra.util.database.spatial.BoundingShape) -> float: ...

    @overload
    def contains(self, __a0: ghidra.util.database.spatial.rect.Point2D) -> bool: ...

    @overload
    def contains(self, __a0: object, __a1: object) -> bool: ...

    def delete(self) -> None: ...

    def description(self) -> unicode: ...

    def doEquals(self, __a0: object) -> bool: ...

    def doHashCode(self) -> int: ...

    def enclosedBy(self, __a0: ghidra.util.database.spatial.rect.Rectangle2D) -> bool: ...

    @overload
    def encloses(self, __a0: ghidra.util.database.spatial.rect.Rectangle2D) -> bool: ...

    @overload
    def encloses(self, __a0: ghidra.util.database.spatial.BoundingShape) -> bool: ...

    def equals(self, __a0: object) -> bool: ...

    def getArea(self) -> float: ...

    def getBounds(self) -> ghidra.util.database.spatial.BoundingShape: ...

    def getCenter(self) -> ghidra.util.database.spatial.rect.Point2D: ...

    def getClass(self) -> java.lang.Class: ...

    def getCreationSnap(self) -> long: ...

    def getDestructionSnap(self) -> long: ...

    def getFlags(self) -> java.util.Set: ...

    def getKey(self) -> long: ...

    def getLength(self) -> long: ...

    def getLifespan(self) -> com.google.common.collect.Range: ...

    def getMargin(self) -> float: ...

    def getMaxAddress(self) -> ghidra.program.model.address.Address: ...

    def getMinAddress(self) -> ghidra.program.model.address.Address: ...

    def getName(self) -> unicode: ...

    def getObjectKey(self) -> ghidra.util.database.ObjectKey: ...

    def getParentKey(self) -> long: ...

    def getPath(self) -> unicode: ...

    def getRange(self) -> ghidra.program.model.address.AddressRange: ...

    def getShape(self) -> ghidra.util.database.spatial.BoundedShape: ...

    def getSpace(self) -> ghidra.util.database.spatial.rect.EuclideanSpace2D: ...

    def getTrace(self) -> ghidra.trace.model.Trace: ...

    def getX1(self) -> object: ...

    def getX2(self) -> object: ...

    def getY1(self) -> object: ...

    def getY2(self) -> object: ...

    def hashCode(self) -> int: ...

    @overload
    def immutable(self, __a0: ghidra.program.model.address.Address, __a1: ghidra.program.model.address.Address, __a2: long, __a3: long) -> ghidra.trace.model.TraceAddressSnapRange: ...

    @overload
    def immutable(self, __a0: object, __a1: object, __a2: object, __a3: object) -> ghidra.util.database.spatial.rect.Rectangle2D: ...

    def intersection(self, __a0: ghidra.util.database.spatial.rect.Rectangle2D) -> ghidra.util.database.spatial.rect.Rectangle2D: ...

    def intersects(self, __a0: ghidra.util.database.spatial.rect.Rectangle2D) -> bool: ...

    @overload
    def isDeleted(self) -> bool: ...

    @overload
    def isDeleted(self, __a0: ghidra.util.Lock) -> bool: ...

    def isExecute(self) -> bool: ...

    def isRead(self) -> bool: ...

    def isVolatile(self) -> bool: ...

    def isWrite(self) -> bool: ...

    def notify(self) -> None: ...

    def notifyAll(self) -> None: ...

    def setCreationSnap(self, __a0: long) -> None: ...

    def setDestructionSnap(self, __a0: long) -> None: ...

    def setExecute(self, __a0: bool) -> None: ...

    @overload
    def setFlags(self, __a0: List[ghidra.trace.model.memory.TraceMemoryFlag]) -> None: ...

    @overload
    def setFlags(self, __a0: java.util.Collection) -> None: ...

    def setInvalid(self) -> None: ...

    def setLength(self, __a0: long) -> None: ...

    def setLifespan(self, __a0: com.google.common.collect.Range) -> None: ...

    def setMaxAddress(self, __a0: ghidra.program.model.address.Address) -> None: ...

    def setMinAddress(self, __a0: ghidra.program.model.address.Address) -> None: ...

    def setName(self, __a0: unicode) -> None: ...

    def setParentKey(self, __a0: long) -> None: ...

    def setRange(self, __a0: ghidra.program.model.address.AddressRange) -> None: ...

    def setRead(self, __a0: bool) -> None: ...

    @overload
    def setShape(self, __a0: ghidra.trace.model.TraceAddressSnapRange) -> None: ...

    @overload
    def setShape(self, __a0: ghidra.util.database.spatial.BoundedShape) -> None: ...

    def setVolatile(self, __a0: bool) -> None: ...

    def setWrite(self, __a0: bool) -> None: ...

    @overload
    def shapeEquals(self, __a0: ghidra.trace.model.TraceAddressSnapRange) -> bool: ...

    @overload
    def shapeEquals(self, __a0: ghidra.util.database.spatial.BoundedShape) -> bool: ...

    def toString(self) -> unicode: ...

    @overload
    def unionBounds(self, __a0: ghidra.util.database.spatial.rect.Rectangle2D) -> ghidra.util.database.spatial.rect.Rectangle2D: ...

    @overload
    def unionBounds(self, __a0: ghidra.util.database.spatial.BoundingShape) -> ghidra.util.database.spatial.BoundingShape: ...

    @overload
    def wait(self) -> None: ...

    @overload
    def wait(self, __a0: long) -> None: ...

    @overload
    def wait(self, __a0: long, __a1: int) -> None: ...

    @property
    def creationSnap(self) -> long: ...

    @creationSnap.setter
    def creationSnap(self, value: long) -> None: ...

    @property
    def destructionSnap(self) -> long: ...

    @destructionSnap.setter
    def destructionSnap(self, value: long) -> None: ...

    @property
    def flags(self) -> java.util.Set: ...

    @property
    def length(self) -> long: ...

    @length.setter
    def length(self, value: long) -> None: ...

    @property
    def lifespan(self) -> com.google.common.collect.Range: ...

    @lifespan.setter
    def lifespan(self, value: com.google.common.collect.Range) -> None: ...

    @property
    def maxAddress(self) -> ghidra.program.model.address.Address: ...

    @maxAddress.setter
    def maxAddress(self, value: ghidra.program.model.address.Address) -> None: ...

    @property
    def minAddress(self) -> ghidra.program.model.address.Address: ...

    @minAddress.setter
    def minAddress(self, value: ghidra.program.model.address.Address) -> None: ...

    @property
    def name(self) -> unicode: ...

    @name.setter
    def name(self, value: unicode) -> None: ...

    @property
    def path(self) -> unicode: ...

    @property
    def range(self) -> ghidra.program.model.address.AddressRange: ...

    @range.setter
    def range(self, value: ghidra.program.model.address.AddressRange) -> None: ...

    @property
    def trace(self) -> ghidra.trace.database.DBTrace: ...