import com.google.common.collect
import ghidra.program.model.address
import ghidra.trace.database.module
import ghidra.trace.database.space
import ghidra.trace.model.modules
import ghidra.trace.model.thread
import java.lang
import java.util


class DBTraceModuleSpace(object, ghidra.trace.model.modules.TraceModuleSpace, ghidra.trace.database.space.DBTraceSpaceBased):




    def __init__(self, __a0: ghidra.trace.database.module.DBTraceModuleManager, __a1: ghidra.program.model.address.AddressSpace): ...



    @overload
    def assertInSpace(self, __a0: ghidra.program.model.address.Address) -> long: ...

    @overload
    def assertInSpace(self, __a0: ghidra.program.model.address.AddressRange) -> None: ...

    @staticmethod
    def create(__a0: ghidra.program.model.address.AddressSpace, __a1: ghidra.trace.model.thread.TraceThread, __a2: int) -> ghidra.trace.database.space.DBTraceSpaceKey: ...

    def doAddSection(self, __a0: ghidra.trace.database.module.DBTraceModule, __a1: unicode, __a2: unicode, __a3: ghidra.program.model.address.AddressRange) -> ghidra.trace.database.module.DBTraceSection: ...

    def doGetModuleById(self, __a0: long) -> ghidra.trace.database.module.DBTraceModule: ...

    def doGetSectionByName(self, __a0: long, __a1: unicode) -> ghidra.trace.database.module.DBTraceSection: ...

    def doGetSectionsByModuleId(self, __a0: long) -> java.util.Collection: ...

    def doGetSectionsByPath(self, __a0: unicode) -> java.util.Collection: ...

    def equals(self, __a0: object) -> bool: ...

    def explainLanguages(self, __a0: ghidra.program.model.address.AddressSpace) -> unicode: ...

    def getAddressSpace(self) -> ghidra.program.model.address.AddressSpace: ...

    def getAllModules(self) -> java.util.Collection: ...

    def getAllSections(self) -> java.util.Collection: ...

    def getClass(self) -> java.lang.Class: ...

    def getFrameLevel(self) -> int: ...

    def getLoadedModules(self, __a0: long) -> java.util.Collection: ...

    def getModulesAt(self, __a0: long, __a1: ghidra.program.model.address.Address) -> java.util.Collection: ...

    def getModulesIntersecting(self, __a0: com.google.common.collect.Range, __a1: ghidra.program.model.address.AddressRange) -> java.util.Collection: ...

    def getSectionsAt(self, __a0: long, __a1: ghidra.program.model.address.Address) -> java.util.Collection: ...

    def getSectionsIntersecting(self, __a0: com.google.common.collect.Range, __a1: ghidra.program.model.address.AddressRange) -> java.util.Collection: ...

    def getThread(self) -> ghidra.trace.model.thread.TraceThread: ...

    def hashCode(self) -> int: ...

    def invalidateCache(self) -> None: ...

    def isMySpace(self, __a0: ghidra.program.model.address.AddressSpace) -> bool: ...

    def notify(self) -> None: ...

    def notifyAll(self) -> None: ...

    def toAddress(self, __a0: long) -> ghidra.program.model.address.Address: ...

    def toOverlay(self, __a0: ghidra.program.model.address.Address) -> ghidra.program.model.address.Address: ...

    def toString(self) -> unicode: ...

    @overload
    def wait(self) -> None: ...

    @overload
    def wait(self, __a0: long) -> None: ...

    @overload
    def wait(self, __a0: long, __a1: int) -> None: ...

    @property
    def addressSpace(self) -> ghidra.program.model.address.AddressSpace: ...

    @property
    def allModules(self) -> java.util.Collection: ...

    @property
    def allSections(self) -> java.util.Collection: ...

    @property
    def frameLevel(self) -> int: ...

    @property
    def thread(self) -> ghidra.trace.database.thread.DBTraceThread: ...