from typing import List
import com.google.common.collect
import ghidra.program.model.address
import ghidra.program.model.lang
import ghidra.program.model.listing
import ghidra.program.model.symbol
import ghidra.trace.database.symbol
import ghidra.trace.model.symbol
import ghidra.trace.model.thread
import java.lang
import java.util


class DBTraceFunctionSymbolView(ghidra.trace.database.symbol.AbstractDBTraceSymbolSingleTypeWithLocationView, ghidra.trace.model.symbol.TraceFunctionSymbolView):




    def __init__(self, __a0: ghidra.trace.database.symbol.DBTraceSymbolManager): ...



    def add(self, __a0: com.google.common.collect.Range, __a1: ghidra.program.model.address.Address, __a2: ghidra.program.model.address.AddressSetView, __a3: unicode, __a4: ghidra.trace.model.symbol.TraceFunctionSymbol, __a5: ghidra.trace.model.symbol.TraceNamespaceSymbol, __a6: ghidra.program.model.symbol.SourceType) -> ghidra.trace.model.symbol.TraceFunctionSymbol: ...

    def create(self, __a0: long, __a1: ghidra.program.model.address.Address, __a2: ghidra.program.model.address.AddressSetView, __a3: unicode, __a4: ghidra.trace.model.symbol.TraceFunctionSymbol, __a5: ghidra.trace.model.symbol.TraceNamespaceSymbol, __a6: ghidra.program.model.symbol.SourceType) -> ghidra.trace.model.symbol.TraceFunctionSymbol: ...

    def equals(self, __a0: object) -> bool: ...

    def getAll(self, __a0: bool) -> java.util.Collection: ...

    def getAt(self, __a0: long, __a1: ghidra.trace.model.thread.TraceThread, __a2: ghidra.program.model.address.Address, __a3: bool) -> java.util.Collection: ...

    def getByKey(self, __a0: long) -> ghidra.trace.database.symbol.AbstractDBTraceSymbol: ...

    def getCallingConvention(self, __a0: unicode) -> ghidra.program.model.lang.PrototypeModel: ...

    @overload
    def getCallingConventionNames(self) -> List[object]: ...

    @overload
    @staticmethod
    def getCallingConventionNames(__a0: ghidra.program.model.lang.CompilerSpec) -> List[object]: ...

    def getCallingConventions(self) -> List[ghidra.program.model.lang.PrototypeModel]: ...

    def getChildWithNameAt(self, __a0: unicode, __a1: long, __a2: ghidra.trace.model.thread.TraceThread, __a3: ghidra.program.model.address.Address, __a4: ghidra.trace.model.symbol.TraceNamespaceSymbol) -> ghidra.trace.database.symbol.AbstractDBTraceSymbol: ...

    def getChildren(self, __a0: ghidra.trace.model.symbol.TraceNamespaceSymbol) -> java.util.Collection: ...

    def getChildrenNamed(self, __a0: unicode, __a1: ghidra.trace.model.symbol.TraceNamespaceSymbol) -> java.util.Collection: ...

    def getClass(self) -> java.lang.Class: ...

    def getDefaultCallingConvention(self) -> ghidra.program.model.lang.PrototypeModel: ...

    def getGlobalWithNameAt(self, __a0: unicode, __a1: long, __a2: ghidra.trace.model.thread.TraceThread, __a3: ghidra.program.model.address.Address) -> ghidra.trace.model.symbol.TraceSymbol: ...

    def getGlobals(self) -> java.util.Collection: ...

    def getGlobalsNamed(self, __a0: unicode) -> java.util.Collection: ...

    @overload
    def getIntersecting(self, __a0: com.google.common.collect.Range, __a1: ghidra.trace.model.thread.TraceThread, __a2: ghidra.program.model.address.AddressRange, __a3: bool) -> java.util.Collection: ...

    @overload
    def getIntersecting(self, __a0: com.google.common.collect.Range, __a1: ghidra.trace.model.thread.TraceThread, __a2: ghidra.program.model.address.AddressRange, __a3: bool, __a4: bool) -> java.util.Collection: ...

    def getManager(self) -> ghidra.trace.database.symbol.DBTraceSymbolManager: ...

    def getNamed(self, __a0: unicode) -> java.util.Collection: ...

    @staticmethod
    def getReferencedVariable(__a0: ghidra.program.model.listing.Function, __a1: ghidra.program.model.address.Address, __a2: ghidra.program.model.address.Address, __a3: int, __a4: bool, __a5: ghidra.program.model.lang.Language) -> ghidra.program.model.listing.Variable: ...

    def getWithMatchingName(self, __a0: unicode, __a1: bool) -> java.util.Collection: ...

    def hasAt(self, __a0: long, __a1: ghidra.trace.model.thread.TraceThread, __a2: ghidra.program.model.address.Address, __a3: bool) -> bool: ...

    def hashCode(self) -> int: ...

    def invalidateCache(self) -> None: ...

    def notify(self) -> None: ...

    def notifyAll(self) -> None: ...

    def size(self, __a0: bool) -> int: ...

    def toString(self) -> unicode: ...

    @overload
    def wait(self) -> None: ...

    @overload
    def wait(self, __a0: long) -> None: ...

    @overload
    def wait(self, __a0: long, __a1: int) -> None: ...

    @property
    def callingConventionNames(self) -> List[object]: ...

    @property
    def callingConventions(self) -> List[ghidra.program.model.lang.PrototypeModel]: ...

    @property
    def defaultCallingConvention(self) -> ghidra.program.model.lang.PrototypeModel: ...

    @property
    def manager(self) -> ghidra.trace.model.symbol.TraceSymbolManager: ...