import com.google.common.collect
import ghidra.dbg.target.schema
import ghidra.dbg.util
import ghidra.trace.database.target
import ghidra.trace.model
import ghidra.trace.model.target
import ghidra.util
import ghidra.util.database
import java.lang
import java.util
import java.util.stream


class DBTraceObject(ghidra.util.database.DBAnnotatedObject, ghidra.trace.model.target.TraceObject):




    def __init__(self, __a0: ghidra.trace.database.target.DBTraceObjectManager, __a1: ghidra.util.database.DBCachedObjectStore, __a2: db.DBRecord): ...



    def delete(self) -> None: ...

    def equals(self, __a0: object) -> bool: ...

    def getAllPaths(self, __a0: com.google.common.collect.Range) -> java.util.stream.Stream: ...

    def getAncestors(self, __a0: com.google.common.collect.Range, __a1: ghidra.dbg.util.PathPredicates) -> java.util.stream.Stream: ...

    def getAncestorsRoot(self, __a0: com.google.common.collect.Range, __a1: ghidra.dbg.util.PathPredicates) -> java.util.stream.Stream: ...

    def getAttribute(self, __a0: long, __a1: unicode) -> ghidra.trace.model.target.TraceObjectValue: ...

    def getAttributes(self) -> java.util.Collection: ...

    def getCanonicalParent(self, __a0: long) -> ghidra.trace.model.target.TraceObjectValue: ...

    def getCanonicalParents(self, __a0: com.google.common.collect.Range) -> java.util.stream.Stream: ...

    def getCanonicalPath(self) -> ghidra.trace.model.target.TraceObjectKeyPath: ...

    def getCanonicalSuccessors(self, __a0: ghidra.dbg.util.PathPredicates) -> java.util.stream.Stream: ...

    def getClass(self) -> java.lang.Class: ...

    @overload
    def getElement(self, __a0: long, __a1: long) -> ghidra.trace.database.target.InternalTraceObjectValue: ...

    @overload
    def getElement(self, __a0: long, __a1: unicode) -> ghidra.trace.database.target.InternalTraceObjectValue: ...

    def getElements(self) -> java.util.Collection: ...

    def getInterfaces(self) -> java.util.Collection: ...

    def getKey(self) -> long: ...

    def getLife(self) -> com.google.common.collect.RangeSet: ...

    def getManager(self) -> ghidra.trace.database.target.DBTraceObjectManager: ...

    def getObjectKey(self) -> ghidra.util.database.ObjectKey: ...

    def getOrderedSuccessors(self, __a0: com.google.common.collect.Range, __a1: ghidra.trace.model.target.TraceObjectKeyPath, __a2: bool) -> java.util.stream.Stream: ...

    def getOrderedValues(self, __a0: com.google.common.collect.Range, __a1: unicode, __a2: bool) -> java.util.stream.Stream: ...

    def getParents(self) -> java.util.Collection: ...

    def getRoot(self) -> ghidra.trace.model.target.TraceObject: ...

    def getSuccessors(self, __a0: com.google.common.collect.Range, __a1: ghidra.dbg.util.PathPredicates) -> java.util.stream.Stream: ...

    def getTargetSchema(self) -> ghidra.dbg.target.schema.TargetObjectSchema: ...

    def getTrace(self) -> ghidra.trace.model.Trace: ...

    def getValue(self, __a0: long, __a1: unicode) -> ghidra.trace.model.target.TraceObjectValue: ...

    @overload
    def getValues(self) -> java.util.Collection: ...

    @overload
    def getValues(self, __a0: com.google.common.collect.Range, __a1: unicode) -> java.util.Collection: ...

    def hashCode(self) -> int: ...

    def insert(self, __a0: com.google.common.collect.Range, __a1: ghidra.trace.model.target.TraceObject.ConflictResolution) -> ghidra.trace.model.target.TraceObjectValPath: ...

    @overload
    def isDeleted(self) -> bool: ...

    @overload
    def isDeleted(self, __a0: ghidra.util.Lock) -> bool: ...

    def isMethod(self, __a0: long) -> bool: ...

    def isRoot(self) -> bool: ...

    def notify(self) -> None: ...

    def notifyAll(self) -> None: ...

    def queryAncestorsInterface(self, __a0: com.google.common.collect.Range, __a1: java.lang.Class) -> java.util.stream.Stream: ...

    def queryAncestorsTargetInterface(self, __a0: com.google.common.collect.Range, __a1: java.lang.Class) -> java.util.stream.Stream: ...

    def queryCanonicalAncestorsInterface(self, __a0: java.lang.Class) -> java.util.stream.Stream: ...

    def queryCanonicalAncestorsTargetInterface(self, __a0: java.lang.Class) -> java.util.stream.Stream: ...

    def queryInterface(self, __a0: java.lang.Class) -> ghidra.trace.model.target.TraceObjectInterface: ...

    def queryRegisterContainer(self, __a0: int) -> ghidra.trace.model.target.TraceObject: ...

    def querySuccessorsInterface(self, __a0: com.google.common.collect.Range, __a1: java.lang.Class) -> java.util.stream.Stream: ...

    def querySuccessorsTargetInterface(self, __a0: com.google.common.collect.Range, __a1: java.lang.Class) -> java.util.stream.Stream: ...

    def querySuitableTargetInterface(self, __a0: java.lang.Class) -> ghidra.trace.model.target.TraceObject: ...

    def remove(self, __a0: com.google.common.collect.Range) -> None: ...

    def removeTree(self, __a0: com.google.common.collect.Range) -> None: ...

    def setAttribute(self, __a0: com.google.common.collect.Range, __a1: unicode, __a2: object) -> ghidra.trace.model.target.TraceObjectValue: ...

    @overload
    def setElement(self, __a0: com.google.common.collect.Range, __a1: long, __a2: object) -> ghidra.trace.model.target.TraceObjectValue: ...

    @overload
    def setElement(self, __a0: com.google.common.collect.Range, __a1: unicode, __a2: object) -> ghidra.trace.model.target.TraceObjectValue: ...

    def setInvalid(self) -> None: ...

    @overload
    def setValue(self, __a0: com.google.common.collect.Range, __a1: unicode, __a2: object) -> ghidra.trace.model.target.TraceObjectValue: ...

    @overload
    def setValue(self, __a0: com.google.common.collect.Range, __a1: unicode, __a2: object, __a3: ghidra.trace.model.target.TraceObject.ConflictResolution) -> ghidra.trace.database.target.InternalTraceObjectValue: ...

    def toString(self) -> unicode: ...

    @overload
    def wait(self) -> None: ...

    @overload
    def wait(self, __a0: long) -> None: ...

    @overload
    def wait(self, __a0: long, __a1: int) -> None: ...

    @property
    def attributes(self) -> java.util.Collection: ...

    @property
    def canonicalPath(self) -> ghidra.trace.model.target.TraceObjectKeyPath: ...

    @property
    def elements(self) -> java.util.Collection: ...

    @property
    def interfaces(self) -> java.util.Collection: ...

    @property
    def life(self) -> com.google.common.collect.RangeSet: ...

    @property
    def manager(self) -> ghidra.trace.database.target.DBTraceObjectManager: ...

    @property
    def parents(self) -> java.util.Collection: ...

    @property
    def root(self) -> bool: ...

    @property
    def targetSchema(self) -> ghidra.dbg.target.schema.TargetObjectSchema: ...

    @property
    def trace(self) -> ghidra.trace.database.DBTrace: ...

    @property
    def values(self) -> java.util.Collection: ...