from typing import List
import com.google.common.collect
import db
import ghidra.dbg.target.schema
import ghidra.dbg.util
import ghidra.program.model.address
import ghidra.trace.database
import ghidra.trace.database.module
import ghidra.trace.database.target
import ghidra.trace.model
import ghidra.trace.model.breakpoint
import ghidra.trace.model.memory
import ghidra.trace.model.modules
import ghidra.trace.model.stack
import ghidra.trace.model.target
import ghidra.trace.model.thread
import ghidra.util.database
import java.io
import java.lang
import java.util
import java.util.function
import java.util.stream


class DBTraceObjectManager(object, ghidra.trace.model.target.TraceObjectManager, ghidra.trace.database.DBTraceManager):





    class DBTraceObjectSchemaDBFieldCodec(ghidra.util.database.DBCachedObjectStoreFactory.AbstractDBFieldCodec):




        def __init__(self, __a0: java.lang.Class, __a1: java.lang.reflect.Field, __a2: int): ...



        def encodeField(self, __a0: object) -> db.Field: ...

        def equals(self, __a0: object) -> bool: ...

        def getClass(self) -> java.lang.Class: ...

        def getFieldType(self) -> java.lang.Class: ...

        def getObjectType(self) -> java.lang.Class: ...

        def getValue(self, __a0: ghidra.util.database.DBAnnotatedObject) -> object: ...

        def getValueType(self) -> java.lang.Class: ...

        def hashCode(self) -> int: ...

        def load(self, __a0: ghidra.util.database.DBAnnotatedObject, __a1: db.DBRecord) -> None: ...

        def notify(self) -> None: ...

        def notifyAll(self) -> None: ...

        @overload
        def store(self, __a0: ghidra.dbg.target.schema.SchemaContext, __a1: db.StringField) -> None: ...

        @overload
        def store(self, __a0: ghidra.util.database.DBAnnotatedObject, __a1: db.DBRecord) -> None: ...

        @overload
        def store(self, __a0: object, __a1: db.Field) -> None: ...

        def toString(self) -> unicode: ...

        @overload
        def wait(self) -> None: ...

        @overload
        def wait(self, __a0: long) -> None: ...

        @overload
        def wait(self, __a0: long, __a1: int) -> None: ...



    def __init__(self, __a0: db.DBHandle, __a1: ghidra.util.database.DBOpenMode, __a2: java.util.concurrent.locks.ReadWriteLock, __a3: ghidra.util.task.TaskMonitor, __a4: ghidra.program.model.lang.Language, __a5: ghidra.trace.database.DBTrace): ...



    def addBreakpoint(self, __a0: unicode, __a1: com.google.common.collect.Range, __a2: ghidra.program.model.address.AddressRange, __a3: java.util.Collection, __a4: java.util.Collection, __a5: bool, __a6: unicode) -> ghidra.trace.model.breakpoint.TraceObjectBreakpointLocation: ...

    def addMemoryRegion(self, __a0: unicode, __a1: com.google.common.collect.Range, __a2: ghidra.program.model.address.AddressRange, __a3: java.util.Collection) -> ghidra.trace.model.memory.TraceObjectMemoryRegion: ...

    def addModule(self, __a0: unicode, __a1: unicode, __a2: com.google.common.collect.Range, __a3: ghidra.program.model.address.AddressRange) -> ghidra.trace.model.modules.TraceObjectModule: ...

    def addSection(self, __a0: unicode, __a1: unicode, __a2: com.google.common.collect.Range, __a3: ghidra.program.model.address.AddressRange) -> ghidra.trace.database.module.TraceObjectSection: ...

    def addStack(self, __a0: List[object], __a1: long) -> ghidra.trace.model.stack.TraceObjectStack: ...

    def addStackFrame(self, __a0: List[object], __a1: long) -> ghidra.trace.model.stack.TraceObjectStackFrame: ...

    def addThread(self, __a0: unicode, __a1: unicode, __a2: com.google.common.collect.Range) -> ghidra.trace.model.thread.TraceObjectThread: ...

    def assertMyThread(self, __a0: ghidra.trace.model.thread.TraceThread) -> ghidra.trace.model.thread.TraceThread: ...

    def checkMyObject(self, __a0: ghidra.trace.database.target.DBTraceObject) -> bool: ...

    def clear(self) -> None: ...

    def createObject(self, __a0: ghidra.trace.model.target.TraceObjectKeyPath) -> ghidra.trace.model.target.TraceObject: ...

    def createRootObject(self, __a0: ghidra.dbg.target.schema.TargetObjectSchema) -> ghidra.trace.model.target.TraceObjectValue: ...

    def cullDisconnectedObjects(self) -> None: ...

    def dbError(self, __a0: java.io.IOException) -> None: ...

    def equals(self, __a0: object) -> bool: ...

    @overload
    def getAllObjects(self) -> java.util.Collection: ...

    @overload
    def getAllObjects(self, __a0: java.lang.Class) -> java.util.Collection: ...

    def getAllValues(self) -> java.util.Collection: ...

    def getClass(self) -> java.lang.Class: ...

    def getLatestSuccessor(self, __a0: ghidra.trace.model.target.TraceObject, __a1: ghidra.trace.model.target.TraceObjectKeyPath, __a2: long, __a3: java.lang.Class) -> ghidra.trace.model.target.TraceObjectInterface: ...

    def getObjectByCanonicalPath(self, __a0: ghidra.trace.model.target.TraceObjectKeyPath) -> ghidra.trace.database.target.DBTraceObject: ...

    def getObjectById(self, __a0: long) -> ghidra.trace.database.target.DBTraceObject: ...

    def getObjectByPath(self, __a0: long, __a1: unicode, __a2: java.lang.Class) -> ghidra.trace.model.target.TraceObjectInterface: ...

    def getObjectContaining(self, __a0: long, __a1: ghidra.program.model.address.Address, __a2: unicode, __a3: java.lang.Class) -> ghidra.trace.model.target.TraceObjectInterface: ...

    def getObjectsAddressSet(self, __a0: long, __a1: unicode, __a2: java.lang.Class, __a3: java.util.function.Predicate) -> ghidra.program.model.address.AddressSetView: ...

    def getObjectsAtSnap(self, __a0: long, __a1: java.lang.Class) -> java.util.Collection: ...

    @overload
    def getObjectsByPath(self, __a0: unicode, __a1: java.lang.Class) -> java.util.Collection: ...

    @overload
    def getObjectsByPath(self, __a0: com.google.common.collect.Range, __a1: ghidra.trace.model.target.TraceObjectKeyPath) -> java.util.stream.Stream: ...

    def getObjectsContaining(self, __a0: long, __a1: ghidra.program.model.address.Address, __a2: unicode, __a3: java.lang.Class) -> java.util.Collection: ...

    def getObjectsIntersecting(self, __a0: com.google.common.collect.Range, __a1: ghidra.program.model.address.AddressRange, __a2: unicode, __a3: java.lang.Class) -> java.util.Collection: ...

    def getRootObject(self) -> ghidra.trace.model.target.TraceObject: ...

    def getRootSchema(self) -> ghidra.dbg.target.schema.TargetObjectSchema: ...

    def getSuccessor(self, __a0: ghidra.trace.model.target.TraceObject, __a1: ghidra.dbg.util.PathPredicates, __a2: long, __a3: java.lang.Class) -> ghidra.trace.model.target.TraceObjectInterface: ...

    def getTrace(self) -> ghidra.trace.model.Trace: ...

    def getValuePaths(self, __a0: com.google.common.collect.Range, __a1: ghidra.dbg.util.PathPredicates) -> java.util.stream.Stream: ...

    def getValuesAt(self, __a0: long, __a1: ghidra.program.model.address.Address) -> java.util.Collection: ...

    def getValuesIntersecting(self, __a0: com.google.common.collect.Range, __a1: ghidra.program.model.address.AddressRange) -> java.util.Collection: ...

    def hasSchema(self) -> bool: ...

    def hashCode(self) -> int: ...

    def invalidateCache(self, __a0: bool) -> None: ...

    def notify(self) -> None: ...

    def notifyAll(self) -> None: ...

    def queryAllInterface(self, __a0: com.google.common.collect.Range, __a1: java.lang.Class) -> java.util.stream.Stream: ...

    def toString(self) -> unicode: ...

    @overload
    def wait(self) -> None: ...

    @overload
    def wait(self, __a0: long) -> None: ...

    @overload
    def wait(self, __a0: long, __a1: int) -> None: ...

    @property
    def allObjects(self) -> java.util.Collection: ...

    @property
    def allValues(self) -> java.util.Collection: ...

    @property
    def rootObject(self) -> ghidra.trace.database.target.DBTraceObject: ...

    @property
    def rootSchema(self) -> ghidra.dbg.target.schema.TargetObjectSchema: ...

    @property
    def trace(self) -> ghidra.trace.model.Trace: ...