from typing import List
import com.google.common.collect
import ghidra.trace.database.target
import ghidra.trace.model
import ghidra.trace.model.target
import ghidra.trace.model.thread
import ghidra.trace.util
import ghidra.util.database
import java.lang


class DBTraceObjectThread(object, ghidra.trace.model.thread.TraceObjectThread, ghidra.trace.database.target.DBTraceObjectInterface):
    KEY_COMMENT: unicode = u'_comment'



    def __init__(self, __a0: ghidra.trace.database.target.DBTraceObject): ...



    def computeMaxSnap(self) -> long: ...

    def computeMinSnap(self) -> long: ...

    def computeSpan(self) -> com.google.common.collect.Range: ...

    def delete(self) -> None: ...

    def equals(self, __a0: object) -> bool: ...

    def getClass(self) -> java.lang.Class: ...

    def getComment(self) -> unicode: ...

    def getCreationSnap(self) -> long: ...

    def getDestructionSnap(self) -> long: ...

    def getKey(self) -> long: ...

    def getLifespan(self) -> com.google.common.collect.Range: ...

    def getName(self) -> unicode: ...

    def getObject(self) -> ghidra.trace.model.target.TraceObject: ...

    def getObjectKey(self) -> ghidra.util.database.ObjectKey: ...

    def getPath(self) -> unicode: ...

    def getRegisters(self) -> List[object]: ...

    def getTrace(self) -> ghidra.trace.model.Trace: ...

    def hashCode(self) -> int: ...

    def isAlive(self) -> bool: ...

    def isDeleted(self) -> bool: ...

    def notify(self) -> None: ...

    def notifyAll(self) -> None: ...

    def setComment(self, __a0: unicode) -> None: ...

    def setCreationSnap(self, __a0: long) -> None: ...

    def setDestructionSnap(self, __a0: long) -> None: ...

    def setLifespan(self, __a0: com.google.common.collect.Range) -> None: ...

    @overload
    def setName(self, __a0: unicode) -> None: ...

    @overload
    def setName(self, __a0: com.google.common.collect.Range, __a1: unicode) -> None: ...

    def spaceForValue(self, __a0: long, __a1: unicode) -> ghidra.trace.util.TraceAddressSpace: ...

    def toString(self) -> unicode: ...

    def translateEvent(self, __a0: ghidra.trace.util.TraceChangeRecord) -> ghidra.trace.util.TraceChangeRecord: ...

    @overload
    def wait(self) -> None: ...

    @overload
    def wait(self, __a0: long) -> None: ...

    @overload
    def wait(self, __a0: long, __a1: int) -> None: ...

    @property
    def alive(self) -> bool: ...

    @property
    def comment(self) -> unicode: ...

    @comment.setter
    def comment(self, value: unicode) -> None: ...

    @property
    def creationSnap(self) -> long: ...

    @creationSnap.setter
    def creationSnap(self, value: long) -> None: ...

    @property
    def deleted(self) -> bool: ...

    @property
    def destructionSnap(self) -> long: ...

    @destructionSnap.setter
    def destructionSnap(self, value: long) -> None: ...

    @property
    def key(self) -> long: ...

    @property
    def lifespan(self) -> com.google.common.collect.Range: ...

    @lifespan.setter
    def lifespan(self, value: com.google.common.collect.Range) -> None: ...

    @property
    def name(self) -> unicode: ...

    @name.setter
    def name(self, value: unicode) -> None: ...

    @property
    def object(self) -> ghidra.trace.database.target.DBTraceObject: ...

    @property
    def objectKey(self) -> ghidra.util.database.ObjectKey: ...

    @property
    def path(self) -> unicode: ...

    @property
    def registers(self) -> List[object]: ...

    @property
    def trace(self) -> ghidra.trace.model.Trace: ...