import com.google.common.collect
import ghidra.program.model.address
import ghidra.program.model.lang
import ghidra.trace.model
import ghidra.trace.model.guest
import ghidra.trace.model.listing
import ghidra.util.task
import java.lang


class TraceBaseDefinedUnitsView(ghidra.trace.model.listing.TraceBaseCodeUnitsView, object):








    @overload
    def clear(self, __a0: com.google.common.collect.Range, __a1: ghidra.program.model.lang.Register, __a2: ghidra.util.task.TaskMonitor) -> None: ...

    @overload
    def clear(self, __a0: com.google.common.collect.Range, __a1: ghidra.program.model.address.AddressRange, __a2: bool, __a3: ghidra.util.task.TaskMonitor) -> None: ...

    @overload
    def clear(self, __a0: ghidra.trace.model.guest.TracePlatform, __a1: com.google.common.collect.Range, __a2: ghidra.program.model.lang.Register, __a3: ghidra.util.task.TaskMonitor) -> None: ...

    def containsAddress(self, __a0: long, __a1: ghidra.program.model.address.Address) -> bool: ...

    @overload
    def coversRange(self, __a0: ghidra.trace.model.TraceAddressSnapRange) -> bool: ...

    @overload
    def coversRange(self, __a0: com.google.common.collect.Range, __a1: ghidra.program.model.address.AddressRange) -> bool: ...

    def equals(self, __a0: object) -> bool: ...

    @overload
    def get(self, __a0: long, __a1: bool) -> java.lang.Iterable: ...

    @overload
    def get(self, __a0: long, __a1: ghidra.program.model.address.Address, __a2: bool) -> java.lang.Iterable: ...

    @overload
    def get(self, __a0: long, __a1: ghidra.program.model.address.AddressRange, __a2: bool) -> java.lang.Iterable: ...

    @overload
    def get(self, __a0: long, __a1: ghidra.program.model.address.AddressSetView, __a2: bool) -> java.lang.Iterable: ...

    @overload
    def get(self, __a0: long, __a1: ghidra.program.model.lang.Register, __a2: bool) -> java.lang.Iterable: ...

    @overload
    def get(self, __a0: long, __a1: ghidra.program.model.address.Address, __a2: ghidra.program.model.address.Address, __a3: bool) -> java.lang.Iterable: ...

    @overload
    def getAddressSetView(self, __a0: long) -> ghidra.program.model.address.AddressSetView: ...

    @overload
    def getAddressSetView(self, __a0: long, __a1: ghidra.program.model.address.AddressRange) -> ghidra.program.model.address.AddressSetView: ...

    def getAfter(self, __a0: long, __a1: ghidra.program.model.address.Address) -> ghidra.trace.model.listing.TraceCodeUnit: ...

    def getAt(self, __a0: long, __a1: ghidra.program.model.address.Address) -> ghidra.trace.model.listing.TraceCodeUnit: ...

    def getBefore(self, __a0: long, __a1: ghidra.program.model.address.Address) -> ghidra.trace.model.listing.TraceCodeUnit: ...

    def getCeiling(self, __a0: long, __a1: ghidra.program.model.address.Address) -> ghidra.trace.model.listing.TraceCodeUnit: ...

    def getClass(self) -> java.lang.Class: ...

    @overload
    def getContaining(self, __a0: long, __a1: ghidra.program.model.address.Address) -> ghidra.trace.model.listing.TraceCodeUnit: ...

    @overload
    def getContaining(self, __a0: long, __a1: ghidra.program.model.lang.Register) -> ghidra.trace.model.listing.TraceCodeUnit: ...

    @overload
    def getContaining(self, __a0: ghidra.trace.model.guest.TracePlatform, __a1: long, __a2: ghidra.program.model.lang.Register) -> ghidra.trace.model.listing.TraceCodeUnit: ...

    def getFloor(self, __a0: long, __a1: ghidra.program.model.address.Address) -> ghidra.trace.model.listing.TraceCodeUnit: ...

    @overload
    def getForRegister(self, __a0: long, __a1: ghidra.program.model.lang.Register) -> ghidra.trace.model.listing.TraceCodeUnit: ...

    @overload
    def getForRegister(self, __a0: ghidra.trace.model.guest.TracePlatform, __a1: long, __a2: ghidra.program.model.lang.Register) -> ghidra.trace.model.listing.TraceCodeUnit: ...

    def getIntersecting(self, __a0: ghidra.trace.model.TraceAddressSnapRange) -> java.lang.Iterable: ...

    def getTrace(self) -> ghidra.trace.model.Trace: ...

    def hashCode(self) -> int: ...

    @overload
    def intersectsRange(self, __a0: ghidra.trace.model.TraceAddressSnapRange) -> bool: ...

    @overload
    def intersectsRange(self, __a0: com.google.common.collect.Range, __a1: ghidra.program.model.address.AddressRange) -> bool: ...

    def notify(self) -> None: ...

    def notifyAll(self) -> None: ...

    def size(self) -> int: ...

    def toString(self) -> unicode: ...

    @overload
    def wait(self) -> None: ...

    @overload
    def wait(self, __a0: long) -> None: ...

    @overload
    def wait(self, __a0: long, __a1: int) -> None: ...

    @property
    def trace(self) -> ghidra.trace.model.Trace: ...