from typing import List
import ghidra.util
import java.lang


class ObjectStorageStreamAdapter(object, ghidra.util.ObjectStorage):
    """
    Implementation for ObjectStorage to save and restore Strings and
     Java primitives using an ObjectOutputStream and ObjectInputStream,
     respectively.
    """





    @overload
    def __init__(self, in_: java.io.ObjectInputStream):
        """
        Constructor for new ObjectStorageStreamAdapter
        @param in input stream to read from
        """
        ...

    @overload
    def __init__(self, out: java.io.ObjectOutputStream):
        """
        Constructor for ObjectStorageStreamAdapter.
        @param out output stream to write to
        """
        ...



    def equals(self, __a0: object) -> bool: ...

    def getBoolean(self) -> bool: ...

    def getByte(self) -> int: ...

    def getBytes(self) -> List[int]: ...

    def getClass(self) -> java.lang.Class: ...

    def getDouble(self) -> float: ...

    def getDoubles(self) -> List[float]: ...

    def getFloat(self) -> float: ...

    def getFloats(self) -> List[float]: ...

    def getInt(self) -> int: ...

    def getInts(self) -> List[int]: ...

    def getLong(self) -> long: ...

    def getLongs(self) -> List[long]: ...

    def getShort(self) -> int: ...

    def getShorts(self) -> List[int]: ...

    def getString(self) -> unicode: ...

    def getStrings(self) -> List[unicode]: ...

    def hashCode(self) -> int: ...

    def notify(self) -> None: ...

    def notifyAll(self) -> None: ...

    def putBoolean(self, value: bool) -> None: ...

    def putByte(self, value: int) -> None: ...

    def putBytes(self, value: List[int]) -> None: ...

    def putDouble(self, value: float) -> None: ...

    def putDoubles(self, value: List[float]) -> None: ...

    def putFloat(self, value: float) -> None: ...

    def putFloats(self, value: List[float]) -> None: ...

    def putInt(self, value: int) -> None: ...

    def putInts(self, value: List[int]) -> None: ...

    def putLong(self, value: long) -> None: ...

    def putLongs(self, value: List[long]) -> None: ...

    def putShort(self, value: int) -> None: ...

    def putShorts(self, value: List[int]) -> None: ...

    def putString(self, value: unicode) -> None: ...

    def putStrings(self, value: List[unicode]) -> None: ...

    def toString(self) -> unicode: ...

    @overload
    def wait(self) -> None: ...

    @overload
    def wait(self, __a0: long) -> None: ...

    @overload
    def wait(self, __a0: long, __a1: int) -> None: ...

    @property
    def boolean(self) -> bool: ...

    @property
    def byte(self) -> int: ...

    @property
    def bytes(self) -> List[int]: ...

    @property
    def double(self) -> float: ...

    @property
    def doubles(self) -> List[float]: ...

    @property
    def float(self) -> float: ...

    @property
    def floats(self) -> List[float]: ...

    @property
    def int(self) -> int: ...

    @property
    def ints(self) -> List[int]: ...

    @property
    def long(self) -> long: ...

    @property
    def longs(self) -> List[long]: ...

    @property
    def short(self) -> int: ...

    @property
    def shorts(self) -> List[int]: ...

    @property
    def string(self) -> unicode: ...

    @property
    def strings(self) -> List[unicode]: ...