from typing import Iterator
import ghidra.util.datastruct
import java.lang
import java.util
import java.util.function
import java.util.stream


class FilteringAccumulatorWrapper(object, ghidra.util.datastruct.Accumulator):
    """
    A class that allows clients to wrap a given accumulator, only adding elements that pass the
     given filter.
    """





    def __init__(self, accumulator: ghidra.util.datastruct.Accumulator, passesFilterPredicate: java.util.function.Predicate):
        """
        Constructor.
        @param accumulator the accumulator to pass items to
        @param passesFilterPredicate the predicate that will return true for items that should be
                allowed to pass
        """
        ...

    def __iter__(self): ...

    def add(self, t: object) -> None: ...

    def addAll(self, collection: java.util.Collection) -> None: ...

    def contains(self, t: object) -> bool: ...

    def equals(self, __a0: object) -> bool: ...

    def forEach(self, __a0: java.util.function.Consumer) -> None: ...

    def get(self) -> java.util.Collection: ...

    def getClass(self) -> java.lang.Class: ...

    def hashCode(self) -> int: ...

    def isEmpty(self) -> bool: ...

    def iterator(self) -> Iterator[object]: ...

    def notify(self) -> None: ...

    def notifyAll(self) -> None: ...

    def size(self) -> int: ...

    def spliterator(self) -> java.util.Spliterator: ...

    def stream(self) -> java.util.stream.Stream: ...

    def toString(self) -> unicode: ...

    @overload
    def wait(self) -> None: ...

    @overload
    def wait(self, __a0: long) -> None: ...

    @overload
    def wait(self, __a0: long, __a1: int) -> None: ...

    @property
    def empty(self) -> bool: ...